use "$path_s1\\${data_save}_${yk}.dta", clear
capture g temp_folio_efh = folio
g year_efh=yearEFH  //year
sum year_e* fol*
drop year folio*
rename temp_folio_efh folio_efh
keep ing edad sexo zona2 tr_edad educ quintile_h quintile_renta ytot_ind ocup a1 desem a2 actividad sector_ind tr_edad2 ytoth yai yaotp yact year_efh foli*
g constant=1
save "$path_s1\EFH_risk0.dta", replace

// Create EFH with different unemployment and income risk rates for each year-quarter
quietly {
forv yr==2002/2015 {
forv q==1/4 {
use "$path_s1\EFH_risk0.dta", clear
g year = min(2014,`yr')
g quarter = `q'
capture drop layoffs_sect jobfind unemp_sect rr_inc_sect sd_ln_inc_sect ytot_p_h //or rename ytot_ind ori_ytot_ind
drop tr_edad tr_edad2  // Correct age for other periods
g edad_p = max(18, edad + (`yr'-year_efh))
g tr_edad= edad_p 
recode tr_edad 0/14.9=0 15/24.9=1 25/34.9=2 35/44.9=3 45/54.9=4 55/64.9=5 65/.=5 
g tr_edad2 = tr_edad // Tramos de edad 2 - Young, Middle Age, Old
recode tr_edad2 1/2=1 3/4=2 5=3

// Probability of unemployment
layoff_jobfind0 12
if `yr'>2014 {
replace year=`yr'
}
rename unemployed pr_unemployed
g unemployed = desem 
capture drop _merge
income_shock0 12
run "$path_bs_do2\p_income" // Calculates Permanent Income of the Family
drop unemployed  
capture drop _merge
replace year = `yr'
keep if a1==1
drop aux_layoffs-pr_unemp_i ln_ing_tot_ocup-rr_inc2_i sd_ln_inc_w0-sd_ln_inc2_i sd_inc_w0-sd_inc_sect a1 a2 constant actividad 
if `yr'==2002 & `q'==1 {
save "$path_s1\EFH_risk_yq2.dta", replace
}
else {
joinby folio year quarter using "$path_s1\EFH_risk_yq2.dta", unmatched(both) update
capture drop _merge
save "$path_s1\EFH_risk_yq2.dta", replace
}
}
}
}
keep foli* year_efh year quarter layoffs_sect jobfind unemp_sect rr_inc_sect sd_ln_inc_sect ytot_p_h  //id_*  ytot_ind
save "$path_s1\EFH_risk_yq0_${yk}.dta", replace
foreach v of varlist year quarter layoffs_sect jobfind unemp_sect rr_inc_sect sd_ln_inc_sect ytot_p_h { //ytot_ind
rename `v' `v'_v
}
save "$path_s1\EFH_risk_yq2_${yk}.dta", replace
use "$path_s1\EFH_risk_yq0_${yk}.dta", clear
keep if year==year_efh
keep if quarter==4
drop year quarter
save "$path_s1\EFH_risk_yq0_${yk}.dta", replace
