global error_op = 0  // >=1 discount all loans if there is a non-interviewed member, >=2 discount loans from Retail Banks that may be confused with Retail Stores

// Folios EFH 2011 which do not report banking debt in SBIF for years 2011 and 2012
use "$path_s1\EFH_folios_20${yk}_nosbif.dta", clear
joinby FolioNuevo using "$path_s1\\${data_save}_${yk}.dta", unmatched(master) update //year_efh yearEFH 
tab _merge
keep if a1==1
drop _merge
sum folio
capture drop id
egen id = group(folio) //g ing = ln(1+ytoth)
if ${yk}==11 {
drop b8_t-b9p c9_lab-c11 c16-c24ecod c26 c28_hm-d6_m7 p1-p8_2 e60_1-e60e_1cod e61_2-e61ecod e63_1_1-e65_6_t h1_1-i4_t_6 i9-i15_10 j3_1-j12ecod
global tcc = 4 
local tcc = ${tcc}
local tlvar = "f10"
local tlvart = "f10_t"
local tlvar2 = "f11"
local ccvar2 = "f21"
local ccmes "f18_m"
local ccano "f18_a"
local ccmes2 "f18_1_m"
local ccano2 "f18_1_a"
}
if ${yk}==14 {
drop j1- j3t d1- d20_7e h1_1- h5t i1_1- i4_8e_9 i6- i18_6e l1_1- l5t_16 
global tcc = 5
local tcc = ${tcc}
forv d=1/3  {
rename f12_t2d`d' f7_t2d`d' 
rename f12t_t2d`d' f7t_t2d`d' 
replace f7_t2d`d' =max(f7_t2d`d', max(0,f7_t1d`d')+ max(0,f7_t3d`d'))
g f9_t2d`d' = f7_t2d`d' 
}
local tlvar = "f7"
local tlvart = "f7t"
local tlvar2 = "f9"
local ccvar2 = "f24"
local ccmes "f21_mes"
local ccano "f21_ano"
local ccmes2 "f22_mes"
local ccano2 "f22_ano"
}
if ${yk}==17 {
global tcc = 5
local tcc = ${tcc}
forv d=1/3  {
rename f13_t2d`d' f7_t2d`d' 
rename f13t_t2d`d' f7t_t2d`d' 
replace f7_t2d`d' =max(f7_t2d`d', max(0,f7_t1d`d')+ max(0,f7_t3d`d'))
g f9_t2d`d' = f7_t2d`d' 
}
local tlvar = "f7"
local tlvart = "f7t"
local tlvar2 = "f9"
local ccvar2 = "f23"
local ccmes "f20_mes"
local ccano "f20_ano"
local ccmes2 "f21_mes"
local ccano2 "f21_ano"
}
//

// Tenencias de Deuda (Ownership of Debt)
capture g cbco=(cfdcbco>0 & cfdcbco<.)
sum *bco
sum cfdtbco cfdcbco dtbco dcbco
sum cbco //ctbco
g deuda_banco_EFH = 0
replace deuda_banco_EFH = 1 if f1_t1==1 | f1_t2==1 | f1_t${tcc}==1
g deuda_TL_EFH = 0
replace deuda_TL_EFH = 1 if f1_t1==1 | f1_t2==1 
g deuda_tarjeta_EFH = 0
replace deuda_tarjeta_EFH = 1 if f1_t1==1
g deuda_linea_EFH = 0
replace deuda_linea_EFH = 1 if f1_t2==1
g deuda_prestamo_EFH = 0
replace deuda_prestamo_EFH = 1 if f1_t${tcc}==1
tab deuda_prestamo_EFH cbco // same variables   //tab deuda_TL_EFH ctbco
sum deuda_* [fw=${factor_op}]
sum edad ytot*
egen f3_t1 = rowmin(f3_t1d*)   // Count Loans that belong to Interviewed HH member
egen f3_t2 = rowmin(f3_t2d*)
egen f3_t${tcc} = rowmin(f3_t${tcc}d*)
egen f3_Banco = rowmin(f3_t1 f3_t2 f3_t${tcc})
egen f3_TL = rowmin(f3_t1 f3_t2)
replace deuda_banco_EFH = 0 if f3_Banco!=1 & f3_Banco!=.  // Discount if interviewed member does not report any loans
replace deuda_TL_EFH = 0 if f3_TL!=1 & f3_TL!=.
replace deuda_tarjeta_EFH = 0 if f3_t1!=1 & f3_t1!=.
replace deuda_linea_EFH = 0 if f3_t2!=1 & f3_t2!=.
replace deuda_prestamo_EFH = 0 if f3_t${tcc}!=1 & f3_t${tcc}!=.

if ${yk}==11 {  // For other EFH there were no second Ruts
// For People who reported 2nd Rut only discount loans that do not belong to a8 member
foreach t of numlist 1/2 `tcc' { // 1 2 4
forv d=1/3  {
g a8_t`t'_d`d' = (f3_t`t'd`d'==a8)
}
egen a8_t`t' = rowmax(a8_t`t'_*)
}
egen a8_Banco = rowmax(a8_t1 a8_t2 a8_t${tcc})
egen a8_TL = rowmax(a8_t1 a8_t2)
replace deuda_banco_EFH = 0 if a8_Banco!=1 & a8_Banco!=. & second_rut_only==1
replace deuda_TL_EFH = 0 if a8_TL!=1 & a8_TL!=. & second_rut_only==1
replace deuda_tarjeta_EFH = 0 if a8_t1!=1 & a8_t1!=. & second_rut_only==1
replace deuda_linea_EFH = 0 if a8_t2!=1 & a8_t2!=. & second_rut_only==1
replace deuda_prestamo_EFH = 0 if a8_t${tcc}!=1 & a8_t${tcc}!=. & second_rut_only==1
capture drop a8_t* a8_Banco a8_TL
}
//   //    //     //

if ${error_op}>=1 { // Discount if there are any loans reported by non-interviewed member
/*egen f3_t1_vs2 = rowmax(f3_t1d*) //  /**/
egen f3_t2_vs2 = rowmax(f3_t2d*)
egen f3_t${tcc}_vs2 = rowmax(f3_t${tcc}d*)
egen f3_Banco_vs2 = rowmax(f3_t1_vs2 f3_t2_vs2 f3_t${tcc}_vs2)
egen f3_TL_vs2 = rowmax(f3_t1_vs2 f3_t2_vs2)   //  /**/
replace deuda_banco_EFH = 0 if f3_Banco_vs2!=1 & f3_Banco_vs2!=.   //  
replace deuda_TL_EFH = 0 if f3_TL_vs2!=1 & f3_TL_vs2!=.
replace deuda_tarjeta_EFH = 0 if f3_t1_vs2!=1 & f3_t1_vs2!=.
replace deuda_linea_EFH = 0 if f3_t2_vs2!=1 & f3_t2_vs2!=.
replace deuda_prestamo_EFH = 0 if f3_t${tcc}_vs2!=1 & f3_t${tcc}_vs2!=.   // 
*/
}
sum deuda_* [fw=${factor_op}]
tab f4_t1d1
tab f4_t2d1
tab f4_t${tcc}d1
foreach tk of numlist 1 2 `tcc' { // 1 2 4
forval dk = 1/3 {
g retailbank_t`tk'd`dk' = (f4_t`tk'd`dk'==15 | f4_t`tk'd`dk'==16 | f4_t`tk'd`dk'==18) if f4_t`tk'd`dk'<.
replace retailbank_t`tk'd`dk' = 1 if f3_t`tk'd`dk'>1
}
egen retailbank_t`tk' = rowmin(retailbank_t`tk'd*)
egen retailbank2_t`tk' = rowmax(retailbank_t`tk'd*)  //  /**/
drop retailbank_t`tk'd*
}
egen retailbank = rowmin(retailbank_t*)
egen retailbank2 = rowmax(retailbank_t*)  //  /**/
replace deuda_banco_EFH = 0 if retailbank==1
replace deuda_TL_EFH = 0 if retailbank_t1==1 & retailbank_t2==1
replace deuda_tarjeta_EFH = 0 if retailbank_t1==1
replace deuda_linea_EFH = 0 if retailbank_t2==1
replace deuda_prestamo_EFH = 0 if retailbank_t${tcc}==1
if ${error_op}>=2 { 
replace deuda_banco_EFH = 0 if retailbank2==1    //  /**/
replace deuda_TL_EFH = 0 if retailbank2_t1==1 & retailbank2_t2==1
replace deuda_tarjeta_EFH = 0 if retailbank2_t1==1
replace deuda_linea_EFH = 0 if retailbank2_t2==1
replace deuda_prestamo_EFH = 0 if retailbank2_t${tcc}==1   //  /**/
}
sum deuda_banco_EFH deuda_TL_EFH deuda_tarjeta_EFH deuda_linea_EFH deuda_prestamo_EFH [fw=${factor_op}]

// Loan Amounts and Financial Charge
*sum f10_t1* f10_t2* f10_t_t1* f10_t_t2* f11_t1* f11_t2*
quietly  {
foreach tk of numlist 1 2 {  // 1 2 before 2014, but for 2014 it is only type 1
forval dk = 1/3 {
replace `tlvar'_t`tk'd`dk' = . if `tlvar'_t`tk'd`dk'>=98 & `tlvar'_t`tk'd`dk'<=99 // previous f10 is now f7
replace `tlvar2'_t`tk'd`dk' = . if `tlvar2'_t`tk'd`dk'>=98 & `tlvar2'_t`tk'd`dk'<=99  // previous f11 is now f9
replace `tlvar'_t`tk'd`dk' = . if `tlvar'_t`tk'd`dk'>=-2 & `tlvar'_t`tk'd`dk'<=-1 // previous f10 is now f7
replace `tlvar2'_t`tk'd`dk' = . if `tlvar2'_t`tk'd`dk'>=-2 & `tlvar2'_t`tk'd`dk'<=-1  // previous f11 is now f9

replace `tlvar'_t`tk'd`dk' = . if f3_t`tk'd`dk'>1
replace `tlvar2'_t`tk'd`dk' = . if f3_t`tk'd`dk'>1

replace `tlvar'_t`tk'd`dk' = 25000 if `tlvart'_t`tk'd`dk'==1
replace `tlvar'_t`tk'd`dk' = 85000 if `tlvart'_t`tk'd`dk'==2
replace `tlvar'_t`tk'd`dk' = 185000 if `tlvart'_t`tk'd`dk'==3
replace `tlvar'_t`tk'd`dk' = 375000 if `tlvart'_t`tk'd`dk'==4
replace `tlvar'_t`tk'd`dk' = 750000 if `tlvart'_t`tk'd`dk'==5
replace `tlvar'_t`tk'd`dk' = 1500000 if `tlvart'_t`tk'd`dk'==6 
if ${yk}==11 {  // after 7 there are different values in 2011 and 2014
replace `tlvar'_t`tk'd`dk' = 3000000 if `tlvart'_t`tk'd`dk'==7 
replace `tlvar'_t`tk'd`dk' = 6000000 if `tlvart'_t`tk'd`dk'==8
}
if ${yk}>11 {
replace `tlvar'_t`tk'd`dk' = 2750000 if `tlvart'_t`tk'd`dk'==7 
replace `tlvar'_t`tk'd`dk' = 4250000 if `tlvart'_t`tk'd`dk'==8 
replace `tlvar'_t`tk'd`dk' = 6250000 if `tlvart'_t`tk'd`dk'==9 
replace `tlvar'_t`tk'd`dk' = 8750000 if `tlvart'_t`tk'd`dk'==10
replace `tlvar'_t`tk'd`dk' = 12500000 if `tlvart'_t`tk'd`dk'==11
replace `tlvar'_t`tk'd`dk' = 17500000 if `tlvart'_t`tk'd`dk'==12
replace `tlvar'_t`tk'd`dk' = 25000000 if `tlvart'_t`tk'd`dk'==13
replace `tlvar'_t`tk'd`dk' = 30000000 if `tlvart'_t`tk'd`dk'==14
}
//
}
}
}
egen deuda_m_tarjeta_EFH = rowtotal(`tlvar'_t1*)
egen deuda_m_linea_EFH = rowtotal(`tlvar'_t2*)
egen cuota_tarjeta_EFH = rowtotal(`tlvar2'_t1*)
egen cuota_linea_EFH = rowtotal(`tlvar2'_t2*)
g deuda_m_TL_EFH = max(0,deuda_m_tarjeta_EFH) + max(0,deuda_m_linea_EFH) if deuda_m_tarjeta_EFH<. | deuda_m_linea_EFH<.
g cuota_TL_EFH = max(0,cuota_tarjeta_EFH) + max(0,cuota_linea_EFH) if cuota_tarjeta_EFH<. | cuota_linea_EFH<.
sum f15_t${tcc}*  `ccvar2'_t${tcc}*
quietly  {
local tk=${tcc}  // 4 before 2014, 5 from 2014 and on
forval dk = 1/3 {
capture replace f15_t`tk'd`dk' = . if f15_t`tk'd`dk'>=98 & f15_t`tk'd`dk'<=99 
capture replace f15_t`tk'd`dk' = . if f15_t`tk'd`dk'>=-2 & f15_t`tk'd`dk'<=-1 
replace `ccvar2'_t`tk'd`dk' = . if `ccvar2'_t`tk'd`dk'>=98 & `ccvar2'_t`tk'd`dk'<=99 
replace `ccvar2'_t`tk'd`dk' = . if `ccvar2'_t`tk'd`dk'>=-2 & `ccvar2'_t`tk'd`dk'<=-1 

replace `ccmes'_t`tk'd`dk' = . if `ccmes'_t`tk'd`dk'>=98 & `ccmes'_t`tk'd`dk'<=99 
replace `ccano'_t`tk'd`dk' = . if `ccano'_t`tk'd`dk'>=98 & `ccano'_t`tk'd`dk'<=99 
replace `ccmes'_t`tk'd`dk' = . if `ccmes'_t`tk'd`dk'>=-2 & `ccmes'_t`tk'd`dk'<=-1 
replace `ccano'_t`tk'd`dk' = . if `ccano'_t`tk'd`dk'>=-2 & `ccano'_t`tk'd`dk'<=-1 
replace `ccmes2'_t`tk'd`dk' = . if `ccmes2'_t`tk'd`dk'>=98 & `ccmes2'_t`tk'd`dk'<=99 
replace `ccano2'_t`tk'd`dk' = . if `ccano2'_t`tk'd`dk'>=98 & `ccano2'_t`tk'd`dk'<=99 
replace `ccmes2'_t`tk'd`dk' = . if `ccmes2'_t`tk'd`dk'>=-2 & `ccmes2'_t`tk'd`dk'<=-1 
replace `ccano2'_t`tk'd`dk' = . if `ccano2'_t`tk'd`dk'>=-2 & `ccano2'_t`tk'd`dk'<=-1 

capture replace f15_t`tk'd`dk' = . if f3_t`tk'd`dk'>1
replace `ccmes'_t`tk'd`dk' = . if f3_t`tk'd`dk'>1
replace `ccano'_t`tk'd`dk' = . if f3_t`tk'd`dk'>1
replace `ccvar2'_t`tk'd`dk' = . if f3_t`tk'd`dk'>1

if ${yk}==11 {  // different values in 2011 and 2014
replace f15_t`tk'd`dk' = 2000000 if f15_t_t`tk'd`dk'==1
replace f15_t`tk'd`dk' = 5000000 if f15_t_t`tk'd`dk'==2
replace f15_t`tk'd`dk' = 7000000 if f15_t_t`tk'd`dk'==3
replace f15_t`tk'd`dk' = 9000000 if f15_t_t`tk'd`dk'==4
replace f15_t`tk'd`dk' = 12500000 if f15_t_t`tk'd`dk'==5
replace f15_t`tk'd`dk' = 22500000 if f15_t_t`tk'd`dk'==6
replace f15_t`tk'd`dk' = 40000000 if f15_t_t`tk'd`dk'==7
replace f15_t`tk'd`dk' = 80000000 if f15_t_t`tk'd`dk'==8
}
if ${yk}>11 {  // different values in 2011 and 2014
replace f15_t`tk'd`dk' = 25000 if f15t_t`tk'd`dk'==1
replace f15_t`tk'd`dk' = 85000 if f15t_t`tk'd`dk'==2
replace f15_t`tk'd`dk' = 185000 if f15t_t`tk'd`dk'==3
replace f15_t`tk'd`dk' = 375000 if f15t_t`tk'd`dk'==4
replace f15_t`tk'd`dk' = 750000 if f15t_t`tk'd`dk'==5
replace f15_t`tk'd`dk' = 1500000 if f15t_t`tk'd`dk'==6 
replace f15_t`tk'd`dk' = 2750000 if f15t_t`tk'd`dk'==7 
replace f15_t`tk'd`dk' = 4250000 if f15t_t`tk'd`dk'==8 
replace f15_t`tk'd`dk' = 6250000 if f15t_t`tk'd`dk'==9 
replace f15_t`tk'd`dk' = 8750000 if f15t_t`tk'd`dk'==10
replace f15_t`tk'd`dk' = 12500000 if f15t_t`tk'd`dk'==11
replace f15_t`tk'd`dk' = 17500000 if f15t_t`tk'd`dk'==12
replace f15_t`tk'd`dk' = 25000000 if f15t_t`tk'd`dk'==13
replace f15_t`tk'd`dk' = 30000000 if f15t_t`tk'd`dk'==14
}
//  //
}
}
egen deuda_m_prestamo_EFH = rowtotal(f15_t${tcc}*)
egen cuota_prestamo_EFH = rowtotal(`ccvar2'_t${tcc}*)
g deuda_m_banco_EFH = max(0,deuda_m_TL_EFH) + max(0,deuda_m_prestamo_EFH) if deuda_m_TL_EFH<. | deuda_m_prestamo_EFH<.
g cuota_banco_EFH = max(0,cuota_TL_EFH) + max(0,cuota_prestamo_EFH) if cuota_TL_EFH<. | cuota_prestamo_EFH<.
/*local debt_types "banco tarjeta linea TL prestamo"
foreach x of local debt_types {
replace deuda_`x'_EFH = 0 if  deuda_m_`x'_EFH==0   
replace deuda_`x'_EFH = 0 if  cuota_`x'_EFH==0           
}*/
local debt_types "banco tarjeta linea TL prestamo"
foreach x of local debt_types {
replace deuda_m_`x'_EFH = . if  deuda_m_`x'_EFH==0   
replace cuota_`x'_EFH = . if  cuota_`x'_EFH==0 
replace deuda_m_`x'_EFH = . if  deuda_`x'_EFH==0   
replace cuota_`x'_EFH = . if  deuda_`x'_EFH==0           
}
sum deuda_banco_EFH deuda_TL_EFH deuda_tarjeta_EFH deuda_linea_EFH deuda_prestamo_EFH [fw=${factor_op}]
sum deuda_m_banco_EFH deuda_m_TL_EFH deuda_m_tarjeta_EFH deuda_m_linea_EFH deuda_m_prestamo_EFH [fw=${factor_op}], d
sum cuota_banco_EFH cuota_TL_EFH cuota_tarjeta_EFH cuota_linea_EFH cuota_prestamo_EFH [fw=${factor_op}], d
g ln_deuda_m_banco_EFH = ln(deuda_m_banco_EFH)
g ln_cuota_banco_EFH = ln(cuota_banco_EFH)
reg deuda_banco_EFH edad ing [pw=${factor_op}]
reg ln_deuda_m_banco_EFH edad ing [pw=${factor_op}]
reg ln_cuota_banco_EFH edad ing [pw=${factor_op}]

//  Loan Maturities  //sum f18_a_t${tcc}* f18_m_t${tcc}* f18_1_a_t${tcc}* f18_1_m_t${tcc}*
quietly  {
local tk=${tcc}  //4
forval dk = 1/3 {
g madurez_prestamo_d`dk' = 12*`ccano'_t`tk'd`dk' if `ccano'_t`tk'd`dk'<97
replace madurez_prestamo_d`dk' = max(0,madurez_prestamo_d`dk') + max(0,`ccmes'_t`tk'd`dk') if `ccmes'_t`tk'd`dk'<13
 
g madurez_prestamo_res_d`dk' = max(0,madurez_prestamo_d`dk') - max(0,`ccmes2'_t`tk'd`dk') if `ccmes2'_t`tk'd`dk'<13 & madurez_prestamo_d`dk'<.
replace madurez_prestamo_res_d`dk' = max(0,madurez_prestamo_d`dk') - 12*max(0,`ccano2'_t`tk'd`dk') if `ccano2'_t`tk'd`dk'<97 & madurez_prestamo_d`dk'<.

replace madurez_prestamo_d`dk' = . if f3_t`tk'd`dk'>1
replace madurez_prestamo_res_d`dk' = . if f3_t`tk'd`dk'>1
replace madurez_prestamo_d`dk' = . if deuda_prestamo_EFH==0 
replace madurez_prestamo_res_d`dk' = . if deuda_prestamo_EFH==0 
}
}
egen madurez_prestamo_EFH = rowmax(madurez_prestamo_d*)
egen madurez_prestamo_res_EFH = rowmax(madurez_prestamo_res_d*)
sum madurez_prestamo_EFH madurez_prestamo_res_EFH [fw=${factor_op}], d
save "$path_s1\EFH_folios_20${yk}_nosbif_allpers.dta", replace
