use "$path_s1\EFH_SBIF_wide_${yk}.dta", clear
local debt_types "banco prestamo TL tarjeta linea"
local debt_types2 "hipotecario banco prestamo TL tarjeta linea"
if ${yk}==11 {  // Tenencias de Deuda (Ownership of Debt) in EFH
global tcc = 4 
local tcc = ${tcc}
local mvars "m1 m2 m3"
local tknrs = "1 2"
local tlvar = "f10"
local tlvart = "f10_t"
local tlvar2 = "f11"
local ccvar2 = "f21"
local ccmes "f18_m"
local ccano "f18_a"
local ccmes2 "f18_1_m"
local ccano2 "f18_1_a"
}
if ${yk}==14 {
global tcc = 5
local tcc = ${tcc}
forv d=1/3  {
rename f12_t2d`d' f7_t2d`d' 
rename f12t_t2d`d' f7t_t2d`d' 
replace f7_t2d`d' =max(f7_t2d`d', max(0,f7_t1d`d')+ max(0,f7_t3d`d'))
g f9_t2d`d' = f12_t2d`d' 
}
local mvars "n1"
local tknrs = "1 2"
local tlvar = "f7"
local tlvart = "f7t"
local tlvar2 = "f9"
local ccvar2 = "f24"
local ccmes "f21_mes"
local ccano "f21_ano"
local ccmes2 "f22_mes"
local ccano2 "f22_ano"
}
if ${yk}==17 {
global tcc = 5
local tcc = ${tcc}
forv d=1/3  {
rename f13_t2d`d' f7_t2d`d' 
rename f13t_t2d`d' f7t_t2d`d' 
replace f7_t2d`d' =max(f7_t2d`d', max(0,f7_t1d`d')+ max(0,f7_t3d`d'))
g f9_t2d`d' = f7_t2d`d' 
}
local mvars "n1"
local tknrs = "1 2"
local tlvar = "f7"
local tlvart = "f7t"
local tlvar2 = "f9"
local ccvar2 = "f23"
local ccmes "f20_mes"
local ccano "f20_ano"
local ccmes2 "f21_mes"
local ccano2 "f21_ano"
}
local tefh1 = 1
local tefh2 = ${tcc}
local tefh5 = 2

sum cfdtbco cfdcbco dtbco dcbco cbco *bco //ctbco
capture g deuda_tarjeta_EFH = 0
replace deuda_tarjeta_EFH = 1 if f1_t1==1
capture g deuda_linea_EFH = 0
replace deuda_linea_EFH = 1 if f1_t2==1
capture g deuda_prestamo_EFH = 0
replace deuda_prestamo_EFH = 1 if f1_t`tcc'==1
g n_cons=0  // Nr of consumer debts in instalments
local f=`tcc' //4 in 2011
if ${yk}==11 {
foreach x of varlist d_*_td`f' {
replace n_cons=n_cons+1  if `x'>0 & `x'<.
}
}
if ${yk}==14 {
foreach x of varlist d_td`f'_* {
replace n_cons=n_cons+1  if `x'>0 & `x'<.
} 
} //rename cf_1_td`f' cf_1_cons   rename cf_2_td`f' cf_2_cons  rename cf_3_td`f' cf_3_cons 
// rename d_1_td`f' d_1_cons  rename d_2_td`f' d_2_cons  rename d_3_td`f' d_3_cons 

tab deuda_prestamo_EFH cbco // same variables 
sum deuda_* [fw=${factor_op}]
egen f3_t1 = rowmin(f3_t1d*)
egen f3_t2 = rowmin(f3_t2d*)
egen f3_t`tcc' = rowmin(f3_t`tcc'd*)
egen f3_Banco = rowmin(f3_t1 f3_t2 f3_t`tcc')
egen f3_TL = rowmin(f3_t1 f3_t2)
replace deuda_tarjeta_EFH = 0 if f3_t1!=1 & f3_t1!=.
replace deuda_linea_EFH = 0 if f3_t2!=1 & f3_t2!=.
replace deuda_prestamo_EFH = 0 if f3_t`tcc'!=1 & f3_t`tcc'!=.
egen deuda_TL_EFH = rowmax( deuda_tarjeta_EFH deuda_linea_EFH )
egen deuda_banco_EFH = rowmax( deuda_TL_EFH deuda_prestamo_EFH )
sum deuda_* [fw=${factor_op}]
tab f4_t1d1
tab f4_t2d1
tab f4_t`tcc'd1

sum date_survey
local date1 = r(min) //${date1}
local date2 = r(max) //${date2}
local date11 = `date1'-2 
local date21 = `date2'+2 
local tdebt1 = "tarjeta"  // Consumo: *1 Tarjetas de crdito *2 Crdito en cuotas *3 Crditos a estudiantes Recursos CORFO
local tdebt2 = "prestamo"  // 4 Otros crditos de consumo *5 Lneas de crdito en cuenta corriente
local tdebt5 = "linea"
quietly  {
foreach td of numlist 1 2 5 { 
g deuda_`tdebt`td''_SBIF = 0
forv kd1=`date1'/`date2' {
local kd3=`kd1'
capture replace deuda_`tdebt`td''_SBIF = 1 if c_nor`td'_1_`kd3'>0 & c_nor`td'_1_`kd3'<. & date_survey==`kd1'
capture replace deuda_`tdebt`td''_SBIF = 1 if c_nor4_1_`kd3'>0 & c_nor4_1_`kd3'<. & deuda_`tdebt`td''_EFH==1 & date_survey==`kd1' //Include Otros Crditos if it improves report
foreach kd2 of numlist -1 1 -2 2 {  //forv kd2=-2/2 {
local kd3=`kd1'+`kd2'
capture replace deuda_`tdebt`td''_SBIF = 0 if c_nor`td'_1_`kd3'==. & deuda_`tdebt`td''_EFH==0 & date_survey==`kd1'
capture replace deuda_`tdebt`td''_SBIF = 1 if c_nor`td'_1_`kd3'<. & deuda_`tdebt`td''_EFH==1 & date_survey==`kd1'
capture replace deuda_`tdebt`td''_SBIF = 1 if c_nor4_1_`kd3'<. & deuda_`tdebt`td''_EFH==1 & date_survey==`kd1' //Include Otros Crditos if it improves report
}
}
}
}
egen deuda_TL_SBIF = rowmax(deuda_tarjeta_SBIF deuda_linea_SBIF)
egen deuda_banco_SBIF = rowmax(deuda_tarjeta_SBIF deuda_linea_SBIF deuda_prestamo_SBIF)
replace deuda_tarjeta_EFH = 1 if f1_t1==1 & deuda_tarjeta_SBIF==1  // Consider also loans from the non-interviewed members
replace deuda_linea_EFH = 1 if f1_t2==1 & deuda_linea_SBIF==1  
replace deuda_prestamo_EFH = 1 if f1_t`tcc'==1 & deuda_prestamo_SBIF==1  
replace deuda_prestamo_EFH = 1 if complementario_EFH==1 & deuda_prestamo_SBIF==1  
replace deuda_TL_EFH = max(deuda_tarjeta_EFH,deuda_linea_EFH) if deuda_TL_SBIF==1 
replace deuda_banco_EFH = max(deuda_TL_EFH,deuda_prestamo_EFH) if deuda_banco_SBIF==1 

foreach tk of numlist 1 2 `tcc' {
forval dk = 1/3 {
capture g retailbank_t`tk'd`dk' = (f4_t`tk'd`dk'==15 | f4_t`tk'd`dk'==16 | f4_t`tk'd`dk'==18) if f4_t`tk'd`dk'<.
replace retailbank_t`tk'd`dk' = 1 if f3_t`tk'd`dk'>1
}
egen retailbank_t`tk' = rowmin(retailbank_t`tk'd*)
egen retailbank2_t`tk' = rowmax(retailbank_t`tk'd*)  //  /**/
drop retailbank_t`tk'd*
}
egen retailbank = rowmin(retailbank_t*)
egen retailbank2 = rowmax(retailbank_t*)  //  /**/
replace deuda_banco_EFH = 0 if retailbank==1 & deuda_banco_SBIF==0
replace deuda_TL_EFH = 0 if retailbank_t1==1 & retailbank_t2==1 & deuda_TL_SBIF==0
replace deuda_tarjeta_EFH = 0 if retailbank_t1==1 & deuda_tarjeta_SBIF==0
replace deuda_linea_EFH = 0 if retailbank_t2==1 & deuda_linea_SBIF==0
replace deuda_prestamo_EFH = 0 if retailbank_t`tcc'==1 & deuda_prestamo_SBIF==0
replace deuda_TL_EFH = max(deuda_tarjeta_EFH,deuda_linea_EFH)
replace deuda_banco_EFH = max(deuda_TL_EFH,deuda_prestamo_EFH)
sum deuda_*_SBIF deuda_*_EFH [fw=${factor_op}]

// Loan Amounts and Financial Charge in EFH
quietly  {
foreach tk of numlist 1 2 {
forval dk = 1/3 {
replace `tlvar'_t`tk'd`dk' = . if `tlvar'_t`tk'd`dk'>=98 & `tlvar'_t`tk'd`dk'<=99 // previous f10 is now f7
replace `tlvar2'_t`tk'd`dk' = . if `tlvar2'_t`tk'd`dk'>=98 & `tlvar2'_t`tk'd`dk'<=99  // previous f11 is now f9
replace `tlvar'_t`tk'd`dk' = . if `tlvar'_t`tk'd`dk'>=-2 & `tlvar'_t`tk'd`dk'<=-1 // previous f10 is now f7
replace `tlvar2'_t`tk'd`dk' = . if `tlvar2'_t`tk'd`dk'>=-2 & `tlvar2'_t`tk'd`dk'<=-1  // previous f11 is now f9

replace `tlvar'_t`tk'd`dk' = 25000 if `tlvart'_t`tk'd`dk'==1
replace `tlvar'_t`tk'd`dk' = 85000 if `tlvart'_t`tk'd`dk'==2
replace `tlvar'_t`tk'd`dk' = 185000 if `tlvart'_t`tk'd`dk'==3
replace `tlvar'_t`tk'd`dk' = 375000 if `tlvart'_t`tk'd`dk'==4
replace `tlvar'_t`tk'd`dk' = 750000 if `tlvart'_t`tk'd`dk'==5
replace `tlvar'_t`tk'd`dk' = 1500000 if `tlvart'_t`tk'd`dk'==6 
if ${yk}==11 {  // after 7 there are different values in 2011 and 2014
replace `tlvar'_t`tk'd`dk' = 3000000 if `tlvart'_t`tk'd`dk'==7 
replace `tlvar'_t`tk'd`dk' = 6000000 if `tlvart'_t`tk'd`dk'==8
}
if ${yk}>11 {
replace `tlvar'_t`tk'd`dk' = 2750000 if `tlvart'_t`tk'd`dk'==7 
replace `tlvar'_t`tk'd`dk' = 4250000 if `tlvart'_t`tk'd`dk'==8 
replace `tlvar'_t`tk'd`dk' = 6250000 if `tlvart'_t`tk'd`dk'==9 
replace `tlvar'_t`tk'd`dk' = 8750000 if `tlvart'_t`tk'd`dk'==10
replace `tlvar'_t`tk'd`dk' = 12500000 if `tlvart'_t`tk'd`dk'==11
replace `tlvar'_t`tk'd`dk' = 17500000 if `tlvart'_t`tk'd`dk'==12
replace `tlvar'_t`tk'd`dk' = 25000000 if `tlvart'_t`tk'd`dk'==13
replace `tlvar'_t`tk'd`dk' = 30000000 if `tlvart'_t`tk'd`dk'==14
} //replace `tlvar'_t`tk'd`dk' = . if f3_t`tk'd`dk'>1  //replace `tlvar2'_t`tk'd`dk' = . if f3_t`tk'd`dk'>1
}
}
}
egen deuda_m_tarjeta_EFH = rowtotal(`tlvar'_t1*), missing
egen deuda_m_linea_EFH = rowtotal(`tlvar'_t2*), missing
egen cuota_tarjeta_EFH = rowtotal(`tlvar2'_t1*), missing
egen cuota_linea_EFH = rowtotal(`tlvar2'_t2*), missing
capture g deuda_m_TL_EFH = max(0,deuda_m_tarjeta_EFH) + max(0,deuda_m_linea_EFH) if deuda_m_tarjeta_EFH<. | deuda_m_linea_EFH<.
capture g cuota_TL_EFH = max(0,cuota_tarjeta_EFH) + max(0,cuota_linea_EFH) if cuota_tarjeta_EFH<. | cuota_linea_EFH<.
sum f15_t${tcc}*  `ccvar2'_t${tcc}*
quietly  {
local tk=${tcc}  // 4 before 2014, 5 from 2014 and on
forval dk = 1/3 {
capture replace f15_t`tk'd`dk' = . if f15_t`tk'd`dk'>=98 & f15_t`tk'd`dk'<=99 
capture replace f15_t`tk'd`dk' = . if f15_t`tk'd`dk'>=-2 & f15_t`tk'd`dk'<=-1 
replace `ccvar2'_t`tk'd`dk' = . if `ccvar2'_t`tk'd`dk'>=98 & `ccvar2'_t`tk'd`dk'<=99 
replace `ccvar2'_t`tk'd`dk' = . if `ccvar2'_t`tk'd`dk'>=-2 & `ccvar2'_t`tk'd`dk'<=-1 

replace `ccmes'_t`tk'd`dk' = . if `ccmes'_t`tk'd`dk'>=98 & `ccmes'_t`tk'd`dk'<=99 
replace `ccano'_t`tk'd`dk' = . if `ccano'_t`tk'd`dk'>=98 & `ccano'_t`tk'd`dk'<=99 
replace `ccmes'_t`tk'd`dk' = . if `ccmes'_t`tk'd`dk'>=-2 & `ccmes'_t`tk'd`dk'<=-1 
replace `ccano'_t`tk'd`dk' = . if `ccano'_t`tk'd`dk'>=-2 & `ccano'_t`tk'd`dk'<=-1 
replace `ccmes2'_t`tk'd`dk' = . if `ccmes2'_t`tk'd`dk'>=98 & `ccmes2'_t`tk'd`dk'<=99 
replace `ccano2'_t`tk'd`dk' = . if `ccano2'_t`tk'd`dk'>=98 & `ccano2'_t`tk'd`dk'<=99 
replace `ccmes2'_t`tk'd`dk' = . if `ccmes2'_t`tk'd`dk'>=-2 & `ccmes2'_t`tk'd`dk'<=-1 
replace `ccano2'_t`tk'd`dk' = . if `ccano2'_t`tk'd`dk'>=-2 & `ccano2'_t`tk'd`dk'<=-1 

if ${yk}==11 {  // different values in 2011 and 2014
replace f15_t`tk'd`dk' = 2000000 if f15_t_t`tk'd`dk'==1
replace f15_t`tk'd`dk' = 5000000 if f15_t_t`tk'd`dk'==2
replace f15_t`tk'd`dk' = 7000000 if f15_t_t`tk'd`dk'==3
replace f15_t`tk'd`dk' = 9000000 if f15_t_t`tk'd`dk'==4
replace f15_t`tk'd`dk' = 12500000 if f15_t_t`tk'd`dk'==5
replace f15_t`tk'd`dk' = 22500000 if f15_t_t`tk'd`dk'==6
replace f15_t`tk'd`dk' = 40000000 if f15_t_t`tk'd`dk'==7
replace f15_t`tk'd`dk' = 80000000 if f15_t_t`tk'd`dk'==8
}
if ${yk}>11 {  // different values in 2011 and 2014
replace f15_t`tk'd`dk' = 25000 if f15t_t`tk'd`dk'==1
replace f15_t`tk'd`dk' = 85000 if f15t_t`tk'd`dk'==2
replace f15_t`tk'd`dk' = 185000 if f15t_t`tk'd`dk'==3
replace f15_t`tk'd`dk' = 375000 if f15t_t`tk'd`dk'==4
replace f15_t`tk'd`dk' = 750000 if f15t_t`tk'd`dk'==5
replace f15_t`tk'd`dk' = 1500000 if f15t_t`tk'd`dk'==6 
replace f15_t`tk'd`dk' = 2750000 if f15t_t`tk'd`dk'==7 
replace f15_t`tk'd`dk' = 4250000 if f15t_t`tk'd`dk'==8 
replace f15_t`tk'd`dk' = 6250000 if f15t_t`tk'd`dk'==9 
replace f15_t`tk'd`dk' = 8750000 if f15t_t`tk'd`dk'==10
replace f15_t`tk'd`dk' = 12500000 if f15t_t`tk'd`dk'==11
replace f15_t`tk'd`dk' = 17500000 if f15t_t`tk'd`dk'==12
replace f15_t`tk'd`dk' = 25000000 if f15t_t`tk'd`dk'==13
replace f15_t`tk'd`dk' = 30000000 if f15t_t`tk'd`dk'==14
} //replace f15_t`tk'd`dk' = . if f3_t`tk'd`dk'>1 //replace `ccmes'_t`tk'd`dk' = . if f3_t`tk'd`dk'>1 //replace `ccano'_t`tk'd`dk' = . if f3_t`tk'd`dk'>1 //replace `ccvar2'_t`tk'd`dk' = . if f3_t`tk'd`dk'>1
}
}
egen deuda_m_prestamo_EFH = rowtotal(f15_t`tcc'*), missing
egen cuota_prestamo_EFH = rowtotal(`ccvar2'_t${tcc}*), missing
capture g deuda_m_banco_EFH = max(0,deuda_m_TL_EFH) + max(0,deuda_m_prestamo_EFH) if deuda_m_TL_EFH<. | deuda_m_prestamo_EFH<.
capture g cuota_banco_EFH = max(0,cuota_TL_EFH) + max(0,cuota_prestamo_EFH) if cuota_TL_EFH<. | cuota_prestamo_EFH<.
foreach x of local debt_types {
replace deuda_`x'_EFH = 0 if  deuda_m_`x'_EFH==0   
replace deuda_`x'_EFH = 0 if  cuota_`x'_EFH==0 
replace deuda_m_`x'_EFH = . if  deuda_`x'_EFH==0  //replace deuda_m_`x'_EFH = . if  deuda_m_`x'_EFH==0    
replace cuota_`x'_EFH = . if  deuda_`x'_EFH==0    //replace cuota_`x'_EFH = . if  cuota_`x'_EFH==0       
}
//

// Loan Amounts - SBIF   //
local tdebt1 = "tarjeta"   // Consumo: *1 Tarjetas de crdito *2 Crdito en cuotas *3 Crditos a estudiantes Recursos CORFO
local tdebt2 = "prestamo"  // 4 Otros crditos de consumo *5 Lneas de crdito en cuenta corriente
local tdebt4 = "otros"
local tdebt5 = "linea"
g error_amount = 0
g abs_error_amount = 0
g abs_error_amount2 = 0
quietly  {
foreach td of numlist 1 2 5 { //1 2 5  //1 2 4 5
g deuda_m_`tdebt`td''_SBIF = 0
forv kd1=`date1'/`date2' {
local kd3=`kd1'
capture egen mo_deu`td'_`kd3' = rowtotal(mo_deu`td'_*_`kd3')
capture egen c_nor`td'_`kd3' = rowtotal(c_nor`td'_*_`kd3')
capture replace mo_deu`td'_`kd3' = c_nor`td'_`kd3' if mo_deu`td'_`kd3'==.  |  mo_deu`td'_`kd3'==0
capture replace deuda_m_`tdebt`td''_SBIF = mo_deu`td'_`kd3' if deuda_`tdebt`td''_SBIF==1 & date_survey==`kd1'
capture replace error_amount = max(0,deuda_m_`tdebt`td''_SBIF)-max(0,deuda_m_`tdebt`td''_EFH)
capture replace abs_error_amount = abs(error_amount)

capture g mo2_deu`td'_`kd3' = max(mo2_deu`td'_`kd3',c_nor`td'_`kd3')
capture replace abs_error_amount2 = abs(max(0,mo2_deu`td'_`kd3')-max(0,deuda_m_`tdebt`td''_EFH))
capture replace deuda_m_`tdebt`td''_SBIF = mo2_deu`td'_`kd3' if abs_error_amount>abs_error_amount2 & date_survey==`kd1'
capture replace error_amount = max(0,deuda_m_`tdebt`td''_SBIF)-max(0,deuda_m_`tdebt`td''_EFH)
capture replace abs_error_amount = abs(error_amount)

forv tn=1/4 {  // Only include 4th debts if these reduce error
capture replace deuda_m_`tdebt`td''_SBIF = max(0,deuda_m_`tdebt`td''_SBIF) + max(0,mo_deu4_`tn'_`kd3') if deuda_`tdebt`td''_SBIF==1 & error_amount<0 & abs_error_amount>mo_deu4_`tn'_`kd3' & date_survey==`kd1'
capture replace error_amount = max(0,deuda_m_`tdebt`td''_SBIF)-max(0,deuda_m_`tdebt`td''_EFH)
capture replace abs_error_amount = abs(error_amount)
}
capture drop mo_deu`td'_`kd3' c_nor`td'_`kd3' mo2_deu`td'_`kd3'
foreach kd2 of numlist -1 1 -2 2 {  //forv kd2=-2/2 {
local kd3=`kd1'+`kd2'
capture egen mo_deu`td'_`kd3' = rowtotal(mo_deu`td'_*_`kd3')
capture egen c_nor`td'_`kd3' = rowtotal(c_nor`td'_*_`kd3')
capture replace mo_deu`td'_`kd3' = c_nor`td'_`kd3' if mo_deu`td'_`kd3'==. | mo_deu`td'_`kd3'==0
capture replace abs_error_amount2 = abs(max(0,mo_deu`td'_`kd3')-max(0,deuda_m_`tdebt`td''_EFH))
capture replace deuda_m_`tdebt`td''_SBIF = mo_deu`td'_`kd3' if deuda_`tdebt`td''_SBIF==1 & abs_error_amount>abs_error_amount2 & date_survey==`kd1' //& mo_deu`td'_`kd3'>0 & mo_deu`td'_`kd3'<.
capture replace error_amount = max(0,deuda_m_`tdebt`td''_SBIF)-max(0,deuda_m_`tdebt`td''_EFH)
capture replace abs_error_amount = abs(error_amount)

capture g mo2_deu`td'_`kd3' = max(mo_deu`td'_`kd3',c_nor`td'_`kd3')
capture replace abs_error_amount2 = abs(max(0,mo2_deu`td'_`kd3')-max(0,deuda_m_`tdebt`td''_EFH))
capture replace deuda_m_`tdebt`td''_SBIF = mo2_deu`td'_`kd3' if abs_error_amount>abs_error_amount2 & date_survey==`kd1'
capture replace error_amount = max(0,deuda_m_`tdebt`td''_SBIF)-max(0,deuda_m_`tdebt`td''_EFH)
capture replace abs_error_amount = abs(error_amount)

forv tn=1/4 {  // Only include 4th debts if these reduce error
capture replace deuda_m_`tdebt`td''_SBIF = max(0,deuda_m_`tdebt`td''_SBIF) + max(0,mo_deu4_`tn'_`kd3') if deuda_`tdebt`td''_SBIF==1 & error_amount<0 & abs_error_amount>mo_deu4_`tn'_`kd3' & date_survey==`kd1'
capture replace error_amount = max(0,deuda_m_`tdebt`td''_SBIF)-max(0,deuda_m_`tdebt`td''_EFH)
capture replace abs_error_amount = abs(error_amount)
}
capture drop mo_deu`td'_`kd3' c_nor`td'_`kd3' mo2_deu`td'_`kd3'
}
}
}
}
//   ReConsider Loans from other Non-Interviewed Household members //
forv dk=1/3 {
rename f15_t`tcc'd`dk' f10_t`tcc'd`dk'
rename `ccvar2'_t`tcc'd`dk' `ccvar2'_t`tcc'd`dk'
}
quietly {
foreach td of numlist 1 2 5 { //replace f10_t`tk'd`dk' = . if f3_t`tk'd`dk'>1 
forv dk=1/3 {   // Loan amount in EFH for non-interviewed members
capture replace error_amount = max(0,deuda_m_`tdebt`td''_SBIF)-max(0,deuda_m_`tdebt`td''_EFH)
capture replace abs_error_amount = abs(error_amount)
capture replace deuda_m_`tdebt`td''_EFH = max(0,deuda_m_`tdebt`td''_EFH)+max(0,f10_t`tefh`tk''d`dk') if f3_t`tefh`tk''d`dk'>1 & error_amount>0  & abs_error_amount>f10_t`tefh`tk''d`dk' & f10_t`tefh`tk''d`dk'<.
}
}
}
quietly { // Reconsider Crdito Complementario as Prstamos de Consumo
forv dk=1/4 { // Only for Prestamos de Consumo
capture replace error_amount = max(0,deuda_m_prestamo_SBIF)-max(0,deuda_m_prestamo_EFH)
capture replace abs_error_amount = abs(error_amount)
capture replace deuda_m_prestamo_EFH = max(0,deuda_m_prestamo_EFH)+max(0,complementario_m_`dk'_EFH') if complementario_m_`dk'_EFH<. & error_amount>0 & abs_error_amount>complementario_m_`dk'_EFH
}  //Reconsider Other Consumer SBIF loans as Prstamos de Consumo
capture replace error_amount = max(0,deuda_m_prestamo_SBIF)-max(0,deuda_m_prestamo_EFH)
capture replace abs_error_amount = abs(error_amount)
capture replace deuda_m_prestamo_SBIF = max(0,deuda_m_prestamo_SBIF)+max(0,deuda_m_otros_SBIF) if deuda_m_otros_SBIF<. & error_amount<0 & abs_error_amount>deuda_m_otros_SBIF
}
replace deuda_m_TL_EFH = max(0,deuda_m_tarjeta_EFH) + max(0,deuda_m_linea_EFH) if deuda_TL_EFH==1 
replace deuda_m_banco_EFH = max(0,deuda_m_TL_EFH) + max(0,deuda_m_prestamo_EFH) if deuda_banco_EFH==1 
foreach td of numlist 1 2 5 { 
capture replace deuda_m_`tdebt`td''_SBIF = . if deuda_`tdebt`td''_SBIF==0  //capture replace deuda_m_`tdebt`td''_SBIF = . if deuda_m_`tdebt`td''_SBIF==0
capture replace deuda_`tdebt`td''_SBIF = 0 if deuda_m_`tdebt`td''_SBIF==.
}
egen deuda_m_TL_SBIF = rowtotal(deuda_m_tarjeta_SBIF deuda_m_linea_SBIF)  //, missing
egen deuda_m_banco_SBIF = rowtotal(deuda_m_tarjeta_SBIF deuda_m_linea_SBIF deuda_m_prestamo_SBIF) //, missing

//  Loan Maturities in EFH  //sum f18_a_t`tcc'* f18_m_t`tcc'* f18_1_a_t`tcc'* f18_1_m_t`tcc'*
quietly  {
local tk=${tcc}  //4
forval dk = 1/3 { 
capture g madurez_prestamo_d`dk' = 12*`ccano'_t`tk'd`dk' if `ccano'_t`tk'd`dk'<97
replace madurez_prestamo_d`dk' = max(0,madurez_prestamo_d`dk') + max(0,`ccmes'_t`tk'd`dk') if `ccmes'_t`tk'd`dk'<13
 
capture g madurez_prestamo_res_d`dk' = max(0,madurez_prestamo_d`dk') - max(0,`ccmes2'_t`tk'd`dk') if `ccmes2'_t`tk'd`dk'<13 & madurez_prestamo_d`dk'<.
replace madurez_prestamo_res_d`dk' = max(0,madurez_prestamo_d`dk') - 12*max(0,`ccano2'_t`tk'd`dk') if `ccano2'_t`tk'd`dk'<97 & madurez_prestamo_d`dk'<.
replace madurez_prestamo_d`dk' = . if deuda_prestamo_EFH==0 
replace madurez_prestamo_res_d`dk' = . if deuda_prestamo_EFH==0 
replace madurez_prestamo_res_d`dk' = . if madurez_prestamo_res_d`dk'<=0 

g w`dk' = max(0,f10_t`tcc'd`dk')/deuda_m_prestamo_EFH
capture replace w`dk' = 0 if w`dk'==.
//replace madurez_prestamo_d`dk' = . if f3_t`tk'd`dk'>1 //replace madurez_prestamo_res_d`dk' = . if f3_t`tk'd`dk'>1
}
g madurez_prestamo_EFH = w1*max(0,madurez_prestamo_d1) + w2*max(0,madurez_prestamo_d2) + w3*max(0,madurez_prestamo_d3)
g madurez_prestamo_res_EFH = w1*max(0,madurez_prestamo_res_d1) + w2*max(0,madurez_prestamo_res_d2) + w3*max(0,madurez_prestamo_res_d3)
replace madurez_prestamo_EFH = . if deuda_prestamo_EFH==0 
replace madurez_prestamo_res_EFH = . if deuda_prestamo_EFH==0 
drop w1 w2 w3
}
egen madurez_max_prestamo_EFH = rowmax(madurez_prestamo_d*)
egen madurez_max_prestamo_res_EFH = rowmax(madurez_prestamo_res_d*)
foreach x of varlist madurez_max_prestamo*EFH madurez_prestamo_EFH madurez_prestamo_res_EFH {
replace `x'=. if deuda_prestamo_EFH==0
}
//

quietly  { // Maturities SBIF  //replace error_amount = 0 //replace abs_error_amount = 0 //replace abs_error_amount2 = 0
capture {
foreach td of numlist 2 { // 4 2 // 2 4 // 2 //local td=2  //foreach td of numlist 1 2 5 { *} // p_cre (initial maturity), vintage_m (how long ago credit was taken) p_cre-vintage_m is remaining maturity
g madurez_`tdebt`td''_SBIF = .
g madurez_`tdebt`td''_res_SBIF = .
forv kd1=`date11'/`date21' { //forv kd1=`date1'/`date2' {
local kd3=`kd1'
capture egen mo_deu`td'_`kd3' = rowtotal(mo_deu`td'_*_`kd3')
capture egen c_nor`td'_`kd3' = rowtotal(c_nor`td'_*_`kd3')
capture replace mo_deu`td'_`kd3' = max(mo_deu`td'_`kd3',c_nor`td'_`kd3')
forv tn=1/4 {  // 4 w
capture g w`tn' = max(0, mo_deu`td'_`tn'_`kd3',c_nor`td'_`tn'_`kd3')/mo_deu`td'_`kd3'
capture g m_res`tn' = max(0,p_cre`td'_`tn'_`kd3')-max(0,vintage_m`td'_`tn'_`kd3')
capture g w`tn' = 0  //capture replace w`tn' = 0 if w`tn'==.
capture g m_res`tn' = 0  //capture replace m_res`tn' = 0 if w`tn'==.
}
capture g p_cre`td'_`kd3' = max(0,p_cre`td'_1_`kd3')*w1 + max(0,p_cre`td'_2_`kd3')*w2 + max(0,p_cre`td'_3_`kd3')*w3 + max(0,p_cre`td'_4_`kd3')*w4 
capture g vintage_m`td'_`kd3' = max(0,vintage_m`td'_1_`kd3')*w1 + max(0,vintage_m`td'_2_`kd3')*w2 + max(0,vintage_m`td'_3_`kd3')*w3 + max(0,vintage_m`td'_4_`kd3')*w4
capture g madurez_res`td'_`kd3' = m_res1*w1 + m_res2*w2 + m_res3*w3 + m_res4*w4 

capture replace p_cre`td'_`kd3' = . if p_cre`td'_`kd3'==0
capture replace vintage_m`td'_`kd3' = . if vintage_m`td'_`kd3'==0
capture replace madurez_res`td'_`kd3' = . if madurez_res`td'_`kd3'==0 

capture replace madurez_`tdebt`td''_SBIF = p_cre`td'_`kd3'  if deuda_`tdebt`td''_SBIF==1 & date_survey==`kd1'
capture replace madurez_`tdebt`td''_res_SBIF = madurez_res`td'_`kd3' if deuda_`tdebt`td''_SBIF==1 & date_survey==`kd1'

capture drop w1 w2 w3 w4 mo_deu`td'_`kd3' c_nor`td'_`kd3' m_res1 m_res2 m_res3 m_res4
foreach kd2 of numlist -1 1 -2 2 { // Consider previous dates for missing values //forv kd2=-2/2 {
local kd3=`kd1'+`kd2'
capture replace madurez_`tdebt`td''_SBIF = p_cre`td'_1_`kd3' if p_cre`td'_1_`kd3'<. & deuda_`tdebt`td''_SBIF==1 & date_survey==`kd1' & madurez_`tdebt`td''_SBIF==.
capture replace madurez_`tdebt`td''_res_SBIF = p_cre`td'_1_`kd3'-vintage_m`td'_1_`kd3' if p_cre`td'_1_`kd3'<. & vintage_m`td'_1_`kd3'<. & deuda_`tdebt`td''_SBIF==1 & date_survey==`kd1' & madurez_`tdebt`td''_res_SBIF==.
}
}
}
}
}
//  Consider maturity of window around date as possible one
quietly  {   // Maturities SBIF
capture {
local td=2
forv kd1=`date1'/`date2' {  //local kd3=`kd1'
foreach kd2 of numlist -1 1 -2 2 { // Consider lag and forward dates for missing values -1 1 -2 2
local kd3=`kd1'+`kd2'
capture replace error_amount = max(0,madurez_`tdebt`td''_SBIF)-max(0,madurez_`tdebt`td''_EFH)
capture replace abs_error_amount = abs(error_amount)
capture replace abs_error_amount2 = abs( max(0,p_cre`td'_`kd3')-max(0,madurez_`tdebt`td''_EFH) )
capture replace madurez_`tdebt`td''_SBIF = max(0,p_cre`td'_`kd3') if deuda_`tdebt`td''_SBIF==1 & abs_error_amount>abs_error_amount2 & date_survey==`kd1' & p_cre`td'_`kd3'>0 & p_cre`td'_`kd3'<.

capture replace error_amount = max(0,madurez_`tdebt`td''_res_SBIF)-max(0,madurez_`tdebt`td''_res_EFH)
capture replace abs_error_amount = abs(error_amount)
capture replace abs_error_amount2 = abs( max(0,madurez_res`td'_`kd3')-max(0,madurez_`tdebt`td''_res_EFH) )
capture replace madurez_`tdebt`td''_res_SBIF = max(0,madurez_res`td'_`kd3') if deuda_`tdebt`td''_res_SBIF==1 & abs_error_amount>abs_error_amount2 & date_survey==`kd1' & madurez_res`td'_`kd3'>0 & madurez_res`td'_`kd3'<.

forv tn=1/2 {  // Consider Otros Crditos as possible maturity
g mad_res = p_cre4_`tn'_`kd3'-vintage_m4_`tn'_`kd3'
capture replace error_amount = max(0,madurez_`tdebt`td''_SBIF)-max(0,madurez_`tdebt`td''_EFH)
capture replace abs_error_amount = abs(error_amount)
capture replace abs_error_amount2 = abs( max(0,p_cre4_`tn'_`kd3')-max(0,madurez_`tdebt`td''_EFH) )
capture replace madurez_`tdebt`td''_SBIF = max(0,p_cre4_`tn'_`kd3') if deuda_`tdebt`td''_SBIF==1 & abs_error_amount>abs_error_amount2 & date_survey==`kd1' & p_cre4_`tn'_`kd3'>0 & p_cre4_`tn'_`kd3'<.

capture replace error_amount = max(0,madurez_`tdebt`td''_res_SBIF)-max(0,madurez_`tdebt`td''_res_EFH)
capture replace abs_error_amount = abs(error_amount)
capture replace abs_error_amount2 = abs( max(0,mad_res)-max(0,madurez_`tdebt`td''_res_EFH) )
capture replace madurez_`tdebt`td''_res_SBIF = max(0,mad_res) if deuda_`tdebt`td''_res_SBIF==1 & abs_error_amount>abs_error_amount2 & date_survey==`kd1' & mad_res>0 & mad_res<.
drop mad_res
} //  //
}
}
}
}
quietly { // Reconsider Crdito Complementario as Prstamos de Consumo
forv dk=1/4 { // Only for Prestamos de Consumo
capture replace error_amount = max(0,madurez_prestamo_SBIF)-max(0,madurez_prestamo_EFH)
capture replace abs_error_amount = abs(error_amount)
capture replace abs_error_amount2 = abs( max(0,madurez_prestamo_SBIF)-max(0,madurez_complementario_`dk'_EFH ) )
capture replace madurez_prestamo_EFH = madurez_complementario_`dk'_EFH  if madurez_complementario_`dk'_EFH <. & abs_error_amount<abs_error_amount2 & madurez_complementario_`dk'_EFH>0

capture replace error_amount = max(0,madurez_prestamo_res_SBIF)-max(0,madurez_prestamo_res_EFH)
capture replace abs_error_amount = abs(error_amount)
capture replace abs_error_amount2 = abs( max(0,madurez_prestamo_res_SBIF)-max(0,madurez_complementario_`dk'_res_EFH ) )
capture replace madurez_prestamo_res_EFH = madurez_complementario_`dk'_res_EFH  if madurez_complementario_`dk'_res_EFH <. & abs_error_amount<abs_error_amount2 & madurez_complementario_`dk'_res_EFH>0
}  
}
*sum madurez_tarjeta_res_SBIF madurez_linea_res_SBIF madurez_res1* madurez_res5* p_cre1_* vintage_m1_*  p_cre5_* vintage_m5_*  // Only prestamos have residual maturity
drop error_amount abs_error_amount abs_error_amount2 p_cre1_* vintage_m1_*  p_cre5_* vintage_m5_* //madurez_tarjeta_SBIF madurez_tarjeta_res_SBIF  madurez_linea_SBIF madurez_linea_res_SBIF  //drop madurez_tarjeta_res_SBIF madurez_linea_res_SBIF madurez_res1* madurez_res5* 
foreach var of varlist madurez_presta* {
replace `var' = ceil(`var')
}
foreach var of varlist madurez_presta*SBIF {
replace `var' = . if deuda_prestamo_SBIF==0
}
sum madurez_prestamo_res_SBIF madurez_res2* p_cre2_* vintage_m2_* 
sum madurez_prestamo_SBIF madurez_prestamo_res_SBIF deuda_prestamo_SBIF if deuda_prestamo_SBIF==1
sum madurez_max_prestamo_EFH madurez_max_prestamo_res_EFH [fw=${factor_op}], d
foreach x of local debt_types2 {  // Debt values go to . if debt ownership is not considered
replace deuda_m_`x'_SBIF=. if deuda_`x'_SBIF==0  |  deuda_`x'_SBIF==.
replace deuda_m_`x'_EFH=. if deuda_`x'_EFH==0  |  deuda_`x'_EFH==.
}
//    //    //

//  Errors of EFH vs SBIF
foreach x of local debt_types {
g error_`x'_tenencia = max(0,deuda_`x'_SBIF) - max(0,deuda_`x'_EFH) if deuda_`x'_SBIF<. | deuda_`x'_EFH<.   
g error_`x'_monto = max(0,deuda_m_`x'_SBIF) - max(0,deuda_m_`x'_EFH) if deuda_m_`x'_SBIF<. | deuda_m_`x'_EFH<.
if ${Ratio_op}==1 { //ln( (abs(error_`x'_monto)+ 1) )  //+ r(min)
g mean_var = ( max(0,deuda_m_`x'_EFH ) + max(0,deuda_m_`x'_SBIF ) )/2 
g error_ratio_`x' =  abs(error_`x'_monto)/mean_var 
g error_ratio0_`x' =  error_`x'_monto/mean_var 
drop mean_var
}
else  {
g error_ratio_`x' =  abs(error_`x'_monto)/deuda_m_`x'_SBIF  //ln( (abs(error_`x'_monto)+ 1) )  //+ r(min) 
replace error_ratio_`x' =  abs(error_`x'_monto)/deuda_m_`x'_EFH if error_ratio_`x'==.                    
}      
}
g error_madurez = max(0,madurez_prestamo_SBIF)-max(0,madurez_prestamo_EFH) if madurez_prestamo_SBIF<. | madurez_prestamo_EFH<.
g error_madurez_res = max(0,madurez_prestamo_res_SBIF)-max(0,madurez_prestamo_res_EFH) if madurez_prestamo_res_SBIF<. | madurez_prestamo_res_EFH<.
g mean_var = ( max(0,madurez_prestamo_SBIF ) + max(0,madurez_prestamo_EFH ) )/2 
g error_ratio_madurez =  abs(error_madurez)/mean_var 
g error_ratio0_madurez =  error_madurez/mean_var 
drop mean_var
g mean_var = ( max(0,madurez_prestamo_res_SBIF ) + max(0,madurez_prestamo_res_EFH ) )/2 
g error_ratio_mres =  abs(error_madurez_res)/mean_var 
g error_ratio0_mres =  error_madurez_res/mean_var 
drop mean_var

foreach x of local debt_types {  // variables: numh or numh2 edad ing
g error2_`x'_tenencia =(error_`x'_tenencia==1)
probit error2_`x'_tenencia `mvars' numh2 edad ing [pw=${factor_op}]
reg error_ratio_`x' numh2 edad ing [pw=${factor_op}]   // m1 m2 m3 //reg error_`x'_monto numh2 edad ing [pw=${factor_op}]                          
}
sum error_madurez error_madurez_res [fw=${factor_op}], d 
save "$path_s1\EFH_SBIF_wide_${yk}.dta", replace
