global df_types0 = 1 // 0 Use a single definition of default in SBIF (any default in c_inc, cc_atr, mc_atr), 
//1 use definition that best matches EFH
use "$path_s1\EFH_SBIF_wide_${yk}.dta", clear
if ${yk}==11 {  // Tenencias de Deuda (Ownership of Debt) in EFH
global tcc = 4 
local tcc = ${tcc}
local mvars "m1 m2 m3"
}
if ${yk}==14 {
global tcc = 5
local tcc = ${tcc}
local mvars "n1"
}
local tefh1 = 1
local tefh2 = ${tcc}
local default_vsbif = "default_sbif"
local df_types "default_inc default_cc default_mca"  
local df_types2 "df_dna_k df_dna_a1 df_dna_new df_dna" 
local df_types3 "df_vp_new df_vp df_vp_1 df_hog_1"    

replace df_dna_a1 = 0 if deuda_prestamo_EFH==1 & df_dna_a1==.
replace df_dna_a1 = . if deuda_prestamo_EFH==0 
replace df_dna_k = 0 if deuda_prestamo_EFH==1 & df_dna_k==.
replace df_dna_k = . if deuda_prestamo_EFH==0
g df_prestamo_EFH = df_dna_a1 // df_dna_k df_dna_a1  df_dna df_dna_new
capture g df_hip_EFH = max(df_vp, df_vp_1, df_hog_1, df_vp_new)   // df_vp df_vp_new df_vp_original
capture g df_hip_EFH = max(df_vp, df_vp_new) 
capture sum df_vp_1 df_hog_1 df_vp df_vp_new df_dna df_dna_new df_dna_k df_dna_a1 //default_sbif default_30

// Consumer Credit - Loan Amounts - SBIF   //
sum date_survey
local date1 = r(min) //${date1}
local date2 = r(max) //${date2}
local tdebt1 = "tarjeta"  // Consumo: *1 Tarjetas de crdito *2 Crdito en cuotas *3 Crditos a estudiantes Recursos CORFO
local tdebt2 = "prestamo" // 4 Otros crditos de consumo *5 Lneas de crdito en cuenta corriente
g error_amount = 0
g abs_error_amount = 0
g abs_error_amount2 = 0
quietly  {
foreach td of numlist 2 { // 1 2 5 (use 2 - just prestamos)
g df_`tdebt`td''_SBIF = 0
forv kd1=`date1'/`date2' {
local kd3=`kd1'
capture egen `default_vsbif'`td'_`kd3' = rowmax(`default_vsbif'`td'_*_`kd3')
capture replace df_`tdebt`td''_SBIF = `default_vsbif'`td'_`kd3' if deuda_`tdebt`td''_SBIF==1 & date_survey==`kd1'
foreach var1 of local df_types2 {  //   ReConsider Other definitions of EFH default //
replace df_`tdebt`td''_EFH = 1 if df_`tdebt`td''_SBIF==1 & `var1'==1 & deuda_`tdebt`td''_EFH==1 //replace df_`tdebt`td''_EFH = 0 if df_`tdebt`td''_SBIF==0 & `var1'==0 & deuda_`tdebt`td''_EFH==1
}
if ${df_types0}==1 { 
foreach var1 of local df_types {  //   ReConsider Other definitions of SBIF default //
egen `var1' = rowmax(`var1'`td'_*_`kd3')
replace df_`tdebt`td''_SBIF = 1 if df_`tdebt`td''_EFH==1 & `var1'==1 & deuda_`tdebt`td''_SBIF==1
replace df_`tdebt`td''_SBIF = 0 if df_`tdebt`td''_EFH==0 & `var1'==0 & deuda_`tdebt`td''_SBIF==1
drop `var1'
}
}
capture replace error_amount = max(0,df_`tdebt`td''_SBIF)-max(0,df_`tdebt`td''_EFH)
capture replace abs_error_amount = abs(error_amount)

forv tn=1/4 {
capture replace df_`tdebt`td''_SBIF = max(0,`default_vsbif'4_`tn'_`kd3') if deuda_`tdebt`td''_SBIF==1 & error_amount<0 & date_survey==`kd1'
capture replace error_amount = max(0,df_`tdebt`td''_SBIF)-max(0,df_`tdebt`td''_EFH)
capture replace abs_error_amount = abs(error_amount)
}
capture drop `default_vsbif'`td'_`kd3' 
foreach kd2 of numlist -1 1 -2 2 {  //forv kd2=-2/2 {
local kd3=`kd1'+`kd2'
capture egen `default_vsbif'`td'_`kd3' = rowmax(`default_vsbif'`td'_*_`kd3')
capture replace abs_error_amount2 = abs(max(0,`default_vsbif'`td'_`kd3')-max(0,df_`tdebt`td''_EFH))
capture replace df_`tdebt`td''_SBIF = `default_vsbif'`td'_`kd3' if deuda_`tdebt`td''_SBIF==1 & abs_error_amount>abs_error_amount2 & `default_vsbif'`td'_`kd3'<. & date_survey==`kd1'
foreach var1 of local df_types2 {  //   ReConsider Other definitions of EFH default //
replace df_`tdebt`td''_EFH = 1 if df_`tdebt`td''_SBIF==1 & `var1'==1 & deuda_`tdebt`td''_EFH==1 //replace df_`tdebt`td''_EFH = 0 if df_`tdebt`td''_SBIF==0 & `var1'==0 & deuda_`tdebt`td''_EFH==1
}
if ${df_types0}==1 { 
foreach var1 of local df_types {  //   ReConsider Other definitions of SBIF default //
egen `var1' = rowmax(`var1'`td'_*_`kd3')
replace df_`tdebt`td''_SBIF = 1 if df_`tdebt`td''_EFH==1 & `var1'==1 & deuda_`tdebt`td''_SBIF==1
replace df_`tdebt`td''_SBIF = 0 if df_`tdebt`td''_EFH==0 & `var1'==0 & deuda_`tdebt`td''_SBIF==1
drop `var1'
}
}
capture replace error_amount = max(0,df_`tdebt`td''_SBIF)-max(0,df_`tdebt`td''_EFH)
capture replace abs_error_amount = abs(error_amount)
forv tn=1/4 {
capture replace df_`tdebt`td''_SBIF = max(0,`default_vsbif'4_`tn'_`kd3') if deuda_`tdebt`td''_SBIF==1 & error_amount<0 & date_survey==`kd1'
capture replace error_amount = max(0,df_`tdebt`td''_SBIF)-max(0,df_`tdebt`td''_EFH)
capture replace abs_error_amount = abs(error_amount)
}
capture drop `default_vsbif'`td'_`kd3' 
}
}
}
}
//   ReConsider Loans from other Non-Interviewed Household members //
quietly {
foreach td of numlist 2 { //replace f10_t`tk'd`dk' = . if f3_t`tk'd`dk'>1 
foreach var1 of local df_types2 {  //   ReConsider Other definitions of EFH default 
replace df_`tdebt`td''_EFH = 1 if df_`tdebt`td''_SBIF==1 & `var1'==1 & deuda_`tdebt`td''_EFH==1
}
foreach var1 of local df_types2 {  //   ReConsider Other definitions of EFH default //replace df_`tdebt`td''_EFH = 1 if df_`tdebt`td''_SBIF==1 & `var1'==1 & deuda_`tdebt`td''_EFH==1 
replace df_`tdebt`td''_EFH = 0 if df_`tdebt`td''_SBIF==0 & `var1'==0 & deuda_`tdebt`td''_EFH==1
}
}
} 

foreach td of numlist 2 { // 1 2 5 (use 2 - just prestamos)
capture replace df_`tdebt`td''_SBIF = . if deuda_`tdebt`td''_SBIF==0 & deuda_`tdebt`td''_EFH==0
g df2_`tdebt`td''_SBIF = df_`tdebt`td''_SBIF 
capture replace df2_`tdebt`td''_SBIF = . if deuda_`tdebt`td''_SBIF==0 | deuda_`tdebt`td''_SBIF==.
capture replace df2_`tdebt`td''_SBIF = . if deuda_`tdebt`td''_EFH==0 | deuda_`tdebt`td''_EFH==.
g df2_`tdebt`td''_EFH = df_`tdebt`td''_EFH
replace df2_`tdebt`td''_EFH = . if df2_`tdebt`td''_SBIF==.  
}
drop error_amount abs_error_amount abs_error_amount2

// Mortgage Credit - SBIF   //
g df_hip_SBIF = 0   
g error_amount = 0
g abs_error_amount = 0
g abs_error_amount2 = 0
quietly  {
forv kd1=`date1'/`date2' {
local kd3=`kd1'
capture egen `default_vsbif'_hip_`kd3' = rowmax(`default_vsbif'6_*_`kd3' `default_vsbif'7_*_`kd3' `default_vsbif'9_*_`kd3' `default_vsbif'10_*_`kd3')
capture replace df_hip_SBIF = `default_vsbif'_hip_`kd3' if hipotecario_SBIF==1 & date_survey==`kd1'
foreach var1 of local df_types3 {  //   ReConsider Other definitions of EFH default //
capture replace df_hip_EFH = 1 if df_hip_SBIF==1 & `var1'==1 & hipotecario_EFH==1 //replace df_hip_EFH = 0 if df_hip_SBIF==0 & `var1'==0 & hipotecario_EFH==1
}
if ${df_types0}==1 { 
foreach var1 of local df_types {  //   ReConsider Other definitions of SBIF default //
egen `var1' = rowmax(`var1'6_*_`kd3' `var1'7_*_`kd3' `var1'9_*_`kd3' `var1'10_*_`kd3')
replace df_hip_SBIF = 1 if df_hip_EFH==1 & `var1'==1 & hipotecario_SBIF==1
replace df_hip_SBIF = 0 if df_hip_EFH==0 & `var1'==0 & hipotecario_SBIF==1
drop `var1'
}
}
capture replace error_amount = max(0,df_hip_SBIF)-max(0,df_hip_EFH)
capture replace abs_error_amount = abs(error_amount)

capture drop `default_vsbif'_hip_`kd3' 
foreach kd2 of numlist -1 1 -2 2 {  //forv kd2=-2/2 {
local kd3=`kd1'+`kd2'
capture egen `default_vsbif'_hip_`kd3' = rowmax(`default_vsbif'6_*_`kd3' `default_vsbif'7_*_`kd3' `default_vsbif'9_*_`kd3' `default_vsbif'10_*_`kd3')
capture replace abs_error_amount2 = abs(max(0,`default_vsbif'_hip_`kd3')-max(0,df_hip_EFH))
capture replace df_hip_SBIF = `default_vsbif'_hip_`kd3' if df_hip_SBIF==1 & abs_error_amount>abs_error_amount2 & `default_vsbif'_hip_`kd3'<. & date_survey==`kd1'
foreach var1 of local df_types3 {  //   ReConsider Other definitions of EFH default //
capture replace df_hip_EFH = 1 if df_hip_SBIF==1 & `var1'==1 & hipotecario_EFH==1 //replace df_hip_EFH = 0 if df_hip_SBIF==0 & `var1'==0 & hipotecario_EFH==1
}
if ${df_types0}==1 { 
foreach var1 of local df_types {  //   ReConsider Other definitions of SBIF default //
egen `var1' = rowmax(`var1'6_*_`kd3' `var1'7_*_`kd3' `var1'9_*_`kd3' `var1'10_*_`kd3')
replace df_hip_SBIF = 1 if df_hip_EFH==1 & `var1'==1 & hipotecario_SBIF==1
replace df_hip_SBIF = 0 if df_hip_EFH==0 & `var1'==0 & hipotecario_SBIF==1
drop `var1'
}
}
capture replace error_amount = max(0,df_hip_SBIF)-max(0,df_hip_EFH)
capture replace abs_error_amount = abs(error_amount)
capture drop `default_vsbif'_hip_`kd3' 
}
}
}
foreach var1 of local df_types3 {  //   ReConsider Other definitions of EFH default 
capture replace df_hip_EFH = 1 if df_hip_SBIF==1 & `var1'==1 & hipotecario_EFH==1
}
foreach var1 of local df_types3 {  //   ReConsider Other definitions of EFH default //replace df_hip_EFH = 1 if df_hip_SBIF==1 & `var1'==1 & hipotecario_EFH==1 
capture replace df_hip_EFH = 0 if df_hip_SBIF==0 & `var1'==0 & hipotecario_EFH==1
}
foreach x of varlist df_hip_SBIF {
replace `x'=. if hipotecario_SBIF==. & hipotecario_EFH==. //replace `x'=. if hipotecario_SBIF==0 
replace `x'=. if hipotecario_SBIF==0 & hipotecario_EFH==0
capture replace `x' = . if possible_prior_mortgage==1 //blc
}
g df2_hip_SBIF = df_hip_SBIF
capture replace df2_hip_SBIF = . if hipotecario_SBIF==0 | hipotecario_SBIF==.
capture replace df2_hip_SBIF = . if hipotecario_EFH==0 | hipotecario_EFH==.
g df2_hip_EFH = df_hip_EFH
replace df2_hip_EFH = . if df2_hip_SBIF==.
drop error_amount abs_error_amount abs_error_amount2

//  Errors of EFH vs SBIF
local debt_types3 "hipotecario banco prestamo tarjeta"
foreach x of local debt_types2 {
g error_`x'_df = max(0,df_`x'_SBIF) - max(0,df_`x'_EFH) if df_`x'_SBIF<. | df_`x'_EFH<.  
if ${Ratio_op}==1 { //ln( (abs(error_`x'_monto)+ 1) )  //+ r(min)
g mean_var = ( max(0,df_`x'_EFH ) + max(0,df_`x'_SBIF ) )/2 
g error_ratio_df_`x' =  abs(error_`x'_df)/mean_var 
g error_ratio0_df_`x' =  error_`x'_df/mean_var 
drop mean_var
}
else  {
g error_ratio_df_`x' =  abs(error_`x'_df)/df_`x'_SBIF  
replace error_ratio_df_`x' =  abs(error_`x'_df)/df_`x'_EFH if error_ratio_df_`x'==.                    
}
}      
save "$path_s1\EFH_SBIF_wide_${yk}.dta", replace
