use "$path_s1\EFH_SBIF_wide_${yk}.dta", clear
// Hipotecario de vivienda: *6 Hipotecario en letras de crdito *7 Mutuo hipotecario endosable
// 8 Hipotecario comprado a ANAP(No Usar) *9 Mutuo hipotecario no endosable *10 Otros crditos hipotecarios
global unknown_institution_op = 0  // if 0 - do not count loans if it is unknown whether it comes from a bank
// if 1 count unknown institutions (No Sabe, No Responde) as a Bank
global complementario_op = 1  // 1 - If there are creditos complementarios in EFH, include them if it fits better SBIF data
global divorce_op = 1  // 1 - Exclude divorced people with debt in SBIF and no debt in EFH
global UF_op = 1  // 0 - Use UF of year of the mortgage, 1 - Use UF of current year (this is what SBIF reports)
if ${yk}==11 {
local mvars "m1 m2 m3"
local Mano = "e22_h_a"
local Mmes = "e22_h_m"
local Mb0 = "e12"
local Mb = "e13"
local Mb2 = "e14"
local Mbano0 = "e25_h"
local MbanoP = "e25_h_a"
local MbmesP = "e25_h_m"
local CMbano0 = "e25_hc"
local CMbanoP = "e25_hc_a"
local CMbmesP = "e25_hc_m"
local OMano0 = "e52_h"
local OManoP = "e52_h_a"
local OMmesP = "e52_h_m"
local OCMano0 = "e52_c"
local OCManoP = "e52_c_a"
local OCMmesP = "e52_c_m"
local Mbano = "e26_h_a"
local Mbmes = "e26_h_m"
local CM0 = "e20"
local CMano = "e26_hc_a"
local CMmes = "e26_hc_m"
local OM "e40"
local OM1 "e41"
local OM2 "e42"
local OMano "e53_h_a"
local OMmes "e53_h_m"
local OCM "e38"
local OCMano "e53_c_a"
local OCMmes "e53_c_m"
local CMmonto "e21"
local Oano = "e49_h_a"
local Omes = "e49_h_m"
local OPano = "e34"
local OMmonto "e48_h"
local OCMmonto "e48_c"
local Mdiv "e27"  
local OMdiv "e54" 
}
if ${yk}==14 {
g a7=a5
local mvars "n1"
local Mano = "e20_ano"
local Mmes = "e20_mes"
local Mb0 = "e14_3"
local Mb = "e18"
local Mb2 = "e36"
local Mbano0 = "e32"
local MbanoP = "e33_ano"
local MbmesP = "e33_mes"
local CMbano0 = "e40"
local CMbanoP = "e42_ano"
local CMbmesP = "e42_mes"
local OMano0 = "e69"
local OManoP = "e70_ano"
local OMmesP = "e70_mes"
local OCMano0 = "e77"
local OCManoP = "e79_ano"
local OCMmesP = "e79_mes"
local Mbano = "e34_ano"
local Mbmes = "e34_mes"
local CM0 = "e14_4"
local CMano = "e43_ano"
local CMmes = "e43_mes"
local OM "e52_3"
local OM1 "e55"
local OM2 "e73" //"e63" is also good alternative
local OMano "e71_ano"
local OMmes "e71_mes"
local OCM "e52_4" //"e78" is good alternative 
local OCMano "e80_ano"
local OCMmes "e80_mes"
local CMmonto "e39"
local Oano = "e57_ano"
local Omes = "e57_mes"
local OPano = "e49"
local OMmonto "e56"
local OCMmonto "e76"
local Mdiv "e35"  //local CMdiv "e44"
local OMdiv "e72" //local OCMdiv "e81"
rename e19t  e19_t
rename e39t  e39_t
rename e35t e35_t  //rename e44t e44_t
foreach var of varlist e32 e33_* e34_* e40* e42_* e43_* e69* e70* e71* e77* e79* e80* e19* e39* e49* e57* e56* e76* e35* e44* e35* e72* {
replace `var'=. if `var'<0
}
replace e34_ano = e32-e33_ano if e32>=e33_ano & e34_ano==.
replace e34_mes = 12-e33_mes if e33_mes<12
replace e34_ano = e34_ano-1 if e33_mes==12 & e34_ano>=1 
replace e43_ano = e40-e42_ano if e40>=e42_ano
replace e43_mes = 12-e42_mes if e42_mes<12
replace e43_ano = e43_ano-1 if e42_mes==12 & e43_ano>=1
forval dk = 1/3 { 
rename e56_pesos_`dk' e56_p_`dk'
rename e56t_`dk' e56_t_`dk'
rename e76_pesos_`dk' e76_p_`dk'
rename e76t_`dk' e76_t_`dk'
rename e72t_`dk' e72_t_`dk'
replace e71_ano_`dk' = e69_`dk'-e70_ano_`dk' if e69_`dk'>=e70_ano_`dk'
replace e71_mes_`dk' = 12-e70_mes_`dk' if e70_mes_`dk'<12
replace e71_ano_`dk' = e71_ano_`dk'-1 if e70_mes_`dk'==12 & e71_ano_`dk'>=1
replace e80_ano_`dk' = e77_`dk'-e79_ano_`dk' if e77_`dk'>=e79_ano_`dk'
replace e80_mes_`dk' = 12-e79_mes_`dk' if e79_mes_`dk'<12
replace e80_ano_`dk' = e80_ano_`dk'-1 if e79_mes_`dk'==12 & e80_ano_`dk'>=1
}
}
if ${yk}==17 {
g a7=a6
local mvars "n1"
local Mano = "e7_ano"
local Mmes = "e7_mes"
local Mb0 = "e9_3"
local Mb = "e13"
local Mb2 = "e29"
local Mbano0 = "e25"
local MbanoP = "e26_ano"
local MbmesP = "e26_mes"
local CMbano0 = "e34"
local CMbanoP = "e35_ano"
local CMbmesP = "e35_mes"
local OMano0 = "e66"
local OManoP = "e67_ano"
local OMmesP = "e67_mes"
local OCMano0 = "e75"
local OCManoP = "e76_ano"
local OCMmesP = "e76_mes"
local Mbano = "e27_ano"
local Mbmes = "e27_mes"
local CM0 = "e9_4"
local CMano = "e36_ano"
local CMmes = "e36_mes"
local OM "e52_3"
local OM1 "e55"
local OM2 "e70" //"e63" is also good alternative
local OMano "e68_ano"
local OMmes "e68_mes"
local OCM "e52_4" //"e78" is good alternative 
local OCMano "e77_ano"
local OCMmes "e77_mes"
local CMmonto "e39"
local Oano = "e59_ano"
local Omes = "e59_mes"
local OPano = "e49_ano"
local OMmonto "e57"
local OCMmonto "e73"
local Mdiv "e28"  //local CMdiv "e44"
local OMdiv "e69" //local OCMdiv "e81"
capture rename e15t  e15_t
capture rename e39t  e39_t
capture rename e28t e28_t  //rename e44t e44_t
foreach var of varlist e* {
capture replace `var'=. if `var'<0
}
/*replace `Mbano'_ano = e32-e33_ano if e32>=e33_ano & `Mbano'==.
replace `Mbmes' = 12-e33_mes if e33_mes<12
replace `Mbano' = e34_ano-1 if e33_mes==12 & `Mbano'>=1 
replace `Cmano' = e40-`CMbanoP' if e40>=`CMbanoP'
replace `Cmmes' = 12-`CMbmesP' if `CMbmesP'<12
replace `Cmano' = `Cmano'-1 if `CMbmesP'==12 & `Cmano'>=1*/
forval dk = 1/3 { 
rename `OMmonto'_pesos_`dk' `OMmonto'_p_`dk'
rename `OMmonto't_`dk' `OMmonto'_t_`dk'
rename `OCMmonto'_pesos_`dk' `OCMmonto'_p_`dk'
rename `OCMmonto't_`dk' `OCMmonto'_t_`dk'
rename `OMdiv't_`dk' `OMdiv'_t_`dk'
/*replace e71_ano_`dk' = e69_`dk'-e70_ano_`dk' if e69_`dk'>=e70_ano_`dk'
replace e71_mes_`dk' = 12-e70_mes_`dk' if e70_mes_`dk'<12
replace e71_ano_`dk' = e71_ano_`dk'-1 if e70_mes_`dk'==12 & e71_ano_`dk'>=1
replace e77_ano_`dk' = e77_`dk'-`OCManoP'_ano_`dk' if e77_`dk'>=`OCManoP'_ano_`dk'
replace e77_mes_`dk' = 12-`OCManoP'_mes_`dk' if `OCManoP'_mes_`dk'<12
replace 77_ano_`dk' = e77_ano_`dk'-1 if `OCManoP'_mes_`dk'==12 & e77_ano_`dk'>=1*/
}
}
//
//
// Mortgage Debt - EFH
if ${unknown_institution_op}==1 {
recode `Mb' 7/.=2
}
g hipotecario_1_EFH = (`Mb0'==1 & `Mb'==2 & `Mb2'<=3) //g cred_hip=(`Mb0'==1)  g cred_hip_inst=(`Mb'==2)
replace hipotecario_1_EFH = (`Mb0'==1 & `Mb'==2 & `Mbano'>0 & `Mbano'<90) if hipotecario_1_EFH==0 | hipotecario_1_EFH==.  //if ${complementario_op}==1 { }
replace hipotecario_1_EFH = (`Mb0'==1 & `Mb'==2 & `Mbmes'>0 & `Mbmes'<90) if hipotecario_1_EFH==0 | hipotecario_1_EFH==.
g complementario_1_EFH = (`CM0'==1 & `CMano'>0 & `CMano'<90)
replace complementario_1_EFH = (`CM0'==1 & `CMmes'>0 & `CMmes'<90) if complementario_1_EFH==0 | complementario_1_EFH==.
if ${yk}==14 {
replace complementario_1_EFH = 1 if e41==1
}
forval dk = 1/3 {
local dk2 = `dk'+1
g hipotecario_`dk2'_EFH = (`OM'_`dk'==1  & `OM1'_`dk'==2 & `OM2'_`dk'<=3)
replace hipotecario_`dk2'_EFH = (`OM'_`dk'==1 & `OM1'_`dk'==2 & `OMano'_`dk'>0 & `OMano'_`dk'<90) if hipotecario_`dk2'_EFH==0 | hipotecario_`dk2'_EFH==.
replace hipotecario_`dk2'_EFH = (`OM'_`dk'==1 & `OM1'_`dk'==2 & `OMmes'_`dk'>0 & `OMmes'_`dk'<90) if hipotecario_`dk2'_EFH==0 | hipotecario_`dk2'_EFH==.
g complementario_`dk2'_EFH = (`OCM'_`dk'==1 & `OCMano'_`dk'>0 & `OCMano'_`dk'<90)
replace complementario_`dk2'_EFH = (`OCM'_`dk'==1 & `OCMmes'_`dk'>0 & `OCMmes'_`dk'<90) if complementario_`dk2'_EFH==0 | complementario_`dk2'_EFH==.
if ${yk}==14 {
replace complementario_`dk2'_EFH = 1 if e78_`dk'==1
}
}
egen hipotecario_EFH = rowmax(hipotecario_1_EFH hipotecario_2_EFH hipotecario_3_EFH hipotecario_4_EFH)
egen complementario_EFH = rowmax(complementario_1_EFH complementario_2_EFH complementario_3_EFH complementario_4_EFH)
egen n_hip = rowtotal(hipotecario_*_EFH)  /* if ${yk}==11 { g n_hip=0 foreach x of varlist div_m div_m1 div_m2 div_m3 { replace n_hip=n_hip+1  if `x'>0 & `x'<. } }  */

// Initial Year of Purchase or Mortgage Credit - sum e4 e5 e22*
capture drop year month  //rename year year_efh  //rename month month_efh
capture drop year
g year = `Mano' if `Mano'>1800 & `Mano'<2100
g month = `Mmes' if `Mmes'>0 & `Mmes'<13
if ${yk}==11 {
replace year = e22_hc_a if e22_hc_a>1800 & e22_hc_a<2100 & year==.
replace year = e4 if e4>1800 & e4<2100 & year==.
replace year = e5 if e5>1800 & e5<2100 & year==.
replace month = e22_hc_m if e22_hc_m>0 & e22_hc_m<13 & month==.
}
replace year = year_survey if year==. & hipotecario_1_EFH==1
replace year = max(1978,year) if year<.
replace month = meses_survey if month==.  & hipotecario_1_EFH==1
if ${UF_op}==1 {
g year_mortgage_1_EFH = year
g month_mortgage_1_EFH = month
replace year=year_survey
replace month = meses_survey
}
g quarter = ceil(month/3)
joinby year month using "$path_s2\base_uf_month.dta", unmatched(master) update //joinby year quarter using "$path_s1\base_uf_trim.dta", unmatched(master) update   //joinby year month using "$path_bs_do\data\base_uf.dta", unmatched(master) update
tab _merge
drop _merge 

// Loan Amounts and Financial Charge in EFH (e19_p, e19_uf, e19_t are the same in 2011, 2014)
g hip_uf = uf*e19_uf if e19_uf>=100   //sum e19*
capture pwcorr e19_p hip_uf if e19_p>=100
g hipotecario_m_1_EFH = (e19_p+hip_uf)/2 if e19_p>=100  
replace hipotecario_m_1_EFH = e19_p if hipotecario_m_1_EFH==. & e19_p>=100
replace hipotecario_m_1_EFH = hip_uf if hipotecario_m_1_EFH==.
recode e19_t 1=2.5 2=7.5 3=15 4=25 5=35 6=45 7=62.5 8=87.5 9=115 10=145 11=180 12=225 13=275 14=350 15=450 16=750 91/99=.
replace hipotecario_m_1_EFH = e19_t*1000000 if hipotecario_m_1_EFH==. 
if ${yk}==14 {
replace hipotecario_m_1_EFH = e19 if hipotecario_m_1_EFH==. & e19>0
pwcorr hipotecario_m_1_EFH e19
}
replace hip_uf = uf*`CMmonto'_uf if `CMmonto'_uf>=10
g complementario_m_1_EFH = (`CMmonto'_p+hip_uf)/2 if `CMmonto'_p>=100
replace complementario_m_1_EFH = `CMmonto'_p if `CMmonto'_p>=100 & complementario_m_1_EFH==.
replace complementario_m_1_EFH = hip_uf if complementario_m_1_EFH==.
recode `CMmonto'_t 1=2.5 2=7.5 3=15 4=25 5=35 6=45 7=62.5 8=87.5 9=115 10=145 11=180 12=225 13=275 14=350 15=450 16=750 91/99=.
replace complementario_m_1_EFH = `CMmonto'_t*1000000 if complementario_m_1_EFH==.

quietly {  
forval dk = 1/3 {  // g hipotecario_m_`dk2'_EFH =   //sum `OMmonto'_*   // g complementario_m_`dk2'_EFH =  //sum `OCMmonto'_*
local dk2=1+`dk'
capture drop uf month year quarter
g year = `Oano'_`dk' if `Oano'_`dk'>1800 & `Oano'_`dk'<2100
replace year = `OPano'_`dk' if `OPano'_`dk'>1800 & `OPano'_`dk'<2100 & year==.
g month = `Omes'_`dk' if `Omes'_`dk'>0 & `Omes'_`dk'<13
if ${yk}==11 {
replace year =e49_c_a_`dk' if e49_c_a_`dk'>1800 & e49_c_a_`dk'<2100 & year==.
replace month = e49_c_m_`dk' if e49_c_m_`dk'>0 & e49_c_m_`dk'<13 & month==.
replace year =e49_o_a_`dk' if e49_o_a_`dk'>1800 & e49_o_a_`dk'<2100 & year==.
replace month = e49_o_m_`dk' if e49_o_m_`dk'>0 & e49_o_m_`dk'<13 & month==.
}
replace year = year_survey if year==.
replace year = max(1978,year)
replace month = meses_survey if month==.
if ${UF_op}==1 {
g year_mortgage_`dk2'_EFH = year
g month_mortgage_`dk2'_EFH = month
replace year=year_survey
replace month = meses_survey
}
g quarter = ceil(month/3) //joinby year month using "$path_bs_do\data\base_uf.dta", unmatched(master) update
joinby year quarter using "$path_s1\base_uf_trim.dta", unmatched(master) update   //joinby year month using "$path_bs_do\data\base_uf.dta", unmatched(master) update
drop _merge 
replace hip_uf = uf*`OMmonto'_uf_`dk' if `OMmonto'_uf_`dk'>=10 
if ${unknown_institution_op}==1 {
recode `OM1'_`dk' 7/.=2
}
recode `OMmonto'_t_`dk' 1=2.5 2=7.5 3=15 4=25 5=35 6=45 7=62.5 8=87.5 9=115 10=145 11=180 12=225 13=275 14=350 15=450 16=750 91/99=.
g hipotecario_m_`dk2'_EFH = (hip_uf+`OMmonto'_p_`dk')/2 if `OMmonto'_p_`dk'>=100 & `OM1'_`dk'==2
replace hipotecario_m_`dk2'_EFH = `OMmonto'_p_`dk' if `OMmonto'_p_`dk'>=100 & hipotecario_m_`dk2'_EFH==. & `OM1'_`dk'==2
replace hipotecario_m_`dk2'_EFH = hip_uf if hipotecario_m_`dk2'_EFH==. & `OM1'_`dk'==2
replace hipotecario_m_`dk2'_EFH = `OMmonto'_t_`dk'*1000000 if hipotecario_m_`dk2'_EFH==. & `OM1'_`dk'==2

recode `OCMmonto'_t_`dk' 1=2.5 2=7.5 3=15 4=25 5=35 6=45 7=62.5 8=87.5 9=115 10=145 11=180 12=225 13=275 14=350 15=450 16=750 91/99=.
replace hip_uf = uf*`OCMmonto'_uf_`dk' if `OCMmonto'_uf_`dk'>=10
g complementario_m_`dk2'_EFH = (hip_uf+`OCMmonto'_p_`dk')/2 if `OCMmonto'_p_`dk'>=100 & `OM1'_`dk'==2
replace complementario_m_`dk2'_EFH = `OCMmonto'_p_`dk' if `OCMmonto'_p_`dk'>=100 & complementario_m_`dk2'_EFH==. & `OM1'_`dk'==2
replace complementario_m_`dk2'_EFH = hip_uf if complementario_m_`dk2'_EFH==. & `OM1'_`dk'==2
replace complementario_m_`dk2'_EFH = `OCMmonto'_t_`dk'*1000000 if complementario_m_`dk2'_EFH==. & `OM1'_`dk'==2
//
if ${yk}==11 {
recode e48_o_t_`dk' 1=2.5 2=7.5 3=15 4=25 5=35 6=45 7=62.5 8=87.5 9=115 10=145 11=180 12=225 13=275 14=350 15=450 16=750 91/99=.
replace hip_uf = uf*e48_o_uf_`dk' if e48_o_uf_`dk'>=10
replace complementario_m_`dk2'_EFH = (hip_uf+e48_o_p_`dk')/2 if e48_o_p_`dk'>=100 & `OM1'_`dk'==2 & complementario_m_`dk2'_EFH==. 
replace complementario_m_`dk2'_EFH = e48_o_p_`dk' if e48_o_p_`dk'>=100 & complementario_m_`dk2'_EFH==. & `OM1'_`dk'==2
replace complementario_m_`dk2'_EFH = hip_uf if complementario_m_`dk2'_EFH==. & `OM1'_`dk'==2
replace complementario_m_`dk2'_EFH = e48_o_t_`dk'*1000000 if complementario_m_`dk2'_EFH==. & `OM1'_`dk'==2
}
}
}
quietly {
forval dk = 1/4 {
replace hipotecario_m_`dk'_EFH= . if hipotecario_`dk'_EFH==0
replace complementario_m_`dk'_EFH = . if complementario_`dk'_EFH==0
replace hipotecario_m_`dk'_EFH= . if hipotecario_m_`dk'_EFH<=0
replace complementario_m_`dk'_EFH = . if complementario_m_`dk'_EFH<=0
}
}
capture drop uf month year quarter
egen deuda_m_hipotecario_EFH = rowtotal(hipotecario_m_*), missing
egen deuda_m_complementario_EFH = rowtotal(complementario_m_*), missing
capture g deuda_m_EFH = max(0,deuda_m_banco_EFH) + max(0,deuda_m_hipotecario_EFH) + max(0,deuda_m_complementario_EFH)  if deuda_m_banco_EFH<. | deuda_m_hipotecario_EFH<.  | deuda_m_complementario_EFH<.

// Financial Charge (Dividendo) Hipotecario
sum `Mdiv'* `OMdiv'*
recode `Mdiv'_t 1=7.5 2=32.5 3=60 4=85 5=125 6=175 7=225 8=275 9=350 10=450 11=550 12=650 13=750 14=900 15=1125 16=1375 17=1750 18=2500
replace `Mdiv'=`Mdiv'_t*1000 if `Mdiv'==. | `Mdiv'<=100
forval dk = 1/3 { 
recode `OMdiv'_t_`dk' 1=7.5 2=32.5 3=60 4=85 5=125 6=175 7=225 8=275 9=350 10=450 11=550 12=650 13=750 14=900 15=1125 16=1375 17=1750 18=2500
replace `OMdiv'_`dk'=`OMdiv'_t_`dk'*1000 if `OMdiv'_`dk'==. | `OMdiv'_`dk'<=100
}
egen cuota_hipotecario_EFH = rowtotal(`Mdiv' `OMdiv'_1 `OMdiv'_2 `OMdiv'_3), missing
capture g cuota_EFH = max(0,cuota_banco_EFH) + max(0,cuota_hipotecario_EFH) if cuota_banco_EFH<. | cuota_hipotecario_EFH<.

//  Loan Maturities in EFH 
recode `Mbano0' 91/.=.
recode `CMbano0' 91/.=.
recode `Mbmes' 13/.=.  
recode `MbmesP' 13/.=.
recode `CMmes' 13/.=.
recode `CMbmesP' 13/.=.
g madurez_hipotecario_1_EFH = 12*`Mbano0' if hipotecario_1_EFH==1 // madurez_hipotecario_1_EFH  madurez_hipotecario_res_1_EFH  // sum e25* e26*
g madurez_complementario_1_EFH = 12*`CMbano0' if complementario_1_EFH==1 
g madurez_hipotecario_res_1_EFH = 12*`Mbano' if `Mbano'<91
replace madurez_hipotecario_res_1_EFH = max(0,madurez_hipotecario_res_1_EFH) + max(0,`Mbmes') 
replace madurez_hipotecario_res_1_EFH = max(0,madurez_hipotecario_1_EFH)-12*max(0,`MbanoP')-max(0,`MbmesP') if (madurez_hipotecario_res_1_EFH==0 | madurez_hipotecario_res_1_EFH==.) & `MbanoP'<91 
replace madurez_hipotecario_res_1_EFH = . if madurez_hipotecario_res_1_EFH<=0
g madurez_complementario_res_1_EFH = 12*`CMano' if `CMano'<91
replace madurez_complementario_res_1_EFH = max(0,madurez_complementario_res_1_EFH) + max(0,`CMmes') 
replace madurez_complementario_res_1_EFH = max(0,madurez_complementario_1_EFH)-12*max(0,`CMbanoP')-max(0,`CMbmesP') if (madurez_complementario_res_1_EFH==0 | madurez_complementario_res_1_EFH==.) & `CMbanoP'<91 
replace madurez_complementario_res_1_EFH = . if madurez_complementario_1_EFH<=0
quietly { //sum `Mbano0' `CMbano0' `OMano0'_1 `OCMano0'_1 `OMano'_1 `OMmes'_1 `OManoP'_1 `OMmesP'_1 tab `OMano'_1 tab `OManoP'_1 tab `Mbano0' tab `MbanoP'
forval dk = 1/3 {  // madurez_hipotecario_`dk2'_EFH  madurez_hipotecario_res_`dk2'_EFH  // sum e52* e53*
local dk2=1+`dk'
recode `OMano0'_`dk' 91/.=.  // Mistakes must be here: `OMano'_`dk',`OMmes'_`dk', `OManoP'_`dk',`OMmesP'_`dk'
recode `OCMano0'_`dk' 91/.=.  //recode `OManoP'_`dk' 91/.=. //recode `OCManoP'_`dk' 91/.=.
recode `OMano'_`dk' 2101/.=.
recode `OMmes'_`dk' 13/.=.
recode `OMmesP'_`dk' 13/.=.
recode `OCMmesP'_`dk' 13/.=.
capture g madurez_hipotecario_`dk2'_EFH = 12*`OMano0'_`dk' 
capture g madurez_complementario_`dk2'_EFH = 12*`OCMano0'_`dk' 
 
capture g madurez_hipotecario_res_`dk2'_EFH = 12*max(0,`OMano'_`dk')+max(0,`OMmes'_`dk') if `OMano'_`dk'<91
replace madurez_hipotecario_res_`dk2'_EFH = max(0,madurez_hipotecario_`dk2'_EFH)-12*max(0,`OManoP'_`dk')-max(0,`OMmesP'_`dk') if (madurez_hipotecario_res_`dk2'_EFH==0 | madurez_hipotecario_res_`dk2'_EFH==.) & `OManoP'_`dk'<91

capture g madurez_complementario_res_`dk2'_EFH = 12*max(0,`OCMano'_`dk')+max(0,`OCMmes'_`dk') if `OCMano'_`dk'<91
replace madurez_complementario_res_`dk2'_EFH = max(0,madurez_complementario_`dk2'_EFH)-12*max(0,`OCManoP'_`dk')-max(0,`OCMmesP'_`dk') if (madurez_complementario_res_`dk2'_EFH==0 | madurez_complementario_res_`dk2'_EFH==.) & `OCManoP'_`dk'<91
if ${yk}==11 {
recode e52_o_`dk' 91/.=.
recode e53_o_a_`dk' 91/.=.
recode e52_o_a_`dk' 91/.=.
recode e53_o_m_`dk'  13/.=.
recode e52_o_m_`dk' 13/.=.
capture replace madurez_complementario_`dk2'_EFH = 12*e52_o_`dk' if madurez_complementario_`dk2'_EFH==.
replace madurez_complementario_res_`dk2'_EFH = 12*max(0,e53_o_a_`dk')+max(0,e53_o_m_`dk') if (madurez_complementario_res_`dk2'_EFH==0 | madurez_complementario_res_`dk2'_EFH==.) & e53_o_a_`dk'<91
replace madurez_complementario_res_`dk2'_EFH = max(0,madurez_complementario_`dk2'_EFH)-12*max(0,e52_o_a_`dk')-max(0,e52_o_m_`dk') if (madurez_complementario_res_`dk2'_EFH==0 | madurez_complementario_res_`dk2'_EFH==.) & e52_o_a_`dk'<91
}
replace madurez_hipotecario_`dk2'_EFH = . if hipotecario_`dk2'_EFH<=0 
replace madurez_hipotecario_res_`dk2'_EFH = . if hipotecario_`dk2'_EFH<=0 
replace madurez_hipotecario_res_`dk2'_EFH = . if madurez_hipotecario_res_`dk2'_EFH<=0 
replace madurez_complementario_`dk2'_EFH = . if complementario_`dk2'_EFH<=0 
replace madurez_complementario_res_`dk2'_EFH = . if complementario_`dk2'_EFH<=0 
replace madurez_complementario_res_`dk2'_EFH = . if madurez_complementario_res_`dk2'_EFH<=0 
}
}
forval dk = 1/4 {
g wh`dk' = max(0,hipotecario_m_`dk'_EFH /deuda_m_hipotecario_EFH)
g wc`dk' = max(0,complementario_m_`dk'_EFH /deuda_m_complementario_EFH)
}
g madurez_hipotecario_EFH = wh1*max(0,madurez_hipotecario_1_EFH) + wh2*max(0,madurez_hipotecario_2_EFH) + wh3*max(0,madurez_hipotecario_3_EFH) +  wh4*max(0,madurez_hipotecario_4_EFH)
g madurez_hipotecario_res_EFH = wh1*max(0,madurez_hipotecario_res_1_EFH) + wh2*max(0,madurez_hipotecario_res_2_EFH) + wh3*max(0,madurez_hipotecario_res_3_EFH) +  wh4*max(0,madurez_hipotecario_res_4_EFH)
g madurez_complementario_EFH = wh1*max(0,madurez_complementario_1_EFH) + wh2*max(0,madurez_complementario_2_EFH) + wh3*max(0,madurez_complementario_3_EFH) +  wh4*max(0,madurez_complementario_4_EFH)
g madurez_complementario_res_EFH = wh1*max(0,madurez_complementario_res_1_EFH) + wh2*max(0,madurez_complementario_res_2_EFH) + wh3*max(0,madurez_complementario_res_3_EFH) +  wh4*max(0,madurez_complementario_res_4_EFH)
foreach var of varlist madurez_hipotecario_EFH-madurez_complementario_res_EFH deuda_m_hipotecario_EFH deuda_m_complementario_EFH {
replace `var' =. if `var'<=0
}
foreach var of varlist madurez_hipotecario* madurez_complementario* {
replace `var' = ceil(`var')
}
foreach var of varlist madurez_hipotecario_*EFH {
replace `var' =. if hipotecario_EFH==0
}
foreach var of varlist madurez_complementario_*EFH {
replace `var' =. if complementario_EFH==0
}
drop wh1-wc4 
sum madurez_hipotecario_EFH madurez_hipotecario_res_EFH madurez_complementario_EFH madurez_complementario_res_EFH [fw=${factor_op}], d

// SBIF Mortgage Debts
// Hipotecario de vivienda: *6 Hipotecario en letras de crdito *7 Mutuo hipotecario endosable
// 8 Hipotecario comprado a ANAP(No Usar) *9 Mutuo hipotecario no endosable *10 Otros crditos hipotecarios
egen nr_mortgages_EFH = rowtotal(hipotecario_1_EFH hipotecario_2_EFH hipotecario_3_EFH hipotecario_4_EFH) //rownonmiss
tab nr_mortgages_EFH
tab nr_mortgages_EFH n_hip

sum date_survey
local date1 = r(min) //${date1}
local date2 = r(max) //${date2}
g hipotecario_SBIF = 0   // Hipotecario: *6 al *10 (but 8 does not exist)
g nr_mortgages_SBIF  = 0
g error_nr_m = 0
g error_nr_m2 = 0
quietly  {
forv kd1=`date1'/`date2' {
local kd3=`kd1'
capture egen c_nor_hip = rowmax(c_nor6_1_`kd3' c_nor7_1_`kd3' c_nor9_1_`kd3' c_nor10_1_`kd3')
capture replace c_nor_hip = . if c_nor_hip<=0
capture replace hipotecario_SBIF = 1 if c_nor_hip<. & date_survey==`kd1'
capture egen nr_m_SBIF = rownonmiss(c_nor6_1_`kd3' c_nor7_1_`kd3' c_nor9_1_`kd3' c_nor10_1_`kd3') //rownonmiss
capture replace nr_mortgages_SBIF = nr_m_SBIF if nr_m_SBIF<. & date_survey==`kd1'
capture replace error_nr_m = max(0,abs(nr_mortgages_SBIF-nr_mortgages_EFH))
capture egen nr_m`kd3'_SBIF = rownonmiss(c_nor6_1_`kd3' c_nor7_1_`kd3' c_nor9_1_`kd3' c_nor10_1_`kd3') //rownonmiss
capture drop c_nor_hip nr_m_SBIF
foreach kd2 of numlist -1 1 -2 2 {  //forv kd2=-2/2 {
local kd3=`kd1'+`kd2'
capture egen c_nor_hip = rowmax(c_nor6_1_`kd3' c_nor7_1_`kd3' c_nor9_1_`kd3' c_nor10_1_`kd3')
capture replace c_nor_hip = . if c_nor_hip<=0
capture replace hipotecario_SBIF = 0 if c_nor_hip==. & hipotecario_EFH==0 & date_survey==`kd1'
capture replace hipotecario_SBIF = 1 if c_nor_hip<. & hipotecario_EFH==1 & date_survey==`kd1'
capture egen nr_m_SBIF = rownonmiss(c_nor6_1_`kd3' c_nor7_1_`kd3' c_nor9_1_`kd3' c_nor10_1_`kd3') //rownonmiss
capture replace error_nr_m2 = max(0, abs(nr_m_SBIF-nr_mortgages_EFH))
capture replace nr_mortgages_SBIF = nr_m_SBIF if nr_m_SBIF<. & date_survey==`kd1' & error_nr_m2<error_nr_m
capture replace error_nr_m = max(0,abs(nr_mortgages_SBIF-nr_mortgages_EFH))
capture drop c_nor_hip nr_m_SBIF
}
}
}
if ${complementario_op}==1 { // 1 - If there are creditos complementarios in EFH, include them if it fits better SBIF data
replace hipotecario_EFH = 1 if hipotecario_SBIF==1 & complementario_EFH==1
replace hipotecario_1_EFH = 1 if hipotecario_SBIF==1 & complementario_1_EFH==1
}
g possible_prior_mortgage = .
if ${divorce_op}==1 { // 1 - If there are divorces in EFH, exclude them if it fits better SBIF data
g separated_divorced = 0
replace separated_divorced = 1 if a7==8
replace separated_divorced = 1 if a7>=3 & a7<=6 
replace possible_prior_mortgage = 1 if hipotecario_SBIF==1 & hipotecario_EFH==0 & separated_divorced==1
replace possible_prior_mortgage = 1 if hipotecario_SBIF==0 & hipotecario_EFH==1 & separated_divorced==1 & sexo==0
replace hipotecario_SBIF=. if possible_prior_mortgage==1
capture replace error_nr_m2 = . if possible_prior_mortgage==1
capture replace nr_mortgages_SBIF = . if possible_prior_mortgage==1
capture replace error_nr_m = . if possible_prior_mortgage==1
}
capture egen nr_mortgages_SBIF_all = rowmax(nr_m*_SBIF) //rownonmiss
drop error_nr_m error_nr_m2

// Loan Amounts - SBIF   //
g deuda_m_hipotecario_SBIF = 0   
g error_amount = 0
g abs_error_amount = 0
g abs_error_amount2 = 0
quietly  {
forv kd1=`date1'/`date2' {
local kd3=`kd1'
capture egen mo_deu_hip_`kd3' = rowtotal(mo_deu6_*_`kd3' mo_deu7_*_`kd3' mo_deu9_*_`kd3' mo_deu10_*_`kd3')
capture egen c_nor_hip_`kd3' = rowtotal(c_nor6_*_`kd3' c_nor7_*_`kd3' c_nor9_*_`kd3' c_nor10_*_`kd3')
capture replace deuda_m_hipotecario_SBIF = mo_deu_hip_`kd3' if hipotecario_SBIF==1 & date_survey==`kd1'
capture replace error_amount = max(0,deuda_m_hipotecario_SBIF)-max(0,deuda_m_hipotecario_EFH)
capture replace abs_error_amount = abs(error_amount)

capture g mo_deu2_hip_`kd3' = max(mo_deu_hip_`kd3',c_nor_hip_`kd3')
capture replace abs_error_amount2 = abs(max(0,mo_deu2_hip_`kd3')-max(0,deuda_m_hipotecario_EFH))
capture replace deuda_m_hipotecario_SBIF = mo_deu2_hip_`kd3' if abs_error_amount>abs_error_amount2 & date_survey==`kd1'
capture replace error_amount = max(0,deuda_m_hipotecario_SBIF)-max(0,deuda_m_hipotecario_EFH)
capture replace abs_error_amount = abs(error_amount)
capture drop mo_deu_hip_`kd3' c_nor_hip_`kd3' mo_deu2_hip_`kd3'

foreach kd2 of numlist -1 1 -2 2 {  //forv kd2=-2/2 {
local kd3=`kd1'+`kd2'
capture egen mo_deu_hip_`kd3' = rowtotal(mo_deu6_*_`kd3' mo_deu7_*_`kd3' mo_deu9_*_`kd3' mo_deu10_*_`kd3')
capture egen c_nor_hip_`kd3' = rowtotal(c_nor6_*_`kd3' c_nor7_*_`kd3' c_nor9_*_`kd3' c_nor10_*_`kd3')
capture replace abs_error_amount2 = abs(max(0,mo_deu_hip_`kd3')-max(0,deuda_m_hipotecario_EFH))
capture replace deuda_m_hipotecario_SBIF = mo_deu`td'_`kd3' if abs_error_amount>abs_error_amount2 & date_survey==`kd1' // & mo_deu_hip_`kd3'>0 & mo_deu_hip_`kd3'<. //& deuda_m_hipotecario_SBIF==1
capture replace error_amount = max(0,deuda_m_hipotecario_SBIF)-max(0,deuda_m_hipotecario_EFH)
capture replace abs_error_amount = abs(error_amount)

capture g mo_deu2_hip_`kd3' = max(mo_deu_hip_`kd3',c_nor_hip_`kd3')
capture replace abs_error_amount2 = abs(max(0,mo_deu2_hip_`kd3')-max(0,deuda_m_hipotecario_EFH))
capture replace deuda_m_hipotecario_SBIF = mo_deu2_hip_`kd3' if abs_error_amount>abs_error_amount2 & date_survey==`kd1'
capture replace error_amount = max(0,deuda_m_hipotecario_SBIF)-max(0,deuda_m_hipotecario_EFH)
capture replace abs_error_amount = abs(error_amount)
capture drop mo_deu_hip_`kd3' c_nor_hip_`kd3' mo_deu2_hip_`kd3'
}
}
}
foreach x of varlist deuda_m_hipotecario_SBIF nr_mortgages_SBIF_all error_amount abs_error_amount abs_error_amount2 { 
replace `x'=. if hipotecario_SBIF==.  |  hipotecario_SBIF==0  //replace `x'=. if hipotecario_SBIF==0  //capture replace `x' = . if possible_prior_mortgage==1 //blc
}
drop error_amount abs_error_amount abs_error_amount2

//   //  Look Here  //
g madurez_hipotecario_SBIF = .
g madurez_hipotecario_res_SBIF = .
quietly  {   // Maturities SBIF
forv kd1=`date1'/`date2' {
local kd3=`kd1'
capture egen mo_deu_hip_`kd3' = rowtotal(mo_deu6_*_`kd3' mo_deu7_*_`kd3' mo_deu9_*_`kd3' mo_deu10_*_`kd3')
capture egen c_nor_hip_`kd3' = rowtotal(c_nor6_*_`kd3' c_nor7_*_`kd3' c_nor9_*_`kd3' c_nor10_*_`kd3')
capture replace mo_deu_hip_`kd3' = max(mo_deu_hip_`kd3',c_nor_hip`kd3')
foreach td of numlist 6 7 9 10 {  // 4 w
forv tn=1/2 {  // 4 w
capture g w`td'_`tn' = max(mo_deu`td'_`tn'_`kd3',c_nor`td'_`tn'_`kd3')/mo_deu_hip_`kd3'
capture g m_res`td'_`tn' = max(0,p_cre`td'_`tn'_`kd3')-max(0,vintage_m`td'_`tn'_`kd3')
capture g m_res`td'_`tn' = 0
capture g w`td'_`tn' = 0
capture replace w`td'_`tn' = 0 if w`td'_`tn'==.
capture replace m_res`td'_`tn' = 0 if w`td'_`tn'==.
}
capture g w`td' = max(0,w`td'_1) + max(0,w`td'_2)
capture g m_res`td' = (w`td'_1/w`td')*max(0,m_res`td'_1) + (w`td'_2/w`td')*max(0,m_res`td'_2)
capture g p_c`td' = (w`td'_1/w`td')*max(0,p_cre`td'_1_`kd3') + (w`td'_2/w`td')*max(0,p_cre`td'_2_`kd3')
capture g v_m`td' = (w`td'_1/w`td')*max(0,vintage_m`td'_1_`kd3') + (w`td'_2/w`td')*max(0,vintage_m`td'_2_`kd3')
}
capture g p_cre_hip_`kd3' = max(0,p_c6)*w6 + max(0,p_c7)*w7 + max(0,p_c9)*w9 + max(0,p_c10)*w10
capture g vintage_m_hip_`kd3' = max(0,v_m6)*w6 + max(0,v_m7)*w7 + max(0,v_m9)*w9 + max(0,v_m10)*w10
capture g madurez_res_hip_`kd3' = m_res6*w6 + m_res7*w7 + m_res9*w9 + m_res10*w10 

capture replace p_cre_hip_`kd3' = . if p_cre_hip_`kd3'==0  //capture replace vintage_m_hip_`kd3' = . if vintage_m_hip_`kd3'==0
capture replace madurez_res_hip_`kd3' = . if madurez_res_hip_`kd3'==0 

capture replace madurez_hipotecario_SBIF = p_cre_hip_`kd3'  if hipotecario_SBIF==1 & date_survey==`kd1'
capture replace madurez_hipotecario_res_SBIF = madurez_res_hip_`kd3' if hipotecario_SBIF==1 & date_survey==`kd1'

capture drop w6* w7* w9* w10* mo_deu_hip_`kd3' c_nor_hip_`kd3' m_res6* m_res7* m_res9* m_res10* p_c6* p_c7* p_c9* p_c10* v_m6* v_m7* v_m9* v_m10*
foreach kd2 of numlist -1 1 -2 2 {  //forv kd2=-2/2 {
local kd3=`kd1'+`kd2'
foreach td of numlist 6 7 9 10 {
capture replace madurez_hipotecario_SBIF = p_cre`td'_1_`kd3' if p_cre`td'_1_`kd3'<. & hipotecario_SBIF==1 & date_survey==`kd1' & madurez_hipotecario_SBIF==.
capture replace madurez_hipotecario_res_SBIF = p_cre`td'_1_`kd3'-vintage_m`td'_1_`kd3' if p_cre`td'_1_`kd3'<. & vintage_m`td'_1_`kd3'<. & hipotecario_SBIF==1 & date_survey==`kd1' & madurez_hipotecario_res_SBIF==.
}
}
}
}
sum madurez_hipotecario_SBIF madurez_hipotecario_res_SBIF hipotecario_SBIF if hipotecario_SBIF==1

//  Errors of EFH vs SBIF
tab complementario_EFH hipotecario_SBIF
tab complementario_EFH hipotecario_EFH
tab hipotecario_EFH hipotecario_SBIF, cell nofreq
tab hipotecario_1_EFH hipotecario_SBIF, cell nofreq
tab nr_mortgages_EFH nr_mortgages_SBIF
tab nr_mortgages_EFH nr_mortgages_SBIF_all
tab nr_mortgages_SBIF nr_mortgages_SBIF_all
tab nr_mortgages_SBIF
tab nr_mortgages_SBIF_all

g error_hipotecario_tenencia = hipotecario_SBIF - hipotecario_EFH   
g error_hipotecario_monto = max(0,deuda_m_hipotecario_SBIF) - max(0,deuda_m_hipotecario_EFH) if deuda_m_hipotecario_SBIF<. | deuda_m_hipotecario_EFH<.
g error_madurez_hipotecario = max(0,madurez_hipotecario_SBIF)-max(0,madurez_hipotecario_EFH) if madurez_hipotecario_SBIF<. | madurez_hipotecario_EFH<.
g error_madurez_hipotecario_res = max(0,madurez_hipotecario_res_SBIF)-max(0,madurez_hipotecario_res_EFH) if madurez_hipotecario_res_SBIF<. | madurez_hipotecario_res_EFH<.
tab hipotecario_EFH hipotecario_SBIF
sum error_madurez_hipotecari* deuda_m_hipotecario_SBIF deuda_m_hipotecario_EFH hipotecario_EFH if hipotecario_EFH==1 & hipotecario_SBIF==1
if ${Ratio_op}==1 { //ln( (abs(error_`x'_monto)+ 1) )  //+ r(min)
g mean_var = ( max(0,deuda_m_hipotecario_SBIF) + max(0,deuda_m_hipotecario_EFH) )/2  
g error_ratio_hipotecario =  abs(error_hipotecario_monto)/mean_var
g error_ratio0_hipotecario =  error_hipotecario_monto/mean_var
drop mean_var
g mean_var = ( max(0,madurez_hipotecario_SBIF) + max(0,madurez_hipotecario_EFH) )/2 
g error_ratio_mad_hipotecario = abs(error_madurez_hipotecario)/mean_var
g error_ratio0_mad_hipotecario =  error_madurez_hipotecario/mean_var
drop mean_var
g mean_var = ( max(0,madurez_hipotecario_res_SBIF) + max(0,madurez_hipotecario_res_EFH) )/2 
g error_ratio_mres_hipotecario = abs(error_madurez_hipotecario_res)/mean_var
g error_ratio0_mres_hipotecario =  error_madurez_hipotecario_res/mean_var
drop mean_var
}
else  {
g error_ratio_hipotecario =  abs(error_hipotecario_monto)/deuda_m_hipotecario_SBIF   
replace error_ratio_hipotecario =  abs(error_hipotecario_monto)/deuda_m_hipotecario_EFH if error_ratio_hipotecario==.                 
}
//
                             
g error2_hipotecario_tenencia =(error_hipotecario_tenencia==1)  // or !=0
probit error2_hipotecario_tenencia numh2 edad ing `mvars' [pw=${factor_op}]
reg error_ratio_hipotecario numh2 edad ing [pw=${factor_op}]   // m1 m2 m3 //reg error_`x'_monto numh2 edad ing [pw=${factor_op}]                          
sum error_madurez_hipotecario error_madurez_hipotecario_res [fw=${factor_op}], d 
g deuda_hipotecario_EFH = hipotecario_EFH
g deuda_hipotecario_SBIF = hipotecario_SBIF
save "$path_s1\EFH_SBIF_wide_${yk}.dta", replace
