local debt_types "banco prestamo TL tarjeta linea"
local debt_types2 "hipotecario banco prestamo TL tarjeta linea"
local debt_types0 "hipotecario prestamo"
local error_types0 "ratio0" //ratio0_cuota
local error_types00 "ratio0_cuota" //ratio0_cuota
local madurez_ratios0 "ratio0_mad_hipotecario ratio0_mres_hipotecario ratio0_madurez ratio0_mres"
capture log close

//////////////////////////////////////////////////////////////////////////////
use "$path_s1\EFH_SBIF_wide_${yk}.dta", clear
quietly {  //Note I exclude the non-reports of -200% and 200%
foreach x of local debt_types0 { //debt_types2
foreach x2 of local error_types0 { 
sum error_`x2'_`x' if error_`x2'_`x'>-2 & error_`x2'_`x'<2 [fw=${factor_op}], d
g O_`x2'_`x' = 1 if error_`x2'_`x'>r(p95) & error_`x2'_`x'<.
replace O_`x2'_`x' = 2 if error_`x2'_`x'<r(p5) & error_`x2'_`x'<.
}
}
foreach x of local madurez_ratios0 { 
sum error_`x' if error_`x'>-2 & error_`x'<2 [fw=${factor_op}], d
g O_`x' = 1 if error_`x'>r(p95) & error_`x'<.
replace O_`x' = 2 if error_`x'<r(p5) & error_`x'<.
}
}
//   //    //

sum O_mo_deuPop* O_mo_deuPopC* O_p_crePop* O_p_crePopC* O_dH* O_modeu* O_cnor*
sum date_survey
local date1 = r(min) //${date1}
local date2 = r(max) //${date2}
local date11 = `date1'-2 
local date21 = `date2'+2 
local tdebt1 = "tarjeta"  // Consumo: *1 Tarjetas de crdito *2 Crdito en cuotas *3 Crditos a estudiantes Recursos CORFO
local tdebt2 = "prestamo"  // 4 Otros crditos de consumo *5 Lneas de crdito en cuenta corriente
local tdebt5 = "linea"
*local outvars "O_mo_deuPop O_mo_deuPopC O_p_crePop O_p_crePopC O_dH O_modeu O_cnor" // look at O_modeu and O_cnor (95% outliers????)
*local outvars "O_mo_deuPop O_mo_deuPopC O_dH O_modeu O_cnor"
*local outvars "O_mo_deuPopC O_dH O_modeu O_cnor"
local outvars "O_mo_deuPopC O_dH O_modeu"
quietly  {  // Consumo
foreach td of numlist 2 { //1 2 5
foreach ox of local outvars {
g `ox'_`tdebt`td'' = .
forv kd1=`date1'/`date2' {
local kd3=`kd1'
egen out_temp1 = rowmin(`ox'`td'_*_`kd3')
egen out_temp2 = rowmax(`ox'`td'_*_`kd3')
replace `ox'_`tdebt`td'' = 1 if deuda_`tdebt`td''_SBIF==1 & date_survey==`kd1' & out_temp1!=.  //& (out_temp1!=. | out_temp2!=.)
drop out_temp1 out_temp2
foreach kd2 of numlist -1 1 -2 2 {  
local kd3=`kd1'+`kd2'
egen out_temp1 = rowmin(`ox'`td'_*_`kd3')
egen out_temp2 = rowmax(`ox'`td'_*_`kd3')
replace `ox'_`tdebt`td'' = 1 if deuda_`tdebt`td''_SBIF==1 & deuda_`tdebt`td''_EFH==0 & date_survey==`kd1' & out_temp1!=.  
replace `ox'_`tdebt`td'' = 1 if deuda_`tdebt`td''_SBIF==1 & O_ratio0_`tdebt`td''!=. & date_survey==`kd1' & out_temp1!=.  
drop out_temp1 out_temp2
}
}
}
}
/*foreach ox of local outvars {  //  Banking debt: All
egen `ox'_banco = rowmin(`ox'_tarjeta `ox'_prestamo `ox'_linea)
}    //   //   //
foreach ox of local outvars {  //  Banking debt: Tarjetas, Lineas
egen `ox'_TL = rowmin(`ox'_tarjeta `ox'_linea)
}  */  //   //   //
}
//      //
quietly  {  // Hipotecario
foreach ox of local outvars {
g `ox'_hipotecario = .
forv kd1=`date1'/`date2' {  //mo_deu6_*_`kd3' mo_deu7_*_`kd3' mo_deu9_*_`kd3' mo_deu10_*_`kd3'
local kd3=`kd1'
egen out_temp1=rowmin(`ox'6_*_`kd3' `ox'7_*_`kd3' `ox'9_*_`kd3' `ox'10_*_`kd3')
egen out_temp2=rowmax(`ox'6_*_`kd3' `ox'7_*_`kd3' `ox'9_*_`kd3' `ox'10_*_`kd3')
replace `ox'_hipotecario = 1 if hipotecario_SBIF==1 & date_survey==`kd1' & out_temp1!=.  //& (out_temp1!=. | out_temp2!=.)
drop out_temp1 out_temp2
foreach kd2 of numlist -1 1 -2 2 {  
local kd3=`kd1'+`kd2'
egen out_temp1=rowmin(`ox'6_*_`kd3' `ox'7_*_`kd3' `ox'9_*_`kd3' `ox'10_*_`kd3')
egen out_temp2=rowmax(`ox'6_*_`kd3' `ox'7_*_`kd3' `ox'9_*_`kd3' `ox'10_*_`kd3')
replace `ox'_hipotecario = 1 if hipotecario_SBIF==1 & hipotecario_EFH==0 & date_survey==`kd1' & out_temp1!=.  
replace `ox'_hipotecario = 1 if hipotecario_SBIF==1 & O_ratio0_hipotecario!=. & date_survey==`kd1' & out_temp1!=.  
drop out_temp1 out_temp2
}
}
}
}
egen O_hipotecario=rowmin(O_mo_deuPopC_hip-O_modeu_hip)  //O_mo_deuPopC_hip-O_cnor_hip
egen O_prestamo=rowmin(O_mo_deuPopC_prestamo-O_modeu_prestamo) //O_mo_deuPopC_prestamo-O_cnor_prestamo
/*egen O_tarjeta=rowmin(O_mo_deuPop_tarjeta-O_cnor_tarjeta)
egen O_linea=rowmin(O_mo_deuPop_linea-O_cnor_linea)
egen O_banco=rowmin(O_mo_deuPop_banco-O_cnor_banco)
egen O_TL=rowmin(O_mo_deuPop_TL-O_cnor_TL) */
foreach x of local debt_types0 { //debt_types2 //g E_`x'_monto`pp' = error_`x'_monto if deuda_`x'_EFH==1 & deuda_`x'_SBIF==1
replace O_`x' = 0 if O_`x'==. & deuda_`x'_SBIF==1
foreach ox of local outvars {
replace `ox'_`x' = 0 if `ox'_`x'==. & deuda_`x'_SBIF==1
}
}
drop O_*1* O_*2*
save "$path_s1\EFH_SBIF_wide_${yk}.dta", replace

local K=1 // Test whether Credits are associated with outliers
foreach x of local debt_types0 { //debt_types2
display("`x'")
foreach x2 of local error_types0 {
g E_`x2'_`x' = 100*abs(error_`x2'_`x') if error_`x2'_`x'>-2 & error_`x2'_`x'<2  //make them in %
reg E_`x2'_`x' a1_nothighest_income a1_nothighest_age i.(O_`x') if deuda_`x'_EFH==1 & deuda_`x'_SBIF==1 //[pw=${factor_op}]
if `K'==1 { 
outreg2 using "$path_p\graphs\\RegsO_montos${yk}_ols.xls", replace
local K=1+`K'
}
else {
outreg2 using "$path_p\graphs\\RegsO_montos${yk}_ols.xls", append
}
reg E_`x2'_`x' a1_nothighest_income i.(O_`x') if deuda_`x'_EFH==1 & deuda_`x'_SBIF==1 
outreg2 using "$path_p\graphs\\RegsO_montos${yk}_ols.xls", append
reg E_`x2'_`x' i.(O_`x') if deuda_`x'_EFH==1 & deuda_`x'_SBIF==1 
outreg2 using "$path_p\graphs\\RegsO_montos${yk}_ols.xls", append
}
}
local x2 "ratio0"
foreach x of local debt_types0 { // debt_types2 //Test whether Credits are associated with outliers
reg E_`x2'_`x' i.(O_`x') if deuda_`x'_EFH==1 & deuda_`x'_SBIF==1 
outreg2 using "$path_p\graphs\\RegsO_montos${yk}_`x'.xls", replace
foreach ox of local outvars {
reg E_`x2'_`x' i.(`ox'_`x') if deuda_`x'_EFH==1 & deuda_`x'_SBIF==1 
outreg2 using "$path_p\graphs\\RegsO_montos${yk}_`x'.xls", append
}
}
log using "$path_p\graphs\\Outliers_${yk}.log", replace  
foreach x of local debt_types0 {  //debt_types2 //deuda_`x'_EFH deuda_`x'_SBIF error_`x'_tenencia [fw=${factor_op}] 
display("`x'") 
sum O_*`x' if deuda_m_`x'_SBIF>0 & deuda_m_`x'_EFH>0 & deuda_m_`x'_SBIF<. & deuda_m_`x'_EFH<. [fw=${factor_op}]                                           
}   // Madurez??   
log close
clear
