local debt_types "banco prestamo TL tarjeta linea"
local debt_types2 "hipotecario banco prestamo TL tarjeta linea"
local debt_types0 "hipotecario prestamo"
local error_types0 "ratio0" //ratio0_cuota
local error_types00 "ratio0_cuota" //ratio0_cuota
local madurez_ratios0 "ratio0_mad_hipotecario ratio0_mres_hipotecario ratio0_madurez ratio0_mres"
capture log close

local rp1 = 3  // Rounding of months for plazo
local rp2 = 6
local rp3 = 12
local tolm = 0.5
local tol = 0.33  // How much of total amount can be rounded
local rm1 = 10  // Rounding of measures for amounts in 1000's of pesos
local rm2 = 25
local rm3 = 50
local rm4 = 100
local rm5 = 250
local rm6 = 500
local rm7 = 1000
local rm8 = 2500
local rm9 = 5000
local rm10 = 10000
local rm11 = 25000
local rm12 = 50000
local rm13 = 100000

use "$path_s1\EFH_SBIF_wide_${yk}.dta", clear

g abs_error_amount = 0  // Rounding of Loan amounts
g abs_error_amount2 = 0
foreach x of local debt_types2 { 
g D_`x'_EFHround = round(deuda_m_`x'_EFH/1000) if deuda_m_`x'_SBIF>0 & deuda_m_`x'_EFH>0 & deuda_m_`x'_SBIF<. & deuda_m_`x'_EFH<.
g deuda_round0 = D_`x'_EFHround
g deuda_roundmax = floor(D_`x'_EFHround*`tol') if D_`x'_EFHround>0 & D_`x'_EFHround<.
replace abs_error_amount = abs( max(0,1000*D_`x'_EFHround) - max(0,deuda_m_`x'_SBIF) ) 
foreach p of numlist 1/13 {
replace deuda_round0 = round(D_`x'_EFHround/`rm`p'') if deuda_roundmax>`rm`p'' & deuda_roundmax<. // Closest round
replace abs_error_amount2 = abs( max(0,1000*`rm`p''*deuda_round0) - max(0,deuda_m_`x'_SBIF) ) 
replace D_`x'_EFHround = `rm`p''*deuda_round0 if abs_error_amount>abs_error_amount2 & deuda_roundmax>`rm`p'' & deuda_roundmax<.
replace abs_error_amount = abs( max(0,1000*D_`x'_EFHround) - max(0,deuda_m_`x'_SBIF) ) 
replace deuda_round0 = floor(D_`x'_EFHround/`rm`p'') if deuda_roundmax>`rm`p'' & deuda_roundmax<.  // Lowest round
replace abs_error_amount2 = abs( max(0,1000*`rm`p''*deuda_round0) - max(0,deuda_m_`x'_SBIF) ) 
replace D_`x'_EFHround = `rm`p''*deuda_round0 if abs_error_amount>abs_error_amount2 & deuda_roundmax>`rm`p'' & deuda_roundmax<.
replace abs_error_amount = abs( max(0,1000*D_`x'_EFHround) - max(0,deuda_m_`x'_SBIF) ) 
replace deuda_round0 = ceil(D_`x'_EFHround/`rm`p'') if deuda_roundmax>`rm`p'' & deuda_roundmax<.  // Highest round
replace abs_error_amount2 = abs( max(0,1000*`rm`p''*deuda_round0) - max(0,deuda_m_`x'_SBIF) ) 
replace D_`x'_EFHround = `rm`p''*deuda_round0 if abs_error_amount>abs_error_amount2 & deuda_roundmax>`rm`p'' & deuda_roundmax<.
replace abs_error_amount = abs( max(0,1000*D_`x'_EFHround) - max(0,deuda_m_`x'_SBIF) ) 

}
replace D_`x'_EFHround = D_`x'_EFHround*1000
g mean_var = (max(0,D_`x'_EFHround) + max(0,deuda_m_`x'_SBIF))/2 if deuda_m_`x'_SBIF>0 & deuda_m_`x'_EFH>0 & deuda_m_`x'_SBIF<. & deuda_m_`x'_EFH<. 
g error_ratio0R_`x' = (max(0,deuda_m_`x'_SBIF) - max(0,D_`x'_EFHround))/mean_var if deuda_m_`x'_SBIF>0 & deuda_m_`x'_EFH>0 & deuda_m_`x'_SBIF<. & deuda_m_`x'_EFH<.
capture drop deuda_roundmax deuda_round0 mean_var
sum D_`x'_EFHround deuda_m_`x'_EFH deuda_m_`x'_SBIF if deuda_m_`x'_SBIF>0 & deuda_m_`x'_EFH>0 & deuda_m_`x'_SBIF<. & deuda_m_`x'_EFH<. 
pwcorr D_`x'_EFHround deuda_m_`x'_EFH deuda_m_`x'_SBIF if deuda_m_`x'_SBIF>0 & deuda_m_`x'_EFH>0 & deuda_m_`x'_SBIF<. & deuda_m_`x'_EFH<. 
}
drop abs_error_amount abs_error_amount2

g abs_error_amount = 0  // Rounding of Debt Service (Cuota) amounts
g abs_error_amount2 = 0
foreach x of local debt_types0 { 
g C_`x'_EFHround = round(cuota_`x'_EFH/1000) if cuota_`x'_SBIF>0 & cuota_`x'_EFH>0 & cuota_`x'_SBIF<. & cuota_`x'_EFH<.
g deuda_round0 = C_`x'_EFHround
g deuda_roundmax = floor(C_`x'_EFHround*`tol') if C_`x'_EFHround>0 & C_`x'_EFHround<.
replace abs_error_amount = abs( max(0,1000*C_`x'_EFHround) - max(0,cuota_`x'_SBIF) ) 
foreach p of numlist 1/13 {
replace deuda_round0 = round(C_`x'_EFHround/`rm`p'') if deuda_roundmax>`rm`p'' & deuda_roundmax<. // Closest Round
replace abs_error_amount2 = abs( max(0,1000*`rm`p''*deuda_round0) - max(0,cuota_`x'_SBIF) ) 
replace C_`x'_EFHround = `rm`p''*deuda_round0 if abs_error_amount>abs_error_amount2 & deuda_roundmax>`rm`p'' & deuda_roundmax<.
replace abs_error_amount = abs( max(0,1000*C_`x'_EFHround) - max(0,cuota_`x'_SBIF) ) 
replace deuda_round0 = floor(C_`x'_EFHround/`rm`p'') if deuda_roundmax>`rm`p'' & deuda_roundmax<. // Lowest Round
replace abs_error_amount2 = abs( max(0,1000*`rm`p''*deuda_round0) - max(0,cuota_`x'_SBIF) ) 
replace C_`x'_EFHround = `rm`p''*deuda_round0 if abs_error_amount>abs_error_amount2 & deuda_roundmax>`rm`p'' & deuda_roundmax<.
replace abs_error_amount = abs( max(0,1000*C_`x'_EFHround) - max(0,cuota_`x'_SBIF) ) 
replace deuda_round0 = ceil(C_`x'_EFHround/`rm`p'') if deuda_roundmax>`rm`p'' & deuda_roundmax<. // Highest Round
replace abs_error_amount2 = abs( max(0,1000*`rm`p''*deuda_round0) - max(0,cuota_`x'_SBIF) ) 
replace C_`x'_EFHround = `rm`p''*deuda_round0 if abs_error_amount>abs_error_amount2 & deuda_roundmax>`rm`p'' & deuda_roundmax<.
replace abs_error_amount = abs( max(0,1000*C_`x'_EFHround) - max(0,cuota_`x'_SBIF) ) 
}
replace C_`x'_EFHround = C_`x'_EFHround*1000
g mean_var = (max(0,C_`x'_EFHround) + max(0,cuota_`x'_SBIF))/2 if cuota_`x'_SBIF>0 & cuota_`x'_EFH>0 & cuota_`x'_SBIF<. & cuota_`x'_EFH<. 
g error_ratio0R_C_`x' = (max(0,cuota_`x'_SBIF) - max(0,C_`x'_EFHround))/mean_var if cuota_`x'_SBIF>0 & cuota_`x'_EFH>0 & cuota_`x'_SBIF<. & cuota_`x'_EFH<.
capture drop deuda_roundmax deuda_round0 mean_var
sum C_`x'_EFHround cuota_`x'_EFH cuota_`x'_SBIF if cuota_`x'_SBIF>0 & cuota_`x'_EFH>0 & cuota_`x'_SBIF<. & cuota_`x'_EFH<. 
pwcorr C_`x'_EFHround cuota_`x'_EFH cuota_`x'_SBIF if cuota_`x'_SBIF>0 & cuota_`x'_EFH>0 & cuota_`x'_SBIF<. & cuota_`x'_EFH<. 
}
drop abs_error_amount abs_error_amount2

g abs_error_amount = 0  // Rounding of Original Maturity (Madurez) amounts
g abs_error_amount2 = 0
foreach x of local debt_types0 { 
g M_`x'_EFHround = madurez_`x'_EFH if madurez_`x'_SBIF>0 & madurez_`x'_EFH>0 & madurez_`x'_SBIF<. & madurez_`x'_EFH<.
g deuda_round0 = M_`x'_EFHround
g deuda_roundmax = floor(M_`x'_EFHround*`tolm') if M_`x'_EFHround>0 & M_`x'_EFHround<.
replace abs_error_amount = abs( max(0,M_`x'_EFHround) - max(0,madurez_`x'_SBIF) ) 
foreach p of numlist 1/3 {
replace deuda_round0 = round(M_`x'_EFHround/`rp`p'') if deuda_roundmax>`rp`p'' & deuda_roundmax<. // Closest Round
replace abs_error_amount2 = abs( max(0,`rp`p''*deuda_round0) - max(0,madurez_`x'_SBIF) ) 
replace M_`x'_EFHround = `rp`p''*deuda_round0 if abs_error_amount>abs_error_amount2 & deuda_roundmax>`rp`p'' & deuda_roundmax<.
replace abs_error_amount = abs( max(0,M_`x'_EFHround) - max(0,madurez_`x'_SBIF) ) 
replace deuda_round0 = floor(M_`x'_EFHround/`rp`p'') if deuda_roundmax>`rp`p'' & deuda_roundmax<. // Lowest Round
replace abs_error_amount2 = abs( max(0,`rp`p''*deuda_round0) - max(0,madurez_`x'_SBIF) ) 
replace M_`x'_EFHround = `rp`p''*deuda_round0 if abs_error_amount>abs_error_amount2 & deuda_roundmax>`rp`p'' & deuda_roundmax<.
replace abs_error_amount = abs( max(0,M_`x'_EFHround) - max(0,madurez_`x'_SBIF) ) 
replace deuda_round0 = ceil(M_`x'_EFHround/`rp`p'') if deuda_roundmax>`rp`p'' & deuda_roundmax<. // Highest Round
replace abs_error_amount2 = abs( max(0,`rp`p''*deuda_round0) - max(0,madurez_`x'_SBIF) ) 
replace M_`x'_EFHround = `rp`p''*deuda_round0 if abs_error_amount>abs_error_amount2 & deuda_roundmax>`rp`p'' & deuda_roundmax<.
replace abs_error_amount = abs( max(0,M_`x'_EFHround) - max(0,madurez_`x'_SBIF) ) 
}
g mean_var = (max(0,M_`x'_EFHround) + max(0,madurez_`x'_SBIF))/2 if madurez_`x'_SBIF>0 & madurez_`x'_EFH>0 & madurez_`x'_SBIF<. & madurez_`x'_EFH<. 
g error_ratio0R_M_`x' = (max(0,madurez_`x'_SBIF) - max(0,M_`x'_EFHround))/mean_var if madurez_`x'_SBIF>0 & madurez_`x'_EFH>0 & madurez_`x'_SBIF<. & madurez_`x'_EFH<.
capture drop deuda_roundmax deuda_round0 mean_var
sum M_`x'_EFHround madurez_`x'_EFH madurez_`x'_SBIF if madurez_`x'_SBIF>0 & madurez_`x'_EFH>0 & madurez_`x'_SBIF<. & madurez_`x'_EFH<. 
pwcorr M_`x'_EFHround madurez_`x'_EFH madurez_`x'_SBIF if madurez_`x'_SBIF>0 & madurez_`x'_EFH>0 & madurez_`x'_SBIF<. & madurez_`x'_EFH<. 
}
drop abs_error_amount abs_error_amount2

g abs_error_amount = 0  // Rounding of remaining Maturity (Madurez-residual) amounts
g abs_error_amount2 = 0
foreach x of local debt_types0 { 
g Mres_`x'_EFHround = madurez_`x'_res_EFH if madurez_`x'_res_SBIF>0 & madurez_`x'_res_EFH>0 & madurez_`x'_res_SBIF<. & madurez_`x'_res_EFH<.
g deuda_round0 = Mres_`x'_EFHround
g deuda_roundmax = floor(Mres_`x'_EFHround*`tolm') if Mres_`x'_EFHround>0 & Mres_`x'_EFHround<.
replace abs_error_amount = abs( max(0,1000*Mres_`x'_EFHround) - max(0,madurez_`x'_res_SBIF) ) 
foreach p of numlist 1/3 {
replace deuda_round0 = round(Mres_`x'_EFHround/`rp`p'') if deuda_roundmax>`rp`p'' & deuda_roundmax<. // Closest Round
replace abs_error_amount2 = abs( max(0,`rp`p''*deuda_round0) - max(0,madurez_`x'_res_SBIF) ) 
replace Mres_`x'_EFHround = `rp`p''*deuda_round0 if abs_error_amount>abs_error_amount2 & deuda_roundmax>`rp`p'' & deuda_roundmax<.
replace abs_error_amount = abs( max(0,Mres_`x'_EFHround) - max(0,madurez_`x'_res_SBIF) ) 
replace deuda_round0 = floor(Mres_`x'_EFHround/`rp`p'') if deuda_roundmax>`rp`p'' & deuda_roundmax<. // Lowest Round
replace abs_error_amount2 = abs( max(0,`rp`p''*deuda_round0) - max(0,madurez_`x'_res_SBIF) ) 
replace Mres_`x'_EFHround = `rp`p''*deuda_round0 if abs_error_amount>abs_error_amount2 & deuda_roundmax>`rp`p'' & deuda_roundmax<.
replace abs_error_amount = abs( max(0,Mres_`x'_EFHround) - max(0,madurez_`x'_res_SBIF) ) 
replace deuda_round0 = ceil(Mres_`x'_EFHround/`rp`p'') if deuda_roundmax>`rp`p'' & deuda_roundmax<. // Highest Round
replace abs_error_amount2 = abs( max(0,`rp`p''*deuda_round0) - max(0,madurez_`x'_res_SBIF) ) 
replace Mres_`x'_EFHround = `rp`p''*deuda_round0 if abs_error_amount>abs_error_amount2 & deuda_roundmax>`rp`p'' & deuda_roundmax<.
replace abs_error_amount = abs( max(0,Mres_`x'_EFHround) - max(0,madurez_`x'_res_SBIF) ) 
}
g mean_var = (max(0,Mres_`x'_EFHround) + max(0,madurez_`x'_res_SBIF))/2 if madurez_`x'_res_SBIF>0 & madurez_`x'_res_EFH>0 & madurez_`x'_res_SBIF<. & madurez_`x'_res_EFH<. 
g error_ratio0R_Mres_`x' = (max(0,madurez_`x'_res_SBIF) - max(0,Mres_`x'_EFHround))/mean_var if madurez_`x'_res_SBIF>0 & madurez_`x'_res_EFH>0 & madurez_`x'_res_SBIF<. & madurez_`x'_res_EFH<.
capture drop deuda_roundmax deuda_round0 mean_var
sum Mres_`x'_EFHround madurez_`x'_res_EFH madurez_`x'_res_SBIF if madurez_`x'_res_SBIF>0 & madurez_`x'_res_EFH>0 & madurez_`x'_res_SBIF<. & madurez_`x'_res_EFH<. 
pwcorr Mres_`x'_EFHround madurez_`x'_res_EFH madurez_`x'_res_SBIF if madurez_`x'_res_SBIF>0 & madurez_`x'_res_EFH>0 & madurez_`x'_res_SBIF<. & madurez_`x'_res_EFH<. 
}
drop abs_error_amount abs_error_amount2

save "$path_s1\EFH_SBIF_wide_${yk}.dta", replace
