set more off
use "$path_s1\EFH_risk_sbif0_fcre.dta", clear  //This just includes observations in SBIF that have banking debt in 2011
sum id fol* Fol*  // 2nd Rut is available, id gives number of Ruts in EFH2011-SBIF that have banking debt in 2011
*sum a1 a8 id fol* FolioNuevo FolioNuevo_segundo_rut if FolioNuevo_segundo_rut!=FolioNuevo & FolioNuevo<. & FolioNuevo_segundo_rut<. // Not valid after 2011
g date_sbif = ym(year_date, month_date) 
format %tm date_sbif
sum date_sbif
global date1 = r(min)
global date2 = r(max)
bysort yearEFH FolioNuevo f_reg t_deu: egen rank_credit2 = rank(c_nor), field
tab rank_credit2
tab rank_credit rank_credit2
capture drop ord b1 b2 b4-d6_m7
rename year year0
capture rename month month0
g year = year_credit
replace year=year_date if year==. 
replace year=year0 if year==.
g month = month_credit 
replace month=month_date if month==. //replace month=month0 if month==.
local grains "tasa_vivienda tasa_consumo2002_16 tasa_consumo2013_16 tasaship"
foreach x of local grains {
joinby year month using "$path_s1\`x'.dta", unmatched(master) update
drop _merge
}
drop year month
rename year0 year
capture rename month0 month
sum tasa_* plazo4
pwcorr tasa_viv plazo4 plazo1 plazo2 plazo3 //tasa_hi* 
pwcorr tasa_cons* tasa_tarj* tasa_pres* tasa_linea plazo4
pwcorr tasa_vivienda tasa_consumo_total plazo4
pwcorr tasa_vivienda plazo4 //tasa_hip_uf 
quietly { 
replace plazo4 = 0.09 if plazo4==. //interest rate for years before 1990
foreach var of varlist tasa_vivienda plazo4 { //tasa_hip_uf
foreach var2 of varlist tasa_consumo_total tasa_consumo_6m tasa_consumo_1y tasa_consumo_3y tasa_consumo_longo {
reg `var2' `var' 
predict tx
replace `var2'=tx if `var2'==.
drop tx
}
}
foreach var of varlist plazo4 { //tasa_hip_uf
reg tasa_vivienda `var' 
predict tx
replace tasa_vivienda=tx if tasa_vivienda==.
drop tx
}
foreach var of varlist tasa_tarj tasa_pres tasa_linea {
reg `var' tasa_consumo_total
predict tx
replace `var'=tx if `var'==.
drop tx
}
//   //
foreach var of varlist tasa_vivienda-tasa_linea {
replace `var'=`var'/100
replace `var'=`var'/12
}
}
sum t_deu mo_deu p_cre  // Consumo: *1 Tarjetas de crdito *2 Crdito en cuotas *3 Crditos a estudiantes Recursos CORFO
 // 4 Otros crditos de consumo *5 Lneas de crdito en cuenta corriente
// Hipotecario de vivienda: *6 Hipotecario en letras de crdito *7 Mutuo hipotecario endosable
// 8 Hipotecario comprado a ANAP(No Usar) *9 Mutuo hipotecario no endosable *10 Otros crditos hipotecarios
g dummy_plazo_c = 1 if t_deu>=2 & t_deu<=4 & p_cre>=0 & p_cre<=6
replace dummy_plazo_c = 2 if t_deu>=2 & t_deu<=4 & p_cre>6 & p_cre<=12
replace dummy_plazo_c = 3 if t_deu>=2 & t_deu<=4 & p_cre>12 & p_cre<=36
replace dummy_plazo_c = 4 if t_deu>=2 & t_deu<=4 & p_cre>36 & p_cre<.
replace dummy_plazo_c = 5 if t_deu>=2 & t_deu<=4 & p_cre==.
sum p_cre if t_deu>5 & mo_deu>0
sum p_cre if t_deu<=5 & mo_deu>0
g p_cre0 = max(1,p_cre)
g cuota_deu = mo_deu*tasa_vivienda/(1- ((1+tasa_vivienda)^(-p_cre0)) )  if t_deu>=6 & t_deu<=10  // vivienda
replace cuota_deu = mo_deu*tasa_vivienda/(1- ((1+tasa_vivienda)^(-p_cre0)) )  if t_deu==3 //educacion
replace cuota_deu = mo_deu*tasa_consumo_6m/(1- ((1+tasa_consumo_6m)^(-p_cre0)) )  if t_deu==2 & dummy_plazo_c==1  // prestamos
replace cuota_deu = mo_deu*tasa_consumo_1y/(1- ((1+tasa_consumo_1y)^(-p_cre0)) )  if t_deu==2 & dummy_plazo_c==2
replace cuota_deu = mo_deu*tasa_consumo_3y/(1- ((1+tasa_consumo_3y)^(-p_cre0)) )  if t_deu==2 & dummy_plazo_c==3
replace cuota_deu = mo_deu*tasa_consumo_longo/(1- ((1+tasa_consumo_longo)^(-p_cre0)) )  if t_deu==2 & dummy_plazo_c==4
replace cuota_deu = mo_deu*tasa_prestamo/(1- ((1+tasa_prestamo)^(-p_cre0)) )  if t_deu==2 & dummy_plazo_c==5

replace cuota_deu = mo_deu*tasa_tarjeta/(1- ((1+tasa_tarjeta)^(-p_cre0)) )  if t_deu==1  //tarjetas, lineas, others
replace cuota_deu = mo_deu*tasa_consumo_total/(1- ((1+tasa_consumo_total)^(-p_cre0)) )  if t_deu==4
replace cuota_deu = mo_deu*tasa_linea/(1- ((1+tasa_linea)^(-p_cre0)) )  if t_deu==5
replace cuota_deu = max(mo_deu,c_nor)*tasa_tarjeta/(1- ((1+tasa_tarjeta)^(-p_cre0)) ) if t_deu==1  & (cuota_deu==. | cuota_deu==0) //tarjetas, lineas, others, Part II (notice mo_deu is missing from data after certain date)
replace cuota_deu = max(mo_deu,c_nor)*tasa_consumo_total/(1- ((1+tasa_consumo_total)^(-p_cre0)) )  if t_deu==4 & (cuota_deu==. | cuota_deu==0)
replace cuota_deu = max(mo_deu,c_nor)*tasa_linea/(1- ((1+tasa_linea)^(-p_cre0)) )  if t_deu==5  & (cuota_deu==. | cuota_deu==0)
replace cuota_deu = max(mo_deu,c_nor)  if t_deu==1 & (cuota_deu==. | cuota_deu==0)  //tarjetas, lineas, others, Part III
replace cuota_deu = max(mo_deu,c_nor)  if t_deu==4 & (cuota_deu==. | cuota_deu==0)
replace cuota_deu = max(mo_deu,c_nor)  if t_deu==5 & (cuota_deu==. | cuota_deu==0)
drop plazo4-plazo3 tasa_vivienda-tasa_linea dummy_plazo_c

do "$path_bs_do\format_default_sbif.do"
keep date_sbif f_cre date_credit-quarter_credit vintage_q-maturity_q cc_atr-mc_atr id folio-${factor_op} year_date-month_date FolioNuevo date_month t_deu rank_credit2 cuota_deu default_sbif-default_30  O_mo_deuPop O_mo_deuPopC O_p_crePop O_p_crePopC O_dH O_modeu O_cnor
capture drop factor_* yearEFH quarter_credit id f_cre year_date date_month month_date date_credi* maturity_q* vintage_q* 
capture drop c_inc pc_inc cc_atr c_jud n_inscod_tdeu n_inscod  //keep year_credit-cm_cuo folio date_sbif rank_credit2 t_deu
order FolioNuevo folio-year_efh date_sbif rank_credit2 t_deu year_credit month_credit vintage_m p_cre O_*, first
rename default_30 default_30_
reshape wide year_credit month_credit vintage_m-mc_atr cuota_deu default_sbif-default_30_, i(FolioNuevo-rank_credit2) j(t_deu)   // wide date_credit-n_inscod  //i(folio* FolioNuevo date_sbif rank_credit2)
save "$path_s1\EFH_risk_sbif0_fcre_wide.dta", replace  //reshape data again???
foreach x of varlist year_credit1-default_30_10 { //cuota_deu10 //year_credit1-mc_atr10
rename `x' `x'_
} 
reshape wide year_credit1_-default_30_10_, i(FolioNuevo-date_sbif) j(rank_credit2) // cuota_deu10_ //year_credit1_-mc_atr10_
capture sum c_nor6_3* c_nor6_4* c_nor7_3* c_nor7_4*  c_nor9_3* c_nor9_4* c_nor10_3* c_nor10_4*
capture drop *6_3* *6_4* *7_3* *7_4* *9_3* *9_4* *10_3* *10_4* // Drop empty variables (no one has 3 or 4 mortgages of the same type)
capture sum *1_2 *5_2 *10_2 *1_3 *3_3 *4_3 *5_3 *1_4 *3_4 *4_4 *5_4
capture drop *1_2 *5_2 *10_2 *1_3 *3_3 *4_3 *5_3 *1_4 *3_4 *4_4 *5_4
sum
save "$path_s1\EFH_risk_sbif0_fcre_wide.dta", replace  //reshape data again???
if ${yk}<17 {
foreach x of varlist year_credit1_1-default_30_2_4 { // cuota_deu2_4 // year_credit1_1-mc_atr2_4
rename `x' `x'_
}
}
if ${yk}>=17 {
foreach x of varlist year_credit1_1-default_30_10_1 { // cuota_deu2_4 // year_credit1_1-mc_atr2_4
rename `x' `x'_
}
}
capture reshape wide year_credit1_1_-default_30_2_4_, i(FolioNuevo-year_efh) j(date_sbif) // cuota_deu2_4_ // year_credit1_1_-mc_atr2_4_
if ${yk}>=17 {
capture reshape wide year_credit1_1_-default_30_10_1_, i(FolioNuevo-year_efh) j(date_sbif)
}
quietly compress
save "$path_s1\EFH_risk_sbif0_fcre_wide.dta", replace  //reshape data again???	

// Folios EFH 2011 which do not report banking debt in SBIF for years 2011 and 2012
use "$path_s1\\${data_save}_${yk}.dta", clear
if ${yk}==11 {
drop b8_t-b9p c9_lab-c11 c16-c24ecod c26 c28_hm-d6_m7 p1-p8_2 e60_1-e60e_1cod e61_2-e61ecod e63_1_1-e65_6_t h1_1-i4_t_6 i9-i15_10 j3_1-j12ecod
}
if ${yk}==14 {
drop j1- j3t d1- d20_7e h1_1- h5t i1_1- i4_8e_9 i6- i18_6e l1_1- l5t_16 
}
keep if a1==1
joinby FolioNuevo year_efh using "$path_s1\EFH_risk_sbif0_fcre_wide.dta", unmatched(both) update  //joinby folio folio2 using "$path_s1\EFH_risk_sbif0_fcre.dta", unmatched(both) update
tab _merge
g nosbif_surveyper = (_merge!=3)
tab nosbif_surveyper
drop _merge

if ${yk}<17 {
joinby yearEFH FolioNuevo using "$path_s2\BaseSBIF_Ruts.dta", unmatched(master) update  
}
if ${yk}>=17 {
joinby folio_20${yk} using "$path_s2\Llave_folios.dta", unmatched(master) update  
}
g NoLoan_history = (_merge!=3)
drop _merge
tab NoLoan_history
tab NoLoan_history nosbif_surveyper
capture drop deuda_banco_EFH-madurez_prestamo_res_EFH
if ${yk}==11 {
sum m1 m2 m3
*drop if m1==.
}
egen id = group(FolioNuevo year_efh)
if ${yk}>=11 {
rename mese meses_survey
if ${yk}==11 {
g year_survey = 2011 if meses_survey>=7
replace year_survey = 2012 if meses_survey<=5
}
if ${yk}>=14 {
g year_survey = anoe
}
capture g date_survey = ym(year_survey, meses_survey)
capture format %tm date_survey
}
sum id a1 ${factor_op} meses_survey year year_efh 
save "$path_s1\EFH_SBIF_wide_${yk}.dta", replace
sum date_survey
sum year_survey meses_survey if date_survey==r(max)
tab meses_survey  // Get rid of months from 2012-1 to 2012-5
forv tn=1/7 { //g ing=ln(yefec+1000)  //capture g ing = ln(1+ytoth) //drop if meses_sur<=5	
capture sum c_nor`tn'_1_* 
}
forv tn=9/10 { 
capture sum c_nor`tn'_1_* 
}
sum edad ing ytot*						
