set more off
use "$path_s3\hist_dynamic_un06_11_${yk}.dta", clear  // Get data for quintile brackets
forvalues k = 1/2 {
forvalues i = 1/5 {
sum ytoth if quintile_h==`i' & a1==1 & zona2==`k'
local q`i'`k'=r(min)
local q`i'`k'_max=r(max)
}
local q6`k'=`q5`k'_max'
}
*bysort quintile_h: sum ytoth ytot_ind if a1==1  & zona2==1

use "$path_s2\Base_EFH_2011_allvars.dta", clear
replace yearEFH = 2011 if yearEFH==.
tab _merge
drop _merge
sum FolioNuevo if FolioNuevo_segundo_rut==.
sum FolioNuevo if FolioNuevo_segundo_rut<.
sum FolioNuevo FolioNuevo_segundo_rut  if FolioNuevo_segundo_rut<. & FolioNuevo<.
g Folio = FolioNuevo 
replace Folio = FolioNuevo_segundo_rut if Folio==.
g second_rut_only = (FolioNuevo==. & FolioNuevo_segundo_rut<.)
egen folio = group(Folio)
replace FolioNuevo = FolioNuevo_segundo_rut if FolioNuevo==.  // Include 2nd Rut if it is the only Rut available
drop Folio
g yefec = ytoth-yai
replace yefec=ytoth if yefec==.
sum yefec if yefec>0
g ing=ln(yefec+1000)
sum sexo zona2 edad ytot_ind ocup a1 desem a2 ytoth yai yaotp yact
capture drop desem
g desem = (ocup==0) if ocup<.
g tr_edad=0
replace tr_edad=1 if edad>=15 & edad<25
replace tr_edad=2 if edad>=25 & edad<35
replace tr_edad=3 if edad>=35 & edad<45
replace tr_edad=4 if edad>=45 & edad<55
replace tr_edad=5 if edad>=55 & edad<65
replace tr_edad=5 if edad>=65 
g tr_edad2 = tr_edad //Tramos de edad 2 - Young, Middle Age, Old
recode tr_edad2 1/2=1 3/4=2 5=3
g nivel=.
replace nivel = 1 if nive_edu>0 & nive_edu<=8 
replace nivel = 2 if nive_edu>8 & nive_edu<=12 
replace nivel = 3 if nive_edu>12 & nive_edu<=15 
replace nivel = 1 if nivel==. & tedu==1
replace nivel = 2 if nivel==. & tedu==2
replace nivel = 3 if nivel==. & tedu==3
replace nivel = 3 if nivel==. & tedu==4
rename nivel educ
g isicrev2=c9_cod if a1==1  // Actividad economica 
replace isicrev2=2302 if isicrev2==2329
replace isicrev2=3111 if isicrev2==3110
replace isicrev2=3411 if isicrev2==3410
sort isicrev2
joinby isicrev2 using "$path2b\isic1.dta", unmatched(master)
drop _merge
g actividad=0  // Rama actividad econmica
forv k=0/9 {
local p=(1000*`k')
replace actividad=`k' if isicrev2>=`p' & isicrev2<`p'+999
}
replace actividad=. if actividad==0
replace actividad=. if actividad==10
replace actividad = 1 if actividad==2
replace actividad = 3 if actividad==4  // Sector economico - Primario, Secundario, Terciario
g sector_ind = actividad
recode sector_ind 0/2=1 3/5=2 6/9=3
replace sector_ind = 3 if sector_ind==. & ocup<. & ytot_ind >0 & ytot_ind <.
g quintile_h = .
forvalues k = 1/2 {
forvalues i = 1/5 {
local i2=`i'+1
replace quintile_h=`i' if ytoth>=`q`i'`k'' & ytoth<`q`i2'`k'' & zona2==`k'
}
replace quintile_h=1 if ytoth<`q1`k'' & zona2==`k'
replace quintile_h=5 if ytoth>=`q6`k'' & ytoth<. & zona2==`k'
replace quintile_h=1 if quintile_h==. & zona2==`k'
}
g quintile_renta = quintile_h
//sexo zona2 tr_edad educ quintile_h ytot_ind ocup a1 desem a2 actividad sector_ind tr_edad2 ytoth yai yaotp yact
order expr* fac*, first
order factor_cvars1112 factor_2011, first
drop expr0200-factor_cvars1110
save "$path_s1\\${data_save}_${yk}.dta", replace
