set more off
use "$path_s3\hist_dynamic_un06_11_${yk}.dta", clear  // Get data for quintile brackets
forvalues k = 1/2 {
forvalues i = 1/5 {
sum ytoth if quintile_h==`i' & a1==1 & zona2==`k'
local q`i'`k'=r(min)
local q`i'`k'_max=r(max)
}
local q6`k'=`q5`k'_max'
}
*bysort quintile_h: sum ytoth ytot_ind if a1==1  & zona2==1

use "$path_s2\Base_EFH_2014_allvars.dta", clear
bysort FolioNuevo: egen factor0 = mean(factor_egm)
replace factor_egm = ceil(factor0)
drop factor0
replace yearEFH = 2014 if yearEFH==.
/*tab _merge
drop _merge
sum FolioNuevo if FolioNuevo_segundo_rut==.
sum FolioNuevo if FolioNuevo_segundo_rut<.
sum FolioNuevo FolioNuevo_segundo_rut  if FolioNuevo_segundo_rut<. & FolioNuevo<.
g Folio = FolioNuevo 
replace Folio = FolioNuevo_segundo_rut if Folio==.
g second_rut_only = (FolioNuevo==. & FolioNuevo_segundo_rut<.)
egen folio = group(Folio)
replace FolioNuevo = FolioNuevo_segundo_rut if FolioNuevo==.  // Include 2nd Rut if it is the only Rut available
drop Folio*/
egen folio = group(Folio)
g year = yearEFH

g yefec = ytoth-yai
replace yefec=ytoth if yefec==.
sum yefec if yefec>0
g ing=ln(yefec+1000)
sum ord edad ocup a1 a2 ytoth yai
global years_educ_op = 1 // 0 - use years of education, 1 - use last reported education level
do "$path_bs_do2\homologacion_2014_2011_vs3.do"  // Changes variable names to 2011 standards
replace rci_dna = cf_dna/max(1000, ytotef) if rci_dna==0 | rci_dna==.  //replace d_dna = 0 if rci_dna==0 | cf_dna==0 | rci_dna==. | cf_dna==.
replace rci_dt = cf_dt/max(1000, ytotef) if rci_dt==0 | rci_dt==.   //replace d_dt = 0 if rci_dt==0 | cf_dt==0 | rci_dt==. | cf_dt==.
sum macrozona s_region
g zona2 = (s_region!=13)
replace zona2 = 2 if s_region==13
tab zona2
capture g s = educ  //g a1=(ord==1)
g hombre_casado = estado_civil*genero
replace hombre_casado = (hombre_casado==1)
g universidad = (n_educ>=5 & n_educ<=6)
g instituto = (n_educ==4)
replace instituto = (n_educ==7) if instituto==0
g d_z2 = (zona2==2)
g ytot_ind0 = ylab
replace ytot_ind0 = 0 if ytot_ind0==.
replace ytot_ind = ytot_ind0 if ytot_ind==.
drop ytot_ind0
replace ytot_ind = max(ytot_ind, max(0,yoprinm)+max(0,yoprin)+max(0,yosec)) 
replace ytoth = ytot_ind if ytoth==. & a1==1
replace ytoth = ytot_ind if ytoth==. & a2==1
g yaotp = max(0, ypenh) + max(0,ysubh)  
g yact0 = max(0,yotroh)
replace yact=max(yact,yact0)
drop yact0

sum Fol* sexo zona2 edad ytot_ind ocup a1 desem a2 ytoth yai yaotp yact
capture drop desem
g desem = (ocup==0) if ocup<.
capture drop tr_eda*
g tr_edad=0
replace tr_edad=1 if edad>=15 & edad<25
replace tr_edad=2 if edad>=25 & edad<35
replace tr_edad=3 if edad>=35 & edad<45
replace tr_edad=4 if edad>=45 & edad<55
replace tr_edad=5 if edad>=55 & edad<65
replace tr_edad=5 if edad>=65 
g tr_edad2 = tr_edad //Tramos de edad 2 - Young, Middle Age, Old
recode tr_edad2 1/2=1 3/4=2 5=3
g nivel = 2 if instituto==1
replace nivel = 3 if univer==1
replace nivel = 1 if univer==0 & instituto==0
bysort comuna sexo tr_edad: egen niv_m=median(nivel)
replace nivel=round(niv_m) if nivel==.
capture rename educ anos_educ //s anos_educ //
rename nivel educ

g actividad=9
g sector_ind = actividad
recode sector_ind 0/2=1 3/5=2 6/9=3
g quintile_h = .
forvalues k = 1/2 {
forvalues i = 1/5 {
local i2=`i'+1
replace quintile_h=`i' if ytoth>=`q`i'`k'' & ytoth<`q`i2'`k'' & zona2==`k'
}
replace quintile_h=1 if ytoth<`q1`k'' & zona2==`k'
replace quintile_h=5 if ytoth>=`q6`k'' & ytoth<. & zona2==`k'
replace quintile_h=1 if quintile_h==. & zona2==`k'
}
g quintile_renta = quintile_h
//sexo zona2 tr_edad educ quintile_h ytot_ind ocup a1 desem a2 actividad sector_ind tr_edad2 ytoth yai yaotp yact
order ${factor_op} factor_2011 factor_2007, first //factor_egm 
drop factor_2007 factor_2011 factor factor_2014 factor_sp_est_m factor_em factor_gm factor_m // factor_2011
save "$path_s1\\${data_save}_${yk}.dta", replace
