use "D:\DAT\DPF\Analisis Financiero\Sector Hogares\EFH\2017\base_imp_2017_all_imp15_ord1.dta", clear //use "$path0\2017\EFH_17_allvars.dta", clear
joinby folio ord using "D:\DAT\DPF\Analisis Financiero\Sector Hogares\EFH\2017\EFH_17_allvars.dta", unmatched(both) update
tab _merge
drop _merge /**/
capture drop tr_* miss* i* l* mora* otp* atraso* bc* pr* u* fin* dfin* motiv* f5* f15* //pp* 

g yefec = ytoth-yai
replace yefec=ytoth if yefec==.
sum yefec if yefec>0
g ing=ln(yefec+1000)
sum ord edad ocup a1 a2 ytoth yai
global years_educ_op = 1 // 0 - use years of education, 1 - use last reported education level
do "$path_bs_do\homologacion_2017_2011_vs3.do"  // Changes variable names to 2011 standards
replace rci_dna = cf_dna/max(1000, ytotef) if rci_dna==0 | rci_dna==.  //replace d_dna = 0 if rci_dna==0 | cf_dna==0 | rci_dna==. | cf_dna==.
replace rci_dt = cf_dt/max(1000, ytotef) if rci_dt==0 | rci_dt==.   //replace d_dt = 0 if rci_dt==0 | cf_dt==0 | rci_dt==. | cf_dt==.
sum macrozona s_region
*g zona2 = (s_region!=13)
*replace zona2 = 2 if s_region==13
*tab zona2
*capture g s = educ  //g a1=(ord==1)
g hombre_casado = estado_civil*genero
replace hombre_casado = (hombre_casado==1)
g universidad = (n_educ>=5 & n_educ<=6)
g instituto = (n_educ==4)
replace instituto = (n_educ==7) if instituto==0
g d_z2 = (zona2==2)
g ytot_ind0 = ylab
replace ytot_ind0 = 0 if ytot_ind0==.
replace ytot_ind = ytot_ind0 if ytot_ind==.
drop ytot_ind0
replace ytot_ind = max(ytot_ind, max(0,yoprinm)+max(0,yoprin)+max(0,yosec)) 
replace ytoth = ytot_ind if ytoth==. & a1==1
replace ytoth = ytot_ind if ytoth==. & a2==1
g yaotp = max(0, ypenh) + max(0,ysubh)  
g yact0 = max(0,yotroh)
replace yact=max(yact,yact0)
drop yact0

sum fol* sexo zona2 edad ytot_ind ocup a1 desem a2 ytoth yai yaotp yact
capture drop desem
g desem = (ocup==0) if ocup<.
capture drop tr_eda*
g tr_edad=0
replace tr_edad=1 if edad>=15 & edad<25
replace tr_edad=2 if edad>=25 & edad<35
replace tr_edad=3 if edad>=35 & edad<45
replace tr_edad=4 if edad>=45 & edad<55
replace tr_edad=5 if edad>=55 & edad<65
replace tr_edad=5 if edad>=65 
g tr_edad2 = tr_edad //Tramos de edad 2 - Young, Middle Age, Old
recode tr_edad2 1/2=1 3/4=2 5=3
g nivel = 2 if instituto==1
replace nivel = 3 if univer==1
replace nivel = 1 if univer==0 & instituto==0
bysort comuna sexo tr_edad: egen niv_m=median(nivel)
replace nivel=round(niv_m) if nivel==.
capture rename educ anos_educ //s anos_educ //
rename nivel educ

g actividad=9
g sector_ind = actividad
recode sector_ind 0/2=1 3/5=2 6/9=3
xtile quintile_h = ytoth if ord==1 [fw=${factor_op}], nq(5)
bysort folio: egen q0=mean(quintile_h)
replace quintile_h = q0 if quintile_h==.
g quintile_renta = quintile_h //sexo zona2 tr_edad educ quintile_h ytot_ind ocup a1 desem a2 actividad sector_ind tr_edad2 ytoth yai yaotp yact
g folio_2017=folio
order factor_egm, first //factor_egm 
drop factor_m_c2002 factor_em_c2002 factor_gm_c2002 factor_egm_c2002  factor_sp_est_m factor_gm factor_em factor_m  q0

sum folio ord
capture g folio_efh = folio
joinby folio_efh ord using "$path_s3\hist_dynamic_un06_11_17.dta", unmatched(both) update
tab _merge
sum folio ord
drop _merge
keep folio_2017 folio_efh folio anoe mese ord a1 a2 nive_edu* flab_0 pet_0 sh_inc* sexo lfp* sector_ind actividad tedad factor_egm zona2 s ocup desem pet_0 pet casado ///
tr_edad* tedad s ytot* c_vp yefec num_adul num_men num_sen rci* ing rci_pend_75 us_rci_75 numh edad* hombre_casado genero ///
instituto universidad cf* dec_renta educ constant year decil_h estrato_h layoffs_sect jobfind zona*  d_dna quintile* gtotal ///
unemp_sect class_co* yai yaotp yact deuda_cons_banco banco *_sect ytot_p_h d_dt d_vp df_dna df_vp p_cons p_tbco p_ccom p_cbco ///
d_td1 d_td2 d_td3 d_td4 d_td5 d_td6 d_td7 d_td8 d_dotras d_dna d_dt d_dtot d_cons rda  tedu vivprop d_chhip d_chvp d_chotp ///
cf_dna cf_dt cf_dtot cf_td1 cf_td2 cf_td3 cf_td4 cf_td5 cf_td6 cf_td7 cf_td8 cf_dotras cbco ///
f1* f4* f3* f13* f16* f7* f9* f23* f20_* f21_* n1 m6 m7  ///
a6 e7* e9* e13* e20* e29* e25* e26* e34* e35* e66* e67* e75* e76* e27* e36* e52* e55* ///
e70* e68* e77* e39* e59* e49* e57* e73* e28* e69* e15* e39* e28* e4* e5* e20* e17* ///
p_fin tipo_trab df_*_new EDF* DF* dcbco dtbco cfdtbco cfdtcc cfdcbco meses_inicio_t* meses_apagar_t* ///
tarjetas_bancaria_al_dia tarjetas_cc_al_dia date_survey folio_2014
drop cf_*_*
capture rename e20_uf e19_uf
capture rename e20_p e19_p
capture rename e20_t e19_t
capture rename e20t e19_t

capture g FolioNuevo=folio
gen yearEFH = 2017  // capture g year = yearEFH
capture g year_efh=yearEFH  //year
sum folio_efh year_efh
capture g numh2=min(numh,6)
char  _dta[_mi_update]
char  _dta[_mi_N]
char  _dta[_mi_style]
char  _dta[_mi_marker]
char  _dta[_mi_M]
local tk=5  // 4 before 2014, 5 from 2014 and on
forval dk = 1/3 {
rename f16t_t`tk'd`dk' f15t_t`tk'd`dk'
rename f16_t`tk'd`dk' f15_t`tk'd`dk'
}
save "$path_s1\\${data_save}_${yk}.dta", replace
