set more off
use "$path_s2\BaseSBIF_final.dta", clear
drop if c_nor==0 & c_inc==0 & mc_atr==0 & cc_atr==0 // I consider these debts were paid
drop if t_deu>=6 & t_deu<=10 & f_cre<19720101
drop if t_deu==2 & f_cre<19720101
egen folio = group(FolioNuevo yearEFH)
egen folio2 = group(FolioNuevo)
sum fol*  // No repeated Ruts that may appear in the panel section of different years: good
sum folio orden c_nor //sum yearEFH FolioNuevo folio f_reg t_deu f_cre p_cre orden //sort yearEFH FolioNuevo f_reg t_deu f_cre p_cre c_nor
collapse (firstnm) orden (max) cc_atr cm_cuo c_jud n_inscod_tdeu n_inscod (sum) c_nor- mc_atr, by(yearEFH FolioNuevo f_reg t_deu f_cre p_cre)
save "$path_s2\BaseSBIF_final_vs2.dta", replace
// A Credit of the same type made in the same day is the same credit (f_cre)
collapse (firstnm) orden (max) cc_atr cm_cuo c_jud n_inscod_tdeu n_inscod p_cre (sum) c_nor- mc_atr, by(yearEFH FolioNuevo f_reg t_deu f_cre)
order yearEFH FolioNuevo f_reg t_deu f_cre p_cre orden, first
save "$path_s2\BaseSBIF_final_vs2.dta", replace
save "$path_s2\BaseSBIF_final_vs2_0.dta", replace

//    // 1.0 Collapse Debts of small value with origin in same month   //
keep if t_deu==1 | t_deu==3 | t_deu==5  | (t_deu==4 & f_cre==.) | (t_deu==4 & f_cre<19720101) 
save "$path_s2\BaseSBIF_final_vs2_1.dta", replace
use "$path_s2\BaseSBIF_final_vs2.dta", clear  // Debts of the same type in the same month are the same debt if 2nd biggest to last sum 10% or less of total
keep if t_deu==2 | (t_deu==4 & f_cre>=19720101) | (t_deu>=6 & t_deu<=10) 
g f_cre0 = floor(f_cre/100) if f_cre>=19720101 
egen id_credito0 = group(FolioNuevo yearEFH f_cre0 t_deu) if t_deu==2 | t_deu==4 | (t_deu>=6 & t_deu<=10)  //include p_cre ??
bysort id_credito0 f_reg: egen rank_credit = rank(mo_deu) if id_credito0<. & f_reg<., field
g mo_deu1=mo_deu if id_credito0<. & f_reg<. & rank_credit==1
g mo_deu2=mo_deu if id_credito0<. & f_reg<. & rank_credit>=2 & rank_credit<.
bysort id_credito0 f_reg: egen mo_deu_rank1 = total(mo_deu1), missing
bysort id_credito0 f_reg: egen mo_deu_rank2 = total(mo_deu2), missing 
bysort id_credito0 f_reg: egen mo_deu_rank_max = max(mo_deu2)
g sh_rank2=mo_deu_rank2/(mo_deu_rank2+mo_deu_rank1)
g sh_rank3=mo_deu_rank_max/(mo_deu_rank2+mo_deu_rank1)
g sh_rank4=mo_deu/(mo_deu_rank2+mo_deu_rank1)
sum sh_rank2 sh_rank3 if id_credito0<. & f_reg<. & rank_credit==1, d 
g sh_rank1=min(sh_rank2,sh_rank3)
pwcorr sh_rank*
sum sh_rank* if sh_rank3==0
sort yearEFH FolioNuevo f_reg t_deu f_cre0 rank_credit
replace rank_credit=1 if rank_credit<. & sh_rank2<=0.20
replace rank_credit=1 if rank_credit<. & sh_rank3<=0.125
replace rank_credit=1 if rank_credit<. & sh_rank1<=0.10
replace rank_credit=1 if rank_credit<. & sh_rank1<=0.25 & (p_cre<=1 | p_cre==.)
replace rank_credit=1 if rank_credit<. & sh_rank4<=0.075 & (p_cre<=1 | p_cre==.)
replace rank_credit=1 if rank_credit<. & sh_rank4<=0.15 & (p_cre>=2 & p_cre<=4)
replace rank_credit=1 if t_deu>=6 & t_deu<=10  // rank_credit<. & //Collapse mortgages originated in same month, independently of value
collapse (firstnm) orden f_cre (max) cc_atr cm_cuo c_jud n_inscod_tdeu n_inscod p_cre (sum) c_nor- mc_atr, by(yearEFH FolioNuevo f_reg t_deu f_cre0 rank_credit)
order yearEFH FolioNuevo f_reg t_deu f_cre p_cre orden, first
drop rank_credit f_cre0
save "$path_s2\BaseSBIF_final_vs2_2.dta", replace
use "$path_s2\BaseSBIF_final_vs2_1.dta", clear
append using "$path_s2\BaseSBIF_final_vs2_2.dta"
save "$path_s2\BaseSBIF_final_vs2.dta", replace
//    // 2.0 Collapse Debts of small value that exist in the same month and have less than one month of maturity   //
use "$path_s2\BaseSBIF_final_vs2.dta", clear  // Debts of the same type in the same month are the same debt if 2nd biggest to last sum 10% or less of total
keep if t_deu==2 | t_deu==4 | (t_deu>=6 & t_deu<=10) 
egen id_credito0 = group(FolioNuevo yearEFH f_reg t_deu) if t_deu==2 | t_deu==4 | (t_deu>=6 & t_deu<=10)  //include p_cre ??
bysort id_credito0: egen rank_credit = rank(mo_deu) if id_credito0<., field
g mo_deu1=mo_deu if id_credito0<. & rank_credit==1
g mo_deu2=mo_deu if id_credito0<. & rank_credit>=2 & rank_credit<.
bysort id_credito0: egen mo_deu_rank1 = total(mo_deu1), missing
bysort id_credito0: egen mo_deu_rank2 = total(mo_deu2), missing 
bysort id_credito0: egen mo_deu_rank_max = max(mo_deu2)
g sh_rank2=mo_deu_rank2/(mo_deu_rank2+mo_deu_rank1)
g sh_rank3=mo_deu_rank_max/(mo_deu_rank2+mo_deu_rank1)
g sh_rank4=mo_deu/(mo_deu_rank2+mo_deu_rank1)
sum sh_rank2 sh_rank3 if id_credito0<. & rank_credit==1, d 
g sh_rank1=min(sh_rank2,sh_rank3)
pwcorr sh_rank*
sum sh_rank* if sh_rank3==0
sort yearEFH FolioNuevo t_deu f_cre rank_credit
replace rank_credit=1 if rank_credit<. & sh_rank2<=0.20
replace rank_credit=1 if rank_credit<. & sh_rank3<=0.125
replace rank_credit=1 if rank_credit<. & sh_rank1<=0.10
replace rank_credit=1 if rank_credit<. & sh_rank1<=0.25 & (p_cre<=1 | p_cre==.)
replace rank_credit=1 if rank_credit<. & sh_rank4<=0.075 & (p_cre<=1 | p_cre==.)
replace rank_credit=1 if rank_credit<. & sh_rank4<=0.15 & (p_cre>=2 & p_cre<=4)
collapse (firstnm) orden f_cre (max) cc_atr cm_cuo c_jud n_inscod_tdeu n_inscod p_cre (sum) c_nor- mc_atr, by(yearEFH FolioNuevo f_reg t_deu rank_credit)
order yearEFH FolioNuevo f_reg t_deu f_cre p_cre orden, first
drop rank_credit
save "$path_s2\BaseSBIF_final_vs2_2.dta", replace
use "$path_s2\BaseSBIF_final_vs2_1.dta", clear
append using "$path_s2\BaseSBIF_final_vs2_2.dta"
save "$path_s2\BaseSBIF_final_vs2.dta", replace
//   END //   //

sum orden c_nor
bysort yearEFH FolioNuevo f_reg t_deu: egen rank_credit = rank(c_nor), field
sort yearEFH FolioNuevo f_reg t_deu rank_credit
replace rank_credit = min(rank_credit, 4)  // Now keep only 4 largest debts (4th debt sums all the smallest debts)
sum orden c_nor
sort yearEFH FolioNuevo f_reg t_deu rank_credit
collapse (firstnm) orden f_cre p_cre (max) cc_atr cm_cuo c_jud n_inscod_tdeu n_inscod (sum) c_nor- mc_atr, by(yearEFH FolioNuevo f_reg t_deu rank_credit)
save "$path_s2\BaseSBIF_final_vs2.dta", replace

use "$path_s2\BaseSBIF_final_vs2.dta", clear
drop if c_nor==0 | c_nor==.
collapse f_reg, by(yearEFH FolioNuevo)
drop f_reg
save "$path_s2\BaseSBIF_Ruts.dta", replace
