set more off
global outlier_op = 0 // 0 - Include only outliers for big values, 1 - Include outliers of both big and small values
global date_op = 1  // 0 Dates for 2014 and 2015, 1 - from 2011-05 to 2012-07, 2 - all dates since 2002 are used
local grains "${yk}" //"07 08 09 10 11 14"
global Rut_op = 0 // 0 - include all the Ruts in the match, 1 - Include just Ruts that appear with some debt between 2003 until now

use "$path_s1\\${data_save}_${yk}.dta", clear   // Add Labor-Variables to EFH-SBIF data
// create variable for whether interviewed is not the highest income member 
// create variable for whether there are other HH members of similar/higher age than interviewed and with income
bysort folio_efh yearEFH: egen ytot_ind_max = max(ytot_ind)  
g ytot_ind_max0 = ytot_ind_max-1000 // allow for 1,000 pesos difference
g ytot_ind_max2=(1/2)*ytot_ind_max
bysort folio_efh yearEFH: egen edad_max = max(edad) //g edad_male = edad if sexo==1  //g edad_female = edad if sexo==0 
g member_HALFymax = (ytot_ind>ytot_ind_max0) if ytot_ind<.  //bysort folio_efh yearEFH: egen edad_male_max = max(edad_male)
g member_HALFymax_male = (ytot_ind>ytot_ind_max0) if ytot_ind<. & sexo==1 //bysort folio_efh yearEFH: egen edad_female_max = max(edad_female)
g member_ymax = (ytot_ind>ytot_ind_max2) //g member_ymax_female = (ytot_ind>ytot_ind_max0) if ytot_ind<. & sexo==0
g member_ymax_male = (ytot_ind>ytot_ind_max0) if ytot_ind<. & sexo==1 
bysort folio_efh yearEFH: egen nr_y_max = total(member_ymax)  
bysort folio_efh yearEFH: egen nr_y_max_male = total(member_ymax_male)  
bysort folio_efh yearEFH: egen nr_y_HALFmax = total(member_HALFymax) 
bysort folio_efh yearEFH: egen nr_y_HALFmax_male = total(member_HALFymax_male)   
g a1_nothighest_income = (ytot_ind<ytot_ind_max) if a1==1
replace a1_nothighest_income = 1 if a1==1 & a1_nothighest_income==.
g a1_nothighest_age = (edad<edad_max) if a1==1
g a1_female_HHmaleinc = (nr_y_HALFmax_male>=1 & nr_y_HALFmax_male<.) if a1==1 & sexo==0
replace a1_female_HHmaleinc=0 if a1==1 & a1_female_HHmaleinc==.
drop ytot_ind_max0 ytot_ind_max2 member_*
//    //     //		//		//		//		//		//		//		//		//

*joinby folio_efh year_efh using "$path_s3\EFH_risk_yq2_${yk}.dta", unmatched(both) update //joinby folio_efh year_efh using "$path_s1\EFH_risk_yq0_${yk}.dta", unmatched(both) update
capture tab _merge  // Format DF is no longer necessary!
capture drop _merge  //do "$path_bs_do\format_DF_20${yk}.do" 
local k=5  // Banking Consumer Credit
local tcc=`k'
if ${yk}==11 {  // In 2011 consumer credit was type 4 of debt
local tcc = 4
} 
local mk=1 // nr of months of default - use 1 or 3
g df_dna_a1 = . //f3_t`tcc'd`k2'
g df_dna_k = .
forv k2=1/3 {
g df_dna_k0 = (DF26_t`k'd`k2'>=2 & DF26_t`k'd`k2'<=3 & DF27_t`k'd`k2'>=`mk' & DF27_t`k'd`k2'<97) if a1==1 & d_td`k'>0 & d_td`k'<. & cf_td`k'>0 & cf_td`k'<.
if `mk'==1 {
replace df_dna_k0 = 1 if DF26_t`k'd`k2'>=2 & DF26_t`k'd`k2'<=3 & df_dna_k0<.
} 
replace df_dna_k = df_dna_k0 if (df_dna_k==. & df_dna_k0!=.) | (df_dna_k==0 & df_dna_k0!=.)
replace df_dna_a1 = df_dna_k0 if (df_dna_a1==. & df_dna_k0!=. & f3_t`tcc'd`k2'==1) | (df_dna_a1==0 & df_dna_k0!=. & f3_t`tcc'd`k2'==1)
capture drop df_dna_k0 
} 
replace df_dna_k = 0 if df_dna_k==. & d_td`k'>0 & d_td`k'<. & cf_td`k'>0 & cf_td`k'<. & a1==1
save "$path_s1\\${data_save}_${yk}.dta", replace

keep if a1==1  // Only data at the household level and for the interviewed person
joinby folio_2017 using "$path_s2\sbif_efh2017.dta", unmatched(master) update //"$path_s2\c_Dad_HFsurvey.dta"
tab _merge
if ${Rut_op}==1  {
keep if _merge==3  // It seems 24 HH folios do not have a match on EFH-SBIF data
drop if c_nor==0
drop if c_nor==.
} 
drop _merge

g f_cre0 = floor(f_cre/100) if f_cre>=19720101 
egen id_credito0 = group( yearEFH folio_2017 f_cre0 t_deu) if t_deu==2 | (t_deu>=6 & t_deu<=10) //FolioNuevo
bysort f_reg id_cre: egen nr=count(t_deu)  if id_credito0<.
bysort t_deu: sum nr
drop id_credito0 nr f_cre0
sum f_reg
//          //      //
label define t_deu1 1 "Tarjetas de credito" 2 "Credito en cuotas" ///
3 "Creditos a estudiantes" 4 "Otros creditos de consumo" ///
5 "Lineas de credito en cuenta corriente" ///
6 "Hipotecario en letras" 7 "Mutuo hipotecario endosable" ///
8 "Hipotecario comprado a ANAP" 9 "Mutuo hipotecario no endosable" ///
10 "Otros creditos hipotecarios"
label values t_deu t_deu1
label define t_deu2 1 "Tarjetas de credito" 2 "Credito en cuotas" ///
3 "Creditos a estudiantes" 4 "Hipotecarios"
g t_deu2 = min(6,t_deu) if t_deu<.
recode t_deu2 4/5=1 6=4
label values t_deu2 t_deu2
label define t_deu3 1 "creditos de consumo" 2 "Hipotecarios"
g t_deu3 = min(6,t_deu) if t_deu<.  // Consumo: *1 Tarjetas de credito *2 Credito en cuotas *3 Creditos a estudiantes Recursos CORFO
recode t_deu3 2/5=1 6=2    //4 Otros creditos de consumo *5 Lineas de credito en cuenta corriente
label values t_deu3 t_deu3  // Hipotecario de vivienda: *6 Hipotecario en letras de credito *7 Mutuo hipotecario endosable
//8 Hipotecario comprado a ANAP(No Usar) *9 Mutuo hipotecario no endosable *10 Otros creditos hipotecarios

//   //     //    //
g year_date = substr(string(f_reg, "%11.0g"), 1, 4)
g month_date = substr(string(f_reg, "%11.0g"), 5, 6)
g date_credit = f_cre if f_cre>19780609
g year_credit = substr(string(date_credit, "%11.0g"), 1, 4)
g month_credit = substr(string(date_credit, "%11.0g"), 5, 6)
replace month_credit = substr(month_credit, 1, 2)
destring year_date month_date year_credit month_cred, replace force
g quarter_credit = ceil(month_credit/3)
g quarter_date = ceil(month_date/3)
generate date_quarter = yq(year_date, quarter_date)
generate date2_quarter = yq(year_cre, quarter_cre)
generate date_month = ym(year_date, month_date)
g year_cre2 = year_cre  //   //     //  //   //     //  //   //     //
replace year_cre2 = . if year<1976  // maximum credit is 30 years (2007-30=1977
generate date2_month = ym(year_cre2, month_cre)  //ym(year_cre, month_cre)
drop year_cre2  //   //     //  //   //     //  //   //     //
format %tq date_quarter // Turn data into quarterly data
format %tq date2_quarter // Turn data into quarterly data
g vintage_q = ceil(date_quarter-date2_q)
replace vintage_q = max(0,vintage_q) if vintage<. & mo_de>0 & mo_de<.
replace vintage_q = . if mo_de<=0 
bysort t_deu2: sum vintage, d
bysort t_deu2: egen vintage_max=pctile(vintage), p(95)
replace vintage_q=min(vintage_q,vintage_max) if vintage_q<.
replace vintage_q=min(vintage_q,16) if vintage_q<. & t_deu3==1 // Few consumer credits have more than 4 years of age
g vintage_m = ceil(date_month-date2_month)
drop vintage_ma  
g maturity_q = ceil(p_cre/3)
order fol* f_cre yearEFH year_efh factor_* t_deu year_date month_date date_credit-date2_month vintage* p_cre maturi*, first
//   //     //    //

g year_v = year_credit
replace year_v = year_date  if year_v==.  // or year_date-1 
replace year_v = max(2002, year_v)
g quarter_v = quarter_credit
replace quarter_v = quarter_date if quarter_v==.
joinby folio_efh year_efh year_v quarter_v using "$path_s3\\EFH_risk_yq2_${yk}.dta", unmatched(master) update //joinby folio year using "$path_s1\EFH_risk2.dta", unmatched(master) update
tab _merge
drop _merge
foreach v of varlist layoffs_sect_v jobfind_v unemp_sect_v rr_inc_sect_v sd_ln_inc_sect_v ytot_p_h_v { //ytot_ind_v
rename `v' `v'_q
}
replace year_v = year_date  
replace quarter_v = quarter_date
joinby folio_efh year_efh year_v quarter_v using "$path_s3\\EFH_risk_yq2_${yk}.dta", unmatched(master) update //joinby folio year using "$path_s1\EFH_risk2.dta", unmatched(master) update
tab _merge
drop _merge
sum lay*
pwcorr lay*
egen id = group(folio)  // some folios ended up being eliminated because they had no observations of credit
sum id

//   Create measures of outliers  //	//		//		//		//		//	 //
sum t_deu p_cre vintage_m orden maturity_q f_cre date_credit date_quarter cc_atr cm_cuo c_nor c_inc mo_deu mc_atr n_inscod_tdeu n_inscod

quietly {  // Outliers relative to the population
local n1 "1/2 4/7 9 10"
local n2 "2 4 6/7 9 10"
local nvars1 "ing_out"
local nvars2 "ing_out mo_out"
g ing_out = max(1, ing, ln(ytoth) )
g mo_out = ln(mo_deu) 
local k=1
foreach v of varlist mo_out p_cre { //mo_deu p_cre //above or below 99 percentile of amount in the population for that debt // mo_deu mc_atr
g O_`v'Pop = .
g O_`v'PopC  = .
foreach num of numlist `n`k'' {		// 1/7 9 10  // foreach type of debt:	tab t_deu
sum `v' if `v'>0 & `v'<. & t_deu==`num' [fw=${factor_op}], d
replace O_`v'Pop = 1 if `v'>r(p95) & `v'<. & t_deu==`num' // Unconditional outlier
if ${outlier_op}==1  {
replace O_`v'Pop = 2 if `v'<r(p5) & `v'<. & t_deu==`num'
}
reg `v' `nvars`k'' i.(tr_edad2 educ numh2) if `v'>0 & `v'<. & t_deu==`num' // tr_numh numh or non
if `k'==1 { 
outreg2 using "$path_p\graphs\\OutRegs${yk}_`num'S.xls", replace
}
else {
outreg2 using "$path_p\graphs\\OutRegs${yk}_`num'S.xls", append
}
predict `v'_x
replace `v'_x = `v'-`v'_x if `v'>0 & `v'<. & t_deu==`num'
sum `v'_x if `v'>0 & `v'<. & t_deu==`num' [fw=${factor_op}], d
replace O_`v'PopC = 1 if `v'_x>r(p95) & `v'<. & t_deu==`num' // Conditional on X outlier
if ${outlier_op}==1  {
replace O_`v'PopC = 2 if `v'_x<r(p5) & `v'<. & t_deu==`num'
}
drop `v'_x
}
local k=1+`k'
}
}
rename O_mo_outPop O_mo_deuPop
rename O_mo_outPopC O_mo_deuPopC
replace O_mo_deuPop = max(O_mo_deuPop,O_p_crePop) //
replace O_mo_deuPopC = max(O_mo_deuPopC,O_p_crePopC) //

//  Outliers relative to history of the debtor himself
g mo_deu0 = mo_deu if mo_deu>0
replace mo_deu0 = ceil(mo_deu0/25000) // in units of 25,000 pesos to prevent rounding error
bysort folio_efh year_efh t_deu: egen moP5_Tdeu = pctile(mo_deu0), p(5) // Outliers for original debt
bysort folio_efh year_efh t_deu: egen moP95_Tdeu = pctile(mo_deu0), p(95)
g O_dH = 1 if mo_deu0>moP95_Tdeu & moP95_Tdeu<. & mo_deu0>0 & mo_deu0<.
bysort folio_efh year_efh t_deu: egen pcP5_Tdeu = pctile(p_cre), p(5) // Outliers for original debt
bysort folio_efh year_efh t_deu: egen pcP95_Tdeu = pctile(p_cre), p(95)
replace O_dH = 1 if p_cre>pcP95_Tdeu & pcP95_Tdeu<. & p_cre>0 & p_cre<.
if ${outlier_op}==1  {
replace O_dH = 2 if mo_deu0<moP5_Tdeu & moP5_Tdeu<. & mo_deu0>0 & mo_deu0<.
replace O_dH = 2 if p_cre<pcP5_Tdeu & pcP5_Tdeu<. & p_cre>0 & p_cre<.
}
replace mo_deu0 = . if t_deu==1  | t_deu==3 | t_deu==5 | t_deu==8 // | t_deu==4

//  Outliers relative to history of the loan itself  
g f_cre0 = floor(f_cre/100) if f_cre>=19720101 //g p_cre0 = p_cre if p_cre>0 & p_cre<. //ceil(p_cre/3) if p_cre>0 & p_cre<.
*egen id_credito0 = group(folio_efh year_efh f_cre0 t_deu rank_credit) if t_deu==2 | (t_deu>=6 & t_deu<=10)  // //include p_cre ??
egen id_credito0 = group(folio_efh year_efh f_cre0 t_deu) if t_deu==2 | (t_deu>=6 & t_deu<=10)  // rank_credit //include p_cre ??
replace id_credito = . if mo_deu0==. | mo_deu0==0 | f_cre==. | f_cre<19720101
bysort id_credito0: egen rank_idc = rank(p_cre) if id_credito<., field
sum rank_idc if rank_idc==1
local x_i=r(N)
sum rank_idc if rank_idc>1
local x_i=`x_i'/(`x_i'+r(N))
display("`x_i'")
bysort t_deu: sum rank_idc if rank_idc>1
char  _dta[_mi_update]
char  _dta[_mi_N]
char  _dta[_mi_style]
char  _dta[_mi_marker]
char  _dta[_mi_M]
save "$path_s1\EFH_risk_sbif0_fcre.dta", replace
keep if f_cre0==f_reg & id_credito0<.
g mo0_loans = mo_deu0 
g pc0_loans = p_cre 
bysort id_credito0: g loan_nr = _n 
sum loan_nr *loans id_cre*
keep loan_nr *loans id_cre* 
keep if loan_nr<.
reshape wide mo0_loans pc0_loans , i( id_credito0) j( loan_nr)
save "$path_s1\data_temp0.dta", replace
use "$path_s1\EFH_risk_sbif0_fcre.dta", clear
sum folio_efh year_efh f_reg
joinby id_credito0 using "$path_s1\data_temp0.dta", unmatched(master) update
tab _merge
drop _merge
bysort id_credito: egen moP25_deu = pctile(mo_deu0) if id_credito<., p(25) // Outliers for original debt
bysort id_credito: egen moP50_deu = pctile(mo_deu0) if id_credito<., p(50)
bysort id_credito: egen moP75_deu = pctile(mo_deu0) if id_credito<., p(75)
local num=1 //foreach num of numlist 1/3 { //1/3
g O_modeu`num'=.
replace O_modeu`num' = 1 if ((mo0_loans`num'>=1.25*mo_deu0) | (mo0_loans`num'<=0.75*mo_deu0)) & (mo_deu0<. & mo_deu0>0 & id_credito<. & mo0_loans`num'<.)
g O_pcre`num'=.
replace O_pcre`num' = 1 if ((pc0_loans`num'>=1.25*p_cre) | (pc0_loans`num'<=0.75*p_cre)) & (p_cre<. & p_cre>0 & id_credito<. & pc0_loans`num'<.)
*}
egen O_modeu = rowmin(O_modeu*)
egen O_pcre = rowmin(O_pcre*)
replace O_modeu = 0 if O_modeu==.
replace O_pcre = 0 if O_pcre==.
replace O_modeu = . if mo_deu0==.  | mo_deu0==0  | id_credito==.
replace O_pcre = . if p_cre==.  | p_cre==0  | id_credito==.
sum O_modeu O_pcre id_credito
tab O_modeu O_pcre
replace O_modeu=max(O_modeu,O_pcre)  // one of the reports was strange
sum O_modeu O_pcre id_credito [fw=${factor_op}]
bysort t_deu: sum O_modeu [fw=${factor_op}]
replace O_modeu = . if O_modeu==0
bysort t_deu: sum O_* [fw=${factor_op}]
capture drop O_modeu1 O_modeu2 O_modeu3 O_pcre1 O_pcre2 O_pcre3 O_pcre
capture drop O_modeu1 O_pcre1 
/* g O_modeu = 1 if ((moP50_deu>=1.34*mo_deu0) | (moP50_deu<=0.67*mo_deu0)) & (mo_deu0<. & mo_deu0>0 & id_credito<.)
replace O_modeu = 2 if ((moP25_deu>mo_deu0) | (moP25_deu<=0.50*mo_deu0)) & (mo_deu0<. & mo_deu0>0 & id_credito<. & O_modeu==.)
replace O_modeu = 3 if ((moP75_deu>=1.5*mo_deu0) | (moP75_deu<mo_deu0)) & (mo_deu0<. & mo_deu0>0 & id_credito<. & O_modeu==.)
replace O_modeu = . if mo_deu0==.  | mo_deu0==0 | id_credito==.  */
g r_p = p_cre-vintage_m
g ir = 0.05/12 if t_deu>=6 & t_deu<=10
replace ir = 0.20/12 if t_deu==2
g c_nor_linear_am = mo_deu0*((p_cre-vintage_m)/p_cre) if mo_deu0>0 & mo_deu0<. & id_credito<. //  Outliers for current debt (c_nor)
replace c_nor_linear_am = ceil((max(0,c_nor)+max(0,c_inc))/25000)/c_nor_linear_am
g c_nor_linear_am0 = mo_deu0*(1-(1.0001)^(-r_p))/(1-(1.0001)^(-p_cre)) if mo_deu0>0 & mo_deu0<. & id_credito<. // Outliers with 0 interest rate
replace c_nor_linear_am0 = ceil((max(0,c_nor)+max(0,c_inc))/25000)/c_nor_linear_am0
g c_nor_linear_am2 = mo_deu0*(1-(1+ir)^(-r_p))/(1-(1+ir)^(-p_cre))
replace c_nor_linear_am2 = . if mo_deu0==.  | mo_deu0==0  | id_credito==. 
replace c_nor_linear_am2 = ceil((max(0,c_nor)+max(0,c_inc))/25000)/c_nor_linear_am2
g O_cnor0 = 1 if c_nor_linear_am<=0 // loans that should already have been paid (maybe maturity was extended)
replace O_cnor0 = 2 if c_nor_linear_am>0 & c_nor_linear_am<=0.5 //loans that are lower than expected
replace O_cnor0 = 3 if c_nor_linear_am>=2 & c_nor_linear_am<.  // loans bigger than expected
g O_cnor1 = 1 if c_nor_linear_am<=0 | r_p<0
replace O_cnor1 = 2 if c_nor_linear_am0>0 & c_nor_linear_am0<=0.66 //loans that are lower than expected
replace O_cnor1 = 3 if c_nor_linear_am0>=1.34 & c_nor_linear_am0<.  // loans bigger than expected
g O_cnor = 1 if c_nor_linear_am<=0 | r_p<0
replace O_cnor = 2 if c_nor_linear_am2>0 & c_nor_linear_am2<=0.66 //loans that are lower than expected
replace O_cnor = 3 if c_nor_linear_am2>=1.34 & c_nor_linear_am2<.  // loans bigger than expected
tab O_cnor0 O_cnor
tab O_cnor1 O_cnor
pwcorr c_nor_linear_am c_nor_linear_am0 c_nor_linear_am2
sum c_nor_linear_am c_nor_linear_am0 c_nor_linear_am2
replace O_cnor=. if O_cnor==1 & O_cnor1!=1
replace O_cnor=. if O_cnor==2 & O_cnor1!=2
replace O_cnor=. if O_cnor==3 & O_cnor1!=3
replace O_modeu=max(O_modeu,O_cnor)
drop mo_deu0 moP*_*deu pcP*_* c_nor_linear_am c_nor_linear_am0 c_nor_linear_am2 ing_out mo_out id_credito mo0_loans* pc0_loans* r_p ir O_cnor0 O_cnor1 //nr_idc nr
//   End	  //	//		//		//		//		//	 //

save "$path_s1\EFH_risk_sbif0_fcre.dta", replace 
collapse folio FolioNuevo yearEFH year_efh, by(id)
save "$path_s1\EFH_folios_20${yk}_all.dta", replace 

use "$path_s1\EFH_risk_sbif0_fcre.dta", clear
if ${yk}==11 {
if ${date_op}==0 {
drop if f_reg<=201012
drop if f_reg>=201301
}
if ${date_op}==1 {
drop if f_reg<=201104  
drop if f_reg>=201208  
}
}
if ${yk}==14 {
if ${date_op}==0 {
drop if f_reg<=201312
drop if f_reg>=201601
}
if ${date_op}==1 {
drop if f_reg<=201403 
drop if f_reg>=201507  
}
}
if ${yk}==17 {
if ${date_op}==0 {
drop if f_reg<=201612
drop if f_reg>=201901
}
if ${date_op}==1 {
drop if f_reg<=201702 
drop if f_reg>=201804  
}
}
capture drop id  // some folios eliminated because they had no credit during years of EFH
egen id = group(folio)
sum id
drop folio_*
save "$path_s1\EFH_risk_sbif0_fcre.dta", replace  
save "$path_s1\EFH_risk_sbif0_fcre_20${yk}.dta", replace  
collapse FolioNuevo yearEFH year_efh, by(id)
drop id
save "$path_s1\EFH_folios_20${yk}_sbif.dta", replace 
joinby FolioNuevo yearEFH year_efh using "$path_s1\EFH_folios_20${yk}_all.dta", unmatched(both) update
tab _merge
keep if _merge==2
drop _merge id
save "$path_s1\EFH_folios_20${yk}_nosbif.dta", replace 
