***************************************************************************************
* ANALISIS RESUMIDO DE LAS REGRESIONES
***************************************************************************************

error_mortgageEFH_notSBIF error_prestamoEFH_notSBIF
* Base regresiones
*use "N:\DPF\GIF\Investigación Financiera\Investigación\Proyectos\2017\Cruce_EFH_SBIF_PM_FM_PR\Cruce_vCM\Bases CM\Regresion\analysis11_14_17.dta", clear
use "/Users/paulamargaretic/Dropbox/Cruce/Paper descriptivo/Stata/Bases y dofiles CM/Regresion/analysis11_14_17.dta"

drop edad2
gen edad2=edad*edad
*-------------
* Logit:
*-------------
* error_mortgageEFH_notSBIF
* 1: EFH=1 Y SBIF=0
* 0: EFH=1 Y SBIF=1 (aprox.)
logit error_mortgageEFH_notSBIF a1_nothighest_income nr_y_max a1_nothighest_age prestamo_SBIF [pw=factor_egm]
tab error_mortgageEFH_notSBIF
tab hipotecario_SBIF hipotecario_EFH ,miss

* Mine
logit error_mortgageEFH_notSBIF tr_edad2 i.ocup i.sexo i.zona2 a1_nothighest_income nr_y_max a1_nothighest_age  ytoth  [pw=factor_egm]

*error_prestamoEFH_notSBIF
* 1: EFH=1 Y SBIF=0
* 0: EFH=1 Y SBIF=1
logit error_prestamoEFH_notSBIF a1_nothighest_income nr_y_max a1_nothighest_age hipotecario_SBIF [pw=factor_egm]
tab error_prestamoEFH_notSBIF
tab  prestamo_SBIF prestamo_EFH


*------------
* OLS:
*------------
* Original:
local debt_types2 "hipotecario banco prestamo TL tarjeta linea"
local error_types0 "ratio0" //ratio0_cuota
local K=1
foreach x of local debt_types2 { //g E_`x'_monto`pp' = error_`x'_monto if deuda_`x'_EFH==1 & deuda_`x'_SBIF==1
display("`x'")
foreach x2 of local error_types0 {
g E_`x2'_`x' = 100*abs(error_`x2'_`x') if error_`x2'_`x'>-2 & error_`x2'_`x'<2  //make them in %
reg E_`x2'_`x' a1_nothighest_income nr_y_max a1_nothighest_age if deuda_`x'_EFH==1 & deuda_`x'_SBIF==1 [pw=factor_egm]
}
}

* Modificado:
*----
rename s educ_years
gen married=(estado_civil==1)
drop edad2
gen edad2=edad^2
de married sexo edad edad2 numh educ_years estrato macrozona tm  
*----
local debt_types2 "hipotecario banco prestamo TL tarjeta linea"
local error_types0 "ratio0" //ratio0_cuota
local K=1
foreach x of local debt_types2 { //g E_`x'_monto`pp' = error_`x'_monto if deuda_`x'_EFH==1 & deuda_`x'_SBIF==1
display("`x'")
foreach x2 of local error_types0 {
g E_`x2'_`x' = 100*abs(error_`x2'_`x') if error_`x2'_`x'>-2 & error_`x2'_`x'<2  //make them in %
reg E_`x2'_`x' a1_nothighest_income nr_y_max a1_nothighest_age      married sexo edad edad2 numh educ_years       if deuda_`x'_EFH==1 & deuda_`x'_SBIF==1 [pw=factor_egm]
}
}

 
