use "/Users/paulamargaretic/Dropbox/Cruce/Paper descriptivo/Stata/dta/EFH_SBIF_wide_11_14_17.dta", clear

local debt_types2 "hipotecario banco prestamo TL tarjeta linea"

*Preguntas: para un folio dado, tenes 2011 y 2017, como puede ser?

*Checks:

*Number of unique households
egen nb_folio = group(FolioNuevo)
summ nb_folio
*There are 6230 unique folios for the  7,818 obs. When restricting to include those with positive amounts of debt in the SBIF 
*I get the same 6230. But they are more than what they appear in table 1. Why????

tab yearEFH if (deuda_hipotecario_SBIF!=. | deuda_prestamo_SBIF!=. | deuda_TL_SBIF!=.)

egen nb_folio_cond = group(FolioNuevo) if (deuda_hipotecario_SBIF!=. | deuda_prestamo_SBIF!=. | deuda_TL_SBIF!=.)
summ nb_folio_cond if (deuda_hipotecario_SBIF!=. | deuda_prestamo_SBIF!=. | deuda_TL_SBIF!=.)

* Table 2: version overleaf 20190623
tab deuda_hipotecario_EFH deuda_hipotecario_SBIF [fw=factor_egm], cell nofreq 
tab deuda_prestamo_EFH deuda_prestamo_SBIF [fw=factor_egm], cell nofreq 
tab deuda_TL_EFH deuda_TL_SBIF [fw=factor_egm], cell nofreq 


* Table 3
local debt_log "deuda_m_hipotecario_EFH deuda_m_hipotecario_SBIF deuda_m_prestamo_EFH deuda_m_prestamo_SBIF deuda_m_TL_EFH deuda_m_TL_SBIF "
foreach v of local debt_log {
gen l`v'=log(`v')
}

tabstat ldeuda_m_hipotecario_EFH  [fw=factor_egm] if (deuda_hipotecario_EFH ==1 & deuda_hipotecario_SBIF ==1), stat(mean median)
tabstat ldeuda_m_hipotecario_EFH  [fw=factor_egm] if (deuda_hipotecario_EFH ==0 & deuda_hipotecario_SBIF ==1), stat(mean median)

