***************************************************************************************
* ANALISIS REGRESIONES PARA TESTEO HIPOTESIS
***************************************************************************************


* Base regresiones
global path "C:\Users\felma.000\Dropbox\Cruce\Paper descriptivo\Stata"
use "$path\dta\analysis11_14_17_vfix_long.dta", replace
use "/Users/paulamargaretic/Dropbox/Cruce/Paper descriptivo/Stata/dta/analysis11_14_17_vfix_long.dta", clear

*global path "C:\Users\pmargaretic\Dropbox\Cruce\Paper descriptivo\Stata"
*use "C:\Users\pmargaretic\Dropbox\Cruce\Paper descriptivo\Stata\dta\analysis11_14_17_vfix_long.dta" , clear
*/
global path "/Users/paulamargaretic/Dropbox/Cruce/Paper descriptivo/Stata"
*use "/Users/paulamargaretic/Dropbox/Cruce/Paper descriptivo/Stata/dta/analysis11_14_17_vfix_long.dta" , clear

* Se une base con infor adicional}

*joinby folio yearEFH tipo_deuda using "$path\dta\informacion_deudas.dta", unm(b)
joinby folio yearEFH tipo_deuda using "$path/dta/informacion_deudas.dta", unm(b)
tab _merge

***************************************************************************************
* Variables explicativas
***************************************************************************************

gen edad2=edad*edad
gen edad_d=int(edad/10)
label var edad_d "Age (in decades)"
g edadsq=edad_d*edad_d
label var edadsq "Age (in decades) squared"
gen terc_educ=(neduc>3)
label var terc_educ "Interviewed holds a post-secondary degree"
gen relationship =(est_civ==2)
label var relationship "In a relationship"
gen sobr_end=(perc_end==1|perc_end==2)
label var sobr_end "Household feels over-indebted"
gen       int_knowledge=(x_n3==3)
label var int_knowledge   "Good knowledge of the interviewed"
gen       int_disposition=(x_n5==3)
label var int_disposition "Good disposition of the interviewed"
g c6_act_indef2=c6_act_indef 
recode c6_act_indef2 2=1 7=1 4=3 6=3
lab def c6_act_indef2 1 "Self-employed" 3 "Civil servant" 5 "Private sector" 8 "Inactive or unemployed" 9 "Pensioner", modify
label values c6_act_indef2 c6_act_indef2
label var c6_act_indef2 "Occupational status"
gen n_cconhip=n_ccon+n_chip
label var n_cconhip "Number of loans"
gen p_estrato3   =(estrato==3)
label var p_estrato3 "If household belongs to highest 2 deciles"
/* Not working here
gen tipo_d=(tipo==9)
label var tipo_d "Type of banking debt"
lab def tipo_d 0 "Installment loan" 1 "Mortgage loan" , modify
label values tipo_d tipo_d
*/
gen education=1 if neduc==1 | neduc==2
replace education=2 if neduc==3
replace education=3 if neduc==4
replace education=4 if neduc==5
label var education "Education"
lab def education 1 "Only school" 2 "Technical education" 3 "University" 4 "Postgraduate" , modify
label values education education

gen male_nmarried=(genero==1 & married==0)
label var male_nmarried "Male, not married"
/*bys folio yearEFH: egen atr_12m_h=max(atr_12m)
label var atr_12m_h "Interviewed has had credit arrears in last 12 months"
*/

***************************************************************************************
* Replicating table 8 on the maximum income member
***************************************************************************************

/*Case (EFH=1,SBIF=0)
* Mortgages
tab d_nomax_ing if (deuda_hipotecario_SBIF==0 & deuda_hipotecario_EFH==1 & reporut_2017!=0 )
* IL
tab d_nomax_ing if (deuda_prestamo_SBIF==0 & deuda_prestamo_EFH==1 & reporut_2017!=0 )
* TL
tab d_nomax_ing if ((deuda_tarjeta_SBIF==0 & deuda_tarjeta_EFH==1 & reporut_2017!=0 ) | (deuda_linea_SBIF==0 & deuda_linea_EFH==1 & reporut_2017!=0 ))

*Case (EFH=1,SBIF=1)
* Mortgages
tab d_nomax_ing if (deuda_hipotecario_SBIF==1 & deuda_hipotecario_EFH==1 & reporut_2017!=0 )
* IL
tab d_nomax_ing if (deuda_prestamo_SBIF==1 & deuda_prestamo_EFH==1 & reporut_2017!=0 )
* TL
tab d_nomax_ing if ((deuda_tarjeta_SBIF==1 & deuda_tarjeta_EFH==1 & reporut_2017!=0 ) | (deuda_linea_SBIF==1 & deuda_linea_EFH==1 & reporut_2017!=0 ))
*/

***************************************************************************************
* Globals and additional variable definiions
***************************************************************************************
egen id=group(folio yearEFH)

/*global explic_var1 "male_nmarried married i.education edad_d edadsq"             
global explic_var2 "male_nmarried married i.education edad edad2"             
global explic_var3 " married i.education edad_d edadsq i.c6_act_indef2 i.genero"             
global explic_var4 " married i.education edad edad2 i.c6_act_indef2 i.genero i.estrato i.macrozona"             
global explic_var5 " married i.education edad edad2 i.c6_act_indef2 i.genero i.macrozona "             */
global explic_var6 " married i.education edad edad2 i.c6_act_indef2 i.genero i.refresco i.macrozona i.weekend i.yearEFH ib2.tipo_deuda "             

*------
/*global adicional   "numh i.n_encuestados n_ing n_cconhip d_transf i.macrozona refresco jefe_hog i.yearEFH"
global adicional2  "numh i.n_encuestados n_cconhip n_ingact gen_ing d_transf i.macrozona refresco i.yearEFH"
global adicional3  "numh n_cconhip n_ingact gen_ing d_transf i.macrozona "
global adicional4  "numh n_cconhip n_ing n_act gen_ing d_transf i.refresco i.yearEFH"
global adicional5 "numh n_cconhip n_ingact gen_ing d_transf i.refresco "
global adicional6 "numh n_cconhip n_ingact gen_ing d_transf i.refresco i.tipo_deudar"
global adicional7 "n_act gen_ing d_transf i.refresco ib2.tipo_deudar"
global adicional8 "n_act d_transf gen_ing i.refresco "
global adicional9 "i.refresco"
*global adicional9 "n_ingact i.refresco i.yearEFH" 
global adicional10 "d_nomax_ing i.refresco i.yearEFH"
global adicional11 "gen_ing i.refresco i.yearEFH "
global adicional12 "a1_nothighest_income i.refresco i.yearEFH "  */

* Proportional error definition
g E_error_ratio0 = 100*abs(error_ratio0) if error_ratio0>=-2 & error_ratio0<=2  //make them in %
g E_error_ratio0R = 100*abs(error_ratio0R) if error_ratio0R>=-2 & error_ratio0R<=2  //make them in %; rounding error

* Debt types
g tipo_deudar=tipo_deuda
replace tipo_deudar = 2 if (tipo_deuda == 2| tipo_deuda == 4)
lab def tipo_deudar 1 "Mortgages" 2 "Credit card and lines" 3 "Installment loans" , modify
label values tipo_deudar tipo_deudar

* TL to the logit 
replace error_EFH_notSBIF=0 if ((deuda_tarjeta_EFH==1 & deuda_tarjeta_SBIF==1) ///
& tipo_deuda==2) | ((deuda_linea_EFH==1 & deuda_linea_SBIF==1) & tipo_deuda==4)

replace error_EFH_notSBIF=1 if ((deuda_tarjeta_EFH==1 & deuda_tarjeta_SBIF==0) ///
& tipo_deuda==2) | ((deuda_linea_EFH==1 & deuda_linea_SBIF==0) & tipo_deuda==4)


* Error not EFH and yes SBIF
g error_notEFH_SBIF=.
replace error_notEFH_SBIF=0 if ((deuda_tarjeta_EFH==1 & deuda_tarjeta_SBIF==1) & tipo_deuda==2) | ///
((deuda_linea_EFH==1 & deuda_linea_SBIF==1) & tipo_deuda==4)  | ///
((deuda_hipotecario_EFH==1 & deuda_hipotecario_SBIF==1) & tipo_deuda==1) | ///
((deuda_prestamo_EFH==1 & deuda_prestamo_SBIF==1) & tipo_deuda==3) 

replace error_notEFH_SBIF=1 if ((deuda_tarjeta_EFH==0 & deuda_tarjeta_SBIF==1) & tipo_deuda==2) | ///
((deuda_linea_EFH==0 & deuda_linea_SBIF==1) & tipo_deuda==4) | ///
((deuda_hipotecario_EFH==0 & deuda_hipotecario_SBIF==1) & tipo_deuda==1) | ///
((deuda_prestamo_EFH==0 & deuda_prestamo_SBIF==1) & tipo_deuda==3) 
   
* Error  EFH and not SBIF
g error_EFH_notSBIF_v2=.
replace error_EFH_notSBIF_v2=0 if ((deuda_tarjeta_EFH==1 & deuda_tarjeta_SBIF==1) & tipo_deuda==2) | ///
((deuda_linea_EFH==1 & deuda_linea_SBIF==1) & tipo_deuda==4)  | ///
((deuda_hipotecario_EFH==1 & deuda_hipotecario_SBIF==1) & tipo_deuda==1) | ///
((deuda_prestamo_EFH==1 & deuda_prestamo_SBIF==1) & tipo_deuda==3) 

replace error_EFH_notSBIF_v2=1 if ((deuda_tarjeta_EFH==1 & deuda_tarjeta_SBIF==0) & tipo_deuda==2) | ///
((deuda_linea_EFH==1 & deuda_linea_SBIF==0) & tipo_deuda==4) | ///
((deuda_hipotecario_EFH==1 & deuda_hipotecario_SBIF==0) & tipo_deuda==1) | ///
((deuda_prestamo_EFH==1 & deuda_prestamo_SBIF==0) & tipo_deuda==3) 
   
g tarj_lin=0
replace tarj_lin=1 if  (tipo_deuda==2 | tipo_deuda==4)

g tipo_deudat=1
replace tipo_deudat=2 if  (tipo_deuda==2 | tipo_deuda==4)
replace tipo_deudat=3 if  tipo_deuda==3

** Additional variables
* Split variable conoc_fondo: i) if interviewee responds the question about pension fund
* ii) interviewee knows the amount of his pension fund

g resp_fondo=(conoc_fondo<2)
lab def resp_fondo 0 "Does not apply" 1 "Int. responds about pension fund"
lab val resp_fondo resp_fondo

g sabe_fondo=(conoc_fondo==1)
lab def sabe_fondo 0 "Int. does not know" 1 "Int. knows"
lab val sabe_fondo sabe_fondo

g weekend=(dow==6 | dow==7)
lab def weekend 0 "Int. working days" 1 "Int. weekend"
lab val weekend weekend

g dispo_dum=0
replace dispo_dum=1 if x_n5==3
lab def dispo_dum 0 "Is not good" 1 "Int. dispo is good"
lab val dispo_dum dispo_dum

***************************************************************************************
* Regressions with debt ownership status (EFH=1,SBIF=0)
***************************************************************************************
/*cd "$path\tablas"
global path "$path\tablas\2020"
cd "C:\Users\pmargaretic\Dropbox\Cruce\Paper descriptivo\Stata\tablas\2020"
*/
cd "$path/tablas/2020/wn_seg"

* 2020: All debt types together (EFH=1,SBIF=0)
***************************************************************************************
global explic_var6 " married i.education edad edad2 i.c6_act_indef2 i.genero i.refresco i.macrozona i.weekend "             
global adicional10 "a1_nothighest_income i.tipo_deuda i.refresco i.yearEFH"
global adicional10_b "i.a1_nothighest_income##ib2.tipo_deuda i.refresco i.a1_nothighest_income##ib2.yearEFH"
global adicional11 "i.a1_nothighest_income##ib2.tipo_deuda i.refresco i.yearEFH"
global adicional12 "i.d_nomax_ing##ib2.tipo_deuda i.refresco i.d_nomax_ing##ib2.yearEFH"

/*set more off
logit error_EFH_notSBIF $explic_var6 $adicional10 if reporut_2017!=0 [pw=factor_egm], vce(cluster id)
outreg2 using "Reg_EFH_notSBIF_v2.xls" , replace ctitle(CM)
*/
set more off
logit error_EFH_notSBIF_v2 $explic_var6 $adicional11 if reporut_2017!=0 [pw=factor_egm], vce(cluster id)
outreg2 using "Reg_EFH_notSBIF_v2.xls" , replace ctitle(CM_int) dec(3)

* With additional hypotheses
set more off
logit error_EFH_notSBIF $explic_var6 $adicional11 i.resp_fondo##i.sabe_fondo  i.dispo_dum  n_act  miss_ing  round_ingact n_seg_e if reporut_2017!=0 [pw=factor_egm], vce(cluster id)
outreg2 using "Reg_EFH_notSBIF_v2.xls" , append ctitle(CM_int) dec(3)

set more off
logit error_EFH_notSBIF $explic_var6 $adicional11 i.sof_fin n_act  i.dispo_dum  n_act miss_ing round_ingact n_seg_e if reporut_2017!=0 [pw=factor_egm], vce(cluster id)
outreg2 using "Reg_EFH_notSBIF_v2.xls" , append ctitle(CM_int) dec(3)

set more off
logit error_EFH_notSBIF_v2 $explic_var6 $adicional11 i.resp_fondo##i.sabe_fondo i.sof_fin n_act  i.dispo_dum  miss_ing round_ingact n_seg_e if reporut_2017!=0 [pw=factor_egm], vce(cluster id)
outreg2 using "Reg_EFH_notSBIF_v2.xls" , append ctitle(CM_int) dec(3)


/* Existing specification, with numh
global explic_var4 "numh married i.education edad edad2 i.c6_act_indef2 i.genero i.estrato i.macrozona"             
global adicional10 "d_nomax_ing i.tipo_deuda i.refresco i.yearEFH"
set more off
logit error_EFH_notSBIF $explic_var4 $adicional10 if reporut_2017!=0 [pw=factor_egm], vce(cluster id)

* interaction with d_nomax_ing
global adicional11 "i.d_nomax_ing##ib2.tipo_deuda i.refresco i.d_nomax_ing##ib2.yearEFH"
set more off
logit error_EFH_notSBIF $explic_var4 $adicional11 if reporut_2017!=0 [pw=factor_egm], vce(cluster id)

* A similar specification than in the intensive margin case
global explic_var6 " married i.education edad edad2 i.c6_act_indef2 i.genero i.refresco i.macrozona "             

set more off
logit error_EFH_notSBIF $explic_var6 $adicional10 i.resp_fondo i.resp_fondo#i.sabe_fondo ///
i.sof_fin n_act  i.dispo_dum  miss_ing i.weekend if reporut_2017!=0 [pw=factor_egm], vce(cluster id)
*/


/* Replicating the same specification than for the proport errors

cd "C:\Users\pmargaretic\Dropbox\Cruce\Paper descriptivo\Stata\tablas\2020"
global explic_var6 " married i.education edad edad2 i.c6_act_indef2 i.genero i.refresco i.macrozona i.weekend i.yearEFH ib2.tipo_deuda "             

set more off
*reg error_EFH_notSBIF $explic_var6 i.resp_fondo i.resp_fondo#i.sabe_fondo  i.dispo_dum  miss_ing round_ingact if reporut_2017!=0 [pw=factor_egm], vce(cluster id) 
reg error_EFH_notSBIF $explic_var6 i.resp_fondo i.resp_fondo#i.sabe_fondo  i.dispo_dum  miss_ing  if reporut_2017!=0 [pw=factor_egm], vce(cluster id) 
outreg2 using "Reg_EFH_notSBIF.xls" , replace ctitle(fondo)

reg error_EFH_notSBIF $explic_var6 i.sof_fin n_act  i.dispo_dum  miss_ing round_ingact if reporut_2017!=0 [pw=factor_egm], vce(cluster id) 
outreg2 using "Reg_EFH_notSBIF.xls" , append ctitle(sof)

*set more off
reg error_EFH_notSBIF $explic_var6 i.resp_fondo i.resp_fondo#i.sabe_fondo i.sof_fin n_act  i.dispo_dum  miss_ing  if reporut_2017!=0 [pw=factor_egm], vce(cluster id) 
outreg2 using "Reg_EFH_notSBIF.xls" , append ctitle(All)

* With use of docs
set more off
reg error_EFH_notSBIF $explic_var6 i.resp_fondo i.resp_fondo#i.sabe_fondo  i.uso_docs  miss_ing  if reporut_2017!=0 [pw=factor_egm], vce(cluster id) 
outreg2 using "Reg_EFH_notSBIF.xls" , append  ctitle(use_fondo)

reg error_EFH_notSBIF $explic_var6 i.sof_fin n_act  i.uso_docs  miss_ing round_ingact if reporut_2017!=0 [pw=factor_egm], vce(cluster id) 
outreg2 using "Reg_EFH_notSBIF.xls" , append ctitle(use_sof)

*set more off
reg error_EFH_notSBIF $explic_var6 i.resp_fondo i.resp_fondo#i.sabe_fondo i.sof_fin n_act  i.uso_docs  miss_ing  if reporut_2017!=0 [pw=factor_egm], vce(cluster id) 
outreg2 using "Reg_EFH_notSBIF.xls" , append ctitle(use_All)

* With average time per question

set more off
*reg error_EFH_notSBIF $explic_var6 i.resp_fondo i.resp_fondo#i.sabe_fondo  i.dispo_dum  miss_ing round_ingact if reporut_2017!=0 [pw=factor_egm], vce(cluster id) 
reg error_EFH_notSBIF $explic_var6 i.resp_fondo i.resp_fondo#i.sabe_fondo  i.dispo_dum  miss_ing  round_ingact n_seg_e if reporut_2017!=0 [pw=factor_egm], vce(cluster id) 
outreg2 using "Reg_EFH_notSBIF.xls" , append ctitle(fondo)

reg error_EFH_notSBIF $explic_var6 i.sof_fin n_act  i.dispo_dum  miss_ing round_ingact n_seg_e if reporut_2017!=0 [pw=factor_egm], vce(cluster id) 
outreg2 using "Reg_EFH_notSBIF.xls" , append ctitle(sof)

*set more off
reg error_EFH_notSBIF $explic_var6 i.resp_fondo i.resp_fondo#i.sabe_fondo i.sof_fin n_act  i.dispo_dum  miss_ing  round_ingact n_seg_e if reporut_2017!=0 [pw=factor_egm], vce(cluster id) 
outreg2 using "Reg_EFH_notSBIF.xls" , append ctitle(All)
*/

***************************************************************************************
* Regressions with debt ownership status (EFH=0,SBIF=1)
***************************************************************************************
g n_cconhip_4=0
replace n_cconhip_4=1 if n_cconhip>4

set more off
logit error_notEFH_SBIF i.tarj_lin n_cconhip if reporut_2017!=0 [pw=factor_egm], vce(cluster id)
logit error_notEFH_SBIF  c.n_cconhip##ib2.tipo_deuda if reporut_2017!=0 [pw=factor_egm], vce(cluster id)

logit error_notEFH_SBIF  i.n_cconhip_4##ib2.tipo_deuda if reporut_2017!=0 [pw=factor_egm], vce(cluster id)

* Se agrega monto en la SBIF
logit error_notEFH_SBIF  i.n_cconhip_4##ib2.tipo_deuda ln_SBIF if reporut_2017!=0 [pw=factor_egm], vce(cluster id)

logit error_notEFH_SBIF  i.n_cconhip_4##ib2.tipo_deuda ln_SBIF i.dispo_dum  if reporut_2017!=0 [pw=factor_egm], vce(cluster id)


*version PM 
global explic_var6 " married i.education edad edad2 i.c6_act_indef2 i.genero i.refresco i.macrozona i.weekend i.yearEFH ib2.tipo_deuda"  
           
set more off
logit error_notEFH_SBIF $explic_var6 ln_SBIF i.n_cconhip_4 if reporut_2017!=0 [pw=factor_egm], vce(cluster id)
outreg2 using "Reg_notEFH_SBIF.xls" , replace ctitle(whip)

* With additional hypotheses
set more off
logit error_notEFH_SBIF $explic_var6 ln_SBIF i.n_cconhip_4 i.resp_fondo##i.sabe_fondo  i.dispo_dum  n_act  miss_ing  round_ingact n_seg_e if reporut_2017!=0 [pw=factor_egm], vce(cluster id)
outreg2 using "Reg_notEFH_SBIF.xls" , append ctitle(fondo)

set more off
logit error_notEFH_SBIF $explic_var6 ln_SBIF i.n_cconhip_4 i.sof_fin n_act  i.dispo_dum  n_act miss_ing round_ingact n_seg_e if reporut_2017!=0 [pw=factor_egm], vce(cluster id)
outreg2 using "Reg_notEFH_SBIF.xls" , append ctitle(sof_fin)

set more off
logit error_notEFH_SBIF $explic_var6 ln_SBIF i.n_cconhip_4 i.resp_fondo##i.sabe_fondo i.sof_fin n_act  i.dispo_dum  miss_ing round_ingact n_seg_e if reporut_2017!=0 [pw=factor_egm], vce(cluster id)
outreg2 using "Reg_notEFH_SBIF.xls" , append ctitle(All)


***************************************************************************************
* Comparison of regressions for the two debt ownership error (EFH=0,SBIF=1) & (EFH=1,SBIF=0)
***************************************************************************************
global explic_var6 " married i.education edad edad2 i.c6_act_indef2 i.genero i.refresco i.macrozona i.weekend "             
*global adicional11 "i.a1_nothighest_income##ib3.tipo_deuda i.yearEFH"
global adicional11 "i.a1_nothighest_income##ib3.tipo_deudat i.yearEFH"

* (EFH=1,SBIF=0)
* we have a problem in the dependent variable error_EFH_notSBIF since in dep_var=0 there are
* some obs with EFH=1 and SBIF=.  (128 obs), but these observations should be missing or 1, but
* not zero.

set more off
logit error_EFH_notSBIF $explic_var6 $adicional11 i.dispo_dum n_act  miss_ing  round_ingact  if reporut_2017!=0 [pw=factor_egm], vce(cluster id)
outreg2 using "Reg_debt_own_err.xls" , replace ctitle(EFH_notSBIF) dec(3) e(r2_p)

* With additional hypotheses
set more off
logit error_EFH_notSBIF $explic_var6 $adicional11 i.resp_fondo##i.sabe_fondo  i.dispo_dum    miss_ing  round_ingact  if reporut_2017!=0 [pw=factor_egm], vce(cluster id)
outreg2 using "Reg_debt_own_err.xls" , append ctitle(EFH_notSBIF) dec(3) e(r2_p)

set more off
logit error_EFH_notSBIF $explic_var6 $adicional11 i.sof_fin  i.dispo_dum   miss_ing round_ingact  if reporut_2017!=0 [pw=factor_egm], vce(cluster id)
outreg2 using "Reg_debt_own_err.xls" , append ctitle(EFH_notSBIF) dec(3) e(r2_p)

set more off
logit error_EFH_notSBIF_v2 $explic_var6 $adicional11 i.resp_fondo##i.sabe_fondo i.sof_fin n_act  i.dispo_dum  miss_ing round_ingact  if reporut_2017!=0 [pw=factor_egm], vce(cluster id)
outreg2 using "Reg_debt_own_err.xls" , append ctitle(EFH_notSBIF) dec(3) e(r2_p)


* (EFH=0,SBIF=1)
global explic_var6 " married i.education edad edad2 i.c6_act_indef2 i.genero i.refresco i.macrozona i.weekend i.yearEFH ib3.tipo_deudat"             
set more off
logit error_notEFH_SBIF $explic_var6 ln_SBIF n_act  i.dispo_dum miss_ing  round_ingact if reporut_2017!=0 [pw=factor_egm], vce(cluster id)
outreg2 using "Reg_debt_own_err.xls" , append ctitle(notEFH_SBIF) dec(3) e(r2_p)

* With additional hypotheses
set more off
logit error_notEFH_SBIF $explic_var6 ln_SBIF  i.resp_fondo##i.sabe_fondo  i.dispo_dum    miss_ing  round_ingact  if reporut_2017!=0 [pw=factor_egm], vce(cluster id)
outreg2 using "Reg_debt_own_err.xls" , append ctitle(notEFH_SBIF) dec(3) e(r2_p)

set more off
logit error_notEFH_SBIF $explic_var6 ln_SBIF  i.sof_fin  i.dispo_dum   miss_ing round_ingact  if reporut_2017!=0 [pw=factor_egm], vce(cluster id)
outreg2 using "Reg_debt_own_err.xls" , append ctitle(notEFH_SBIF) dec(3) e(r2_p)

set more off
logit error_notEFH_SBIF $explic_var6 ln_SBIF  i.resp_fondo##i.sabe_fondo i.sof_fin n_act  i.dispo_dum  miss_ing round_ingact  if reporut_2017!=0 [pw=factor_egm], vce(cluster id)
outreg2 using "Reg_debt_own_err.xls" , append ctitle(notEFH_SBIF) dec(3) e(r2_p)



***************************************************************************************
* Regressions with proportional errors
***************************************************************************************
* To test the hypothesis on willingness

foreach v in x_n5 disp_efhnext lug_entrev prob_resp dif_acep int_knowledge int_disposition {
tab yearEFH `v'
}


* Conditional model for all observations together, including error=2,-1 
***************************************************************************************
cd "C:\Users\pmargaretic\Dropbox\Cruce\Paper descriptivo\Stata\tablas\2020"
global explic_var6 " married i.education edad edad2 i.c6_act_indef2 i.genero i.refresco i.macrozona i.weekend i.yearEFH ib3.tipo_deudat"             

set more off
*reg E_error_ratio0 $explic_var6 i.resp_fondo i.resp_fondo#i.sabe_fondo  i.dispo_dum  miss_ing round_ingact if reporut_2017!=0 [pw=factor_egm], vce(cluster id) 
reg E_error_ratio0 $explic_var6 i.resp_fondo##i.sabe_fondo  i.dispo_dum  n_act  miss_ing  round_ingact n_seg_e if reporut_2017!=0 [pw=factor_egm], vce(cluster id) 
outreg2 using "Reg_error_prop.xls" , replace ctitle(fondo)

reg E_error_ratio0 $explic_var6 i.sof_fin n_act  i.dispo_dum  n_act miss_ing round_ingact n_seg_e if reporut_2017!=0 [pw=factor_egm], vce(cluster id) 
outreg2 using "Reg_error_prop.xls" , append ctitle(sof)

*set more off
reg E_error_ratio0 $explic_var6  i.resp_fondo##i.sabe_fondo i.sof_fin n_act  i.dispo_dum  miss_ing round_ingact n_seg_e if reporut_2017!=0 [pw=factor_egm], vce(cluster id) 
outreg2 using "Reg_error_prop.xls" , append ctitle(All)

/* With use of docs
set more off
reg E_error_ratio0 $explic_var6 i.resp_fondo##i.sabe_fondo  i.uso_docs n_act   miss_ing round_ingact n_seg_e if reporut_2017!=0 [pw=factor_egm], vce(cluster id) 
outreg2 using "Reg_error_prop.xls" , append  ctitle(use_fondo)

reg E_error_ratio0 $explic_var6 i.sof_fin n_act  i.uso_docs  n_act  miss_ing round_ingact n_seg_e if reporut_2017!=0 [pw=factor_egm], vce(cluster id) 
outreg2 using "Reg_error_prop.xls" , append ctitle(use_sof)

*set more off
reg E_error_ratio0 $explic_var6  i.resp_fondo##i.sabe_fondo i.sof_fin n_act  i.uso_docs  miss_ing round_ingact n_seg_e if reporut_2017!=0 [pw=factor_egm], vce(cluster id) 
outreg2 using "Reg_error_prop.xls" , append ctitle(use_All)

* Without n_act 
set more off
*reg E_error_ratio0 $explic_var6 i.resp_fondo i.resp_fondo#i.sabe_fondo  i.dispo_dum  miss_ing round_ingact if reporut_2017!=0 [pw=factor_egm], vce(cluster id) 
reg E_error_ratio0 $explic_var6 i.resp_fondo##i.sabe_fondo  i.dispo_dum  miss_ing  round_ingact n_seg_e if reporut_2017!=0 [pw=factor_egm], vce(cluster id) 
outreg2 using "Reg_error_prop.xls" , append ctitle(fondo)

reg E_error_ratio0 $explic_var6 i.sof_fin  i.dispo_dum  miss_ing round_ingact n_seg_e if reporut_2017!=0 [pw=factor_egm], vce(cluster id) 
outreg2 using "Reg_error_prop.xls" , append ctitle(sof)

*set more off
reg E_error_ratio0 $explic_var6  i.resp_fondo##i.sabe_fondo i.sof_fin  i.dispo_dum  miss_ing round_ingact n_seg_e if reporut_2017!=0 [pw=factor_egm], vce(cluster id) 
outreg2 using "Reg_error_prop.xls" , append ctitle(All)

* Other proxies for rounding
set more off
reg E_error_ratio0 $explic_var6 i.resp_fondo i.resp_fondo#i.sabe_fondo i.sof_fin n_act  i.dispo_dum  miss_ing round_ing if reporut_2017!=0 [pw=factor_egm], vce(cluster id) 
outreg2 using "Reg_error_prop.xls" , append ctitle(All_round_ing)

reg E_error_ratio0 $explic_var6 i.resp_fondo i.resp_fondo#i.sabe_fondo i.sof_fin n_act  i.dispo_dum  miss_ing round_act if reporut_2017!=0 [pw=factor_egm], vce(cluster id) 
outreg2 using "Reg_error_prop.xls" , append ctitle(All_round_act)

*/


* Comparison results including error=2,-2 and excluding them
***************************************************************************************
cd "C:\Users\pmargaretic\Dropbox\Cruce\Paper descriptivo\Stata\tablas\2020"
g ratio2= (error_ratio0==2)       
g ratio_2= (error_ratio0==-2)       

global explic_var6 " married i.education edad edad2 i.c6_act_indef2 i.genero i.refresco i.macrozona i.weekend i.yearEFH ib3.tipo_deudat "    

* Including them
set more off
reg E_error_ratio0 $explic_var6 i.resp_fondo##i.sabe_fondo  i.dispo_dum  n_act  miss_ing  round_ingact n_seg_e if reporut_2017!=0 [pw=factor_egm], vce(cluster id) 
outreg2 using "Reg_error_prop_wext.xls" , replace ctitle(fondo)

reg E_error_ratio0 $explic_var6 i.sof_fin n_act  i.dispo_dum  n_act miss_ing round_ingact n_seg_e if reporut_2017!=0 [pw=factor_egm], vce(cluster id) 
outreg2 using "Reg_error_prop_wext.xls" , append ctitle(sof)

*set more off
reg E_error_ratio0 $explic_var6  i.resp_fondo##i.sabe_fondo i.sof_fin n_act  i.dispo_dum  miss_ing round_ingact n_seg_e if reporut_2017!=0 [pw=factor_egm], vce(cluster id) 
outreg2 using "Reg_error_prop_wext.xls" , append ctitle(All)

* Excluding them
set more off
reg E_error_ratio0 $explic_var6 i.dispo_dum  n_act  miss_ing   i.dispo_dum round_ingact  if reporut_2017!=0 & (error_ratio0>-2 & error_ratio0<2) [pw=factor_egm], vce(cluster id) 
outreg2 using "Reg_error_prop_wext.xls" , replace ctitle(fondo)  dec(3)


set more off
reg E_error_ratio0 $explic_var6 i.resp_fondo##i.sabe_fondo  i.dispo_dum    miss_ing  round_ingact  if reporut_2017!=0 & (error_ratio0>-2 & error_ratio0<2) [pw=factor_egm], vce(cluster id) 
outreg2 using "Reg_error_prop_wext.xls" , append ctitle(fondo)  dec(3)

reg E_error_ratio0 $explic_var6 i.sof_fin   i.dispo_dum  miss_ing round_ingact  if reporut_2017!=0 & (error_ratio0>-2 & error_ratio0<2) [pw=factor_egm], vce(cluster id) 
outreg2 using "Reg_error_prop_wext.xls" , append ctitle(sof)  dec(3)

*set more off
reg E_error_ratio0 $explic_var6  i.resp_fondo##i.sabe_fondo i.sof_fin n_act  i.dispo_dum n_act miss_ing round_ingact  if reporut_2017!=0 & (error_ratio0>-2 & error_ratio0<2) [pw=factor_egm], vce(cluster id) 
outreg2 using "Reg_error_prop_wext.xls" , append ctitle(All)  dec(3)


/* Including them but controlling for the extremes
set more off
reg E_error_ratio0 $explic_var6 i.resp_fondo##i.sabe_fondo  i.dispo_dum  n_act  miss_ing  round_ingact n_seg_e ratio2 ratio_2 if reporut_2017!=0 [pw=factor_egm], vce(cluster id) 
outreg2 using "Reg_error_prop_wext.xls" , append ctitle(fondo)

reg E_error_ratio0 $explic_var6 i.sof_fin n_act  i.dispo_dum  n_act miss_ing round_ingact n_seg_e ratio2 ratio_2 if reporut_2017!=0 [pw=factor_egm], vce(cluster id) 
outreg2 using "Reg_error_prop_wext.xls" , append ctitle(sof)

*set more off
reg E_error_ratio0 $explic_var6  i.resp_fondo##i.sabe_fondo i.sof_fin n_act  i.dispo_dum  miss_ing round_ingact n_seg_e ratio2 ratio_2 if reporut_2017!=0 [pw=factor_egm], vce(cluster id) 
outreg2 using "Reg_error_prop_wext.xls" , append ctitle(All)
*/

* Excluding them with rounded dep variable
set more off

reg E_error_ratio0R $explic_var6 i.dispo_dum  n_act  miss_ing  round_ingact  if reporut_2017!=0 & (error_ratio0>-2 & error_ratio0<2) [pw=factor_egm], vce(cluster id) 
outreg2 using "Reg_error_prop_wext.xls" , append ctitle(round_fondo)  dec(3)

reg E_error_ratio0R $explic_var6 i.resp_fondo##i.sabe_fondo  i.dispo_dum    miss_ing  round_ingact  if reporut_2017!=0 & (error_ratio0>-2 & error_ratio0<2) [pw=factor_egm], vce(cluster id) 
outreg2 using "Reg_error_prop_wext.xls" , append ctitle(round_fondo)  dec(3)

reg E_error_ratio0R $explic_var6 i.sof_fin   i.dispo_dum   miss_ing round_ingact  if reporut_2017!=0 & (error_ratio0>-2 & error_ratio0<2) [pw=factor_egm], vce(cluster id) 
outreg2 using "Reg_error_prop_wext.xls" , append ctitle(round_sof)  dec(3)

*set more off
reg E_error_ratio0R $explic_var6  i.resp_fondo##i.sabe_fondo i.sof_fin n_act  i.dispo_dum  miss_ing round_ingact  if reporut_2017!=0 & (error_ratio0>-2 & error_ratio0<2) [pw=factor_egm], vce(cluster id) 
outreg2 using "Reg_error_prop_wext.xls" , append ctitle(round_All)  dec(3)


* Version FM: Comparing regression result with rounding and not rounding dependent variable
global explic_var6 " married i.education edad edad2 i.c6_act_indef2 i.genero i.refresco i.macrozona i.weekend i.yearEFH ib2.tipo_deuda "             

reg E_error_ratio0 $explic_var6 i.resp_fondo##i.sabe_fondo  i.uso_docs n_act   miss_ing round_ingact n_seg_e ///
if reporut_2017!=0 & (error_ratio0>-2 & error_ratio0<2) [pw=factor_egm], vce(cluster id) 
outreg2 using "rounding_no_rounding_reg.xls" , replace  ctitle(use_fondo)

reg E_error_ratio0 $explic_var6  i.resp_fondo##i.sabe_fondo i.sof_fin n_act  i.uso_docs  miss_ing round_ingact n_seg_e ///
if reporut_2017!=0 & (error_ratio0>-2 & error_ratio0<2) [pw=factor_egm], vce(cluster id) 
outreg2 using "rounding_no_rounding_reg.xls" , append ctitle(use_All)


reg E_error_ratio0R $explic_var6 i.resp_fondo##i.sabe_fondo  i.uso_docs n_act   miss_ing round_ingact n_seg_e if reporut_2017!=0 [pw=factor_egm], vce(cluster id) 
outreg2 using "rounding_no_rounding_reg.xls" , append  ctitle(use_fondo, rounding)

reg E_error_ratio0R $explic_var6  i.resp_fondo##i.sabe_fondo i.sof_fin n_act  i.uso_docs  miss_ing round_ingact n_seg_e ///
if reporut_2017!=0 & (error_ratio0>-2 & error_ratio0<2) [pw=factor_egm], vce(cluster id) 
outreg2 using "rounding_no_rounding_reg.xls" , append ctitle(use_All, rounding)


