
version 14
clear all
cls
set more off
capture log close

global path "C:\Users\pedro\Dropbox\Cruce\Paper descriptivo\Stata"


* Reconstrucción tablas documento descriptivo

use "$path\dta\analysis11_14_17_vfix.dta"

* Archivo excel para guardar resultados
putexcel set "$path\tablas\PR\tablas.xlsx", replace sheet(tabla_2,replace)


* Tabla 2

* Cálculo CM

putexcel B2=("Tabla 2, con datos de CM")
putexcel B4=("Debt ownership (EFH, SBIF)")
putexcel B5=("Mortgage")
putexcel B6=("Installment loans")
putexcel B7=("Credit cards and credit lines")

putexcel C4=("(0,0)")
putexcel D4=("(0,1)") 
putexcel E4=("(1,0)") 
putexcel F4=("(1,1)")  

global lista "hipotecario prestamo TL"
forv k=1/3 {

	local x=word("$lista",`k')
	di "`x'"
	local p=`k'+4
	
	tab deuda_`x'_EFH deuda_`x'_SBIF [fw=factor_egm], cell nofreq matcell(a)
	putexcel C`p'=matrix(100*a[1,1..2]/r(N))
	putexcel E`p'=matrix(100*a[2,1..2]/r(N))

		foreach x in C D E F {
			putexcel `x'`p'=nformat("number_d2")
		}
}

putexcel I2=("Analisis elemento (1,0)")

tab yearEFH if deuda_hipotecario_EFH==1 & deuda_hipotecario_SBIF==1 ///
[fw=factor_egm], matcell(a)

putexcel I4=("year EFH")
putexcel I5=("2011")
putexcel I6=("2014")
putexcel I7=("2017")

putexcel J4=("percentage")
putexcel J5=mat(100*a/r(N))
putexcel (J5:J7)=nformat("number_d2")

* Análisis elemento (1,0)

* Cálculo con corrección de ruts

putexcel B10=("Tabla 2, corrección ruts")
putexcel B12=("Debt ownership (EFH, SBIF)")
putexcel B13=("Mortgage")
putexcel B14=("Installment loans")
putexcel B15=("Credit cards and credit lines")

putexcel C12=("(0,0)")
putexcel D12=("(0,1)") 
putexcel E12=("(1,0)") 
putexcel F12=("(1,1)")  

global lista "hipotecario prestamo TL"
forv k=1/3 {

	local x=word("$lista",`k')
	di "`x'"
	local p=`k'+12
	
	tab deuda_`x'_EFH deuda_`x'_SBIF [fw=factor_egm] if reporut!=0, cell ///
	nofreq matcell(a)
	putexcel C`p'=matrix(100*a[1,1..2]/r(N))
	putexcel E`p'=matrix(100*a[2,1..2]/r(N))

		foreach x in C D E F {
			putexcel `x'`p'=nformat("number_d2")
		}
}

putexcel I10=("Analisis elemento (1,0)")

tab yearEFH if deuda_hipotecario_EFH==1 & deuda_hipotecario_SBIF==1 ///
& reporut!=0 [fw=factor_egm], matcell(a)

putexcel I12=("year EFH")
putexcel I13=("2011")
putexcel I14=("2014")
putexcel I15=("2017")

putexcel J12=("percentage")
putexcel J13=mat(100*a/r(N))
putexcel (J13:J15)=nformat("number_d2")

* Tabla 3

foreach x in $lista tarjeta linea {
	g ln_`x'_EFH=ln(deuda_m_`x'_EFH)
	g ln_`x'_SBIF=ln(deuda_m_`x'_SBIF)
}

putexcel set "$path\tablas\PR\tablas.xlsx", modify sheet(tabla_3,replace)

putexcel B2=("Tabla 3, con datos de CM")
putexcel B3=("Debt Category")
putexcel C3=("EFH Dataset")
putexcel E3=("SBIF dataset")

putexcel B4=("Debt ownership (EFH, SBIF)")
putexcel C4=("(1,0)")
putexcel D4=("(1,1)") 
putexcel E4=("(0,1)") 
putexcel F4=("(1,1)")  

putexcel D5=("Mean")
putexcel B6=("Mortgage")
putexcel B7=("Installment loans")
putexcel B8=("Credit cards and credit lines")

putexcel D9=("Median")
putexcel B10=("Mortgage")
putexcel B11=("Installment loans")
putexcel B12=("Credit cards and credit lines")

* Con datos de Carlos
forv k=1/3 {
	
	local x=word("$lista",`k')
	di "`x'"
	local p=`k'+5
	local r=`k'+9
	
	tabstat ln_`x'_EFH [fw=factor_egm] if deuda_`x'_EFH==1, ///
	by(deuda_`x'_SBIF) stat(mean med) save not
	mat a1=r(Stat1)
	mat a2=r(Stat2)
	putexcel C`p'=mat(a1[1,1])
	putexcel C`r'=mat(a1[2,1])
	putexcel D`p'=mat(a2[1,1])
	putexcel D`r'=mat(a2[2,1])

	tabstat ln_`x'_SBIF [fw=factor_egm] if deuda_`x'_SBIF==1, ///
	by(deuda_`x'_EFH) stat(mean med) save not
	mat a1=r(Stat1)
	mat a2=r(Stat2)
	putexcel E`p'=mat(a1[1,1])
	putexcel E`r'=mat(a1[2,1])
	putexcel F`p'=mat(a2[1,1])
	putexcel F`r'=mat(a2[2,1])
	
}


* Cálculo con corrección de ruts

putexcel B14=("Tabla 3, con corrección de ruts")
putexcel B15=("Debt Category")
putexcel C15=("EFH Dataset")
putexcel E15=("SBIF dataset")

putexcel B16=("Debt ownership (EFH, SBIF)")
putexcel C16=("(1,0)")
putexcel D16=("(1,1)") 
putexcel E16=("(0,1)") 
putexcel F16=("(1,1)")  

putexcel D17=("Mean")
putexcel B18=("Mortgage")
putexcel B19=("Installment loans")
putexcel B20=("Credit cards and credit lines")

putexcel D21=("Median")
putexcel B22=("Mortgage")
putexcel B23=("Installment loans")
putexcel B24=("Credit cards and credit lines")

forv k=1/3 {
	
	local x=word("$lista",`k')
	di "`x'"
	local p=`k'+17
	local r=`k'+21
	
	tabstat ln_`x'_EFH [fw=factor_egm] if deuda_`x'_EFH==1 & reporut!=0, ///
	by(deuda_`x'_SBIF) stat(mean med) save not
	mat a1=r(Stat1)
	mat a2=r(Stat2)
	putexcel C`p'=mat(a1[1,1])
	putexcel C`r'=mat(a1[2,1])
	putexcel D`p'=mat(a2[1,1])
	putexcel D`r'=mat(a2[2,1])

	tabstat ln_`x'_SBIF [fw=factor_egm] if deuda_`x'_SBIF==1 & reporut!=0, ///
	by(deuda_`x'_EFH) stat(mean med) save not
	mat a1=r(Stat1)
	mat a2=r(Stat2)
	putexcel E`p'=mat(a1[1,1])
	putexcel E`r'=mat(a1[2,1])
	putexcel F`p'=mat(a2[1,1])
	putexcel F`r'=mat(a2[2,1])
	
}

* Test significancia

egen id=group(folio yearEFH)

* Datos EFH
putexcel H15=("Mean comparison one sided test")
putexcel H16=("Test EFH")
putexcel I16=("Test SBIF")
putexcel H17=("p-value")

forv k=1/3 {
	
	local x=word("$lista",`k')
	di "`x'"
	
	local p=`k'+17
	
	ttest ln_`x'_EFH if deuda_`x'_EFH==1 & reporut!=0,by(deuda_`x'_SBIF) unequal
	putexcel H`p'=(r(p_l))
	ttest ln_`x'_SBIF if deuda_`x'_SBIF==1 & reporut!=0,by(deuda_`x'_EFH) unequal
	putexcel I`p'=(r(p_l))
}

* Tabla 5

putexcel set "$path\tablas\PR\tablas.xlsx", modify sheet(tabla_5,replace)

* Cálculo CM

putexcel B2=("Tabla 5, con datos de CM")
putexcel B4=("Default (EFH, SBIF)")

putexcel C5=("All loans")
putexcel B6=("Mortgage")
putexcel B7=("Installment loans")

putexcel C4=("(0,0)")
putexcel D4=("(0,1)") 
putexcel E4=("(1,0)") 
putexcel F4=("(1,1)")  

putexcel C8=("All loans")
putexcel B9=("Mortgage")
putexcel B10=("Installment loans")

global lista1 "hipotecario prestamo"

* Ajuste de nombres
rename df_hip_* df_hipotecario_*
rename df2_hip_* df2_hipotecario_*

forv k=1/2 {

	local x=word("$lista1",`k')
	di "`x'"
	local p=`k'+5
	local q=`k'+8
	
	tab df_`x'_EFH df_`x'_SBIF [fw=factor_egm], cell nofreq matcell(a)
	putexcel C`p'=matrix(100*a[1,1..2]/r(N))
	putexcel E`p'=matrix(100*a[2,1..2]/r(N))
	foreach y in C D E F {
		putexcel `y'`p'=nformat("number_d2")
	}

	tab df2_`x'_EFH df2_`x'_SBIF [fw=factor_egm] if deuda_`x'_EFH==1 & ///
	deuda_`x'_SBIF==1, cell nofreq matcell(a)
	putexcel C`q'=matrix(100*a[1,1..2]/r(N))
	putexcel E`q'=matrix(100*a[2,1..2]/r(N))
	foreach y in C D E F {
		putexcel `y'`q'=nformat("number_d2")
	}
}

* Cálculo con corrección de ruts

putexcel B12=("Tabla 5, con corrección ruts")
putexcel B14=("Default (EFH, SBIF)")


putexcel C15=("All loans")
putexcel B16=("Mortgage")
putexcel B17=("Installment loans")

putexcel C14=("(0,0)")
putexcel D14=("(0,1)") 
putexcel E14=("(1,0)") 
putexcel F14=("(1,1)")  

putexcel C18=("All loans")
putexcel B19=("Mortgage")
putexcel B20=("Installment loans")


forv k=1/2 {

	local x=word("$lista1",`k')
	di "`x'"
	local p=`k'+15
	local q=`k'+18
	
	tab df_`x'_EFH df_`x'_SBIF [fw=factor_egm] if reporut!=0, cell nofreq matcell(a)
	putexcel C`p'=matrix(100*a[1,1..2]/r(N))
	putexcel E`p'=matrix(100*a[2,1..2]/r(N))
	foreach y in C D E F {
		putexcel `y'`p'=nformat("number_d2")
	}

	tab df2_`x'_EFH df2_`x'_SBIF [fw=factor_egm] if reporut!=0 & deuda_`x'_EFH==1 & ///
	deuda_`x'_SBIF==1, cell nofreq matcell(a)
	putexcel C`q'=matrix(100*a[1,1..2]/r(N))
	putexcel E`q'=matrix(100*a[2,1..2]/r(N))
	foreach y in C D E F {
		putexcel `y'`q'=nformat("number_d2")
	}
}





* Tabla 6 y 7 con outliers

global indic "0 0R"

* Outliers TL
foreach x in TL tarjeta linea {
	sum error_ratio0_`x' [fw=factor_egm] if ln_`x'_EFH!=. & ln_`x'_SBIF!=., d
	g O_`x'=(error_ratio0_`x'<r(p5) | error_ratio0_`x'>r(p95))
}

foreach x in $lista tarjeta linea {
	lab def O_`x' 0 "normal" 1 "outlier"
	lab val O_`x' O_`x'
} 

* Ajuste nombres
rename error_ratio0_madurez error_ratio0_mad_prestamo
rename error_ratio0_mres error_ratio0_mres_prestamo

rename error_ratio0R_C_* error_ratio0R_cuota_*
rename error_ratio0R_M_* error_ratio0R_mad_*
rename error_ratio0R_Mres_* error_ratio0R_mres_*

rename D_*_SBIFround deuda_m0R_*_SBIF
rename deuda_m_*_SBIF deuda_m0_*_SBIF

rename cuota_*_SBIF cuota0_*_SBIF
rename C_*_SBIFround cuota0R_*_SBIF

rename madurez_*_SBIF madurez0_*_SBIF
rename M_*_SBIFround madurez0R_*_SBIF

*rename madurez_*_res_SBIF madurez0_*_res_SBIF
rename Mres_*_res_SBIFround madurez0R_*_res_SBIF


forv w=1/2 {

	local aux=`w'+5
	
	putexcel set "$path\tablas\PR\tablas.xlsx", modify sheet(tabla_`aux',replace)

	putexcel B2=("Tabla `aux', con outliers")
	putexcel B3=("Variable")
	putexcel C3=("Debt Category")
	putexcel D3=("P10")
	putexcel E3=("P25")
	putexcel F3=("P50")
	putexcel G3=("P75")
	putexcel H3=("P90")
    putexcel I3=("Mean")

	putexcel J3=("\rho")

	putexcel B4=("Loans amounts")
	putexcel C4=("Mortgages")
	putexcel C5=("Installment loans")
	putexcel C6=("Credit cards and credit lines")

	putexcel B7=("Debt service") 
	putexcel C7=("Mortgages") 
	putexcel C8=("Installment loans")  

	putexcel B9=("Total maturity") 
	putexcel C9=("Mortgages") 
	putexcel C10=("Installment loans")

	putexcel B11=("Residual maturity") 
	putexcel C11=("Mortgages") 
	putexcel C12=("Installment loans")


	local v=word("$indic",`w')

	forv k=1/3 {
	
		local x=word("$lista",`k')
		di "`x'"
	
		local p=`k'+3
		local q=`k'+5
		local r=`k'+7
		local s=`k'+9
	
		_pctile error_ratio`v'_`x'  if reporut!=0 & /// 
		ln_`x'_EFH!=. & ln_`x'_SBIF!=.  [fw=factor_egm], p(10 25 50 75 90)
		foreach y in D E F G H {
			local z=strpos("DEFGH","`y'")
			putexcel `y'`p'=(100*r(r`z'))
			putexcel `y'`p'=nformat("number_d2")
}
		sum error_ratio`v'_`x'  if reporut!=0 & /// 
		ln_`x'_EFH!=. & ln_`x'_SBIF!=.  [fw=factor_egm]
			putexcel I`p'=(100*r(mean))
			putexcel I`p'=nformat("number_d2")

		corr deuda_m_`x'_EFH deuda_m`v'_`x'_SBIF if deuda_m`v'_`x'_SBIF>0 & /// 
		deuda_m_`x'_EFH>0 & deuda_m`v'_`x'_SBIF<. & /// 
		deuda_m_`x'_EFH<. [fw=factor_egm]
		putexcel J`p'=(100*r(rho))
		
		pwcorr deuda_m_`x'_EFH deuda_m`v'_`x'_SBIF if deuda_m`v'_`x'_SBIF>0 & /// 
		deuda_m_`x'_EFH>0 & deuda_m`v'_`x'_SBIF<. & /// 
		deuda_m_`x'_EFH<., sig
		putexcel K`p'=("***")
	}
	forv k=1/2 {
		
		local x=word("$lista1",`k')
		di "`x'"
		
		local q=`k'+6
		local r=`k'+8
		local s=`k'+10
			 
		_pctile error_ratio`v'_cuota_`x'  if reporut!=0 & /// 
		error_ratio`v'_cuota_`x'>-2 & error_ratio`v'_cuota_`x'<2  [fw=factor_egm], p(10 25 50 75 90)
		foreach y in D E F G H {
			local z=strpos("DEFGH","`y'")
			putexcel `y'`q'=(100*r(r`z'))
			putexcel `y'`q'=nformat("number_d2")
		}
		
		sum     error_ratio`v'_cuota_`x'  if reporut!=0 & /// 
		error_ratio`v'_cuota_`x'>-2 & error_ratio`v'_cuota_`x'<2 [fw=factor_egm]
			putexcel I`q'=(100*r(mean))
			putexcel I`q'=nformat("number_d2")
		
		corr cuota`v'_`x'_SBIF cuota_`x'_EFH if cuota`v'_`x'_SBIF>0 & /// 
		cuota_`x'_EFH>0 & cuota`v'_`x'_SBIF<. & cuota_`x'_EFH<.  [fw=factor_egm]
		putexcel J`q'=(100*r(rho))
		
		pwcorr cuota`v'_`x'_SBIF cuota_`x'_EFH if cuota`v'_`x'_SBIF>0 & /// 
		cuota_`x'_EFH>0 & cuota`v'_`x'_SBIF<. & cuota_`x'_EFH<., sig
		putexcel K`q'=("***")
	
		_pctile error_ratio`v'_mad_`x'  if reporut!=0 & /// 
		error_ratio`v'_mad_`x'>-2 & error_ratio`v'_mad_`x'<2  [fw=factor_egm], p(10 25 50 75 90)
		foreach y in D E F G H {
			local z=strpos("DEFGH","`y'")
			putexcel `y'`r'=(100*r(r`z'))
			putexcel `y'`r'=nformat("number_d2")
		}
		
		sum     error_ratio`v'_mad_`x'  if reporut!=0 & /// 
		error_ratio`v'_mad_`x'>-2 & error_ratio`v'_mad_`x'<2  [fw=factor_egm]
			putexcel I`r'=(100*r(mean))
			putexcel I`r'=nformat("number_d2")
		
		corr madurez`v'_`x'_SBIF madurez_`x'_EFH if madurez`v'_`x'_SBIF>0 & ///
		madurez_`x'_EFH>0 & madurez`v'_`x'_SBIF<. & madurez_`x'_EFH<.  /// 
		[fw=factor_egm]
		putexcel J`r'=(100*r(rho))
		
		pwcorr madurez`v'_`x'_SBIF madurez_`x'_EFH if madurez`v'_`x'_SBIF>0 & ///
		madurez_`x'_EFH>0 & madurez`v'_`x'_SBIF<. & madurez_`x'_EFH<., sig
		putexcel K`r'=("***")
	
		_pctile error_ratio`v'_mres_`x'  if reporut!=0 & /// 
		error_ratio`v'_mres_`x'>-2 & error_ratio`v'_mres_`x'<2  [fw=factor_egm], p(10 25 50 75 90)
		foreach y in D E F G H {
			local z=strpos("DEFGH","`y'")
			putexcel `y'`s'=(100*r(r`z'))
			putexcel `y'`s'=nformat("number_d2")
		}

		sum     error_ratio`v'_mres_`x'  if reporut!=0 & /// 
		error_ratio`v'_mres_`x'>-2 & error_ratio`v'_mres_`x'<2  [fw=factor_egm]
			putexcel I`s'=(100*r(mean))
			putexcel I`s'=nformat("number_d2")
		
		corr madurez`v'_`x'_res_SBIF madurez_`x'_res_EFH if madurez`v'_`x'_res_SBIF>0 ///
		& madurez_`x'_res_EFH>0 & madurez`v'_`x'_res_SBIF<. & madurez_`x'_res_EFH<. ///
		[fw=factor_egm]
		putexcel J`s'=(100*r(rho))
		
		pwcorr madurez`v'_`x'_res_SBIF madurez_`x'_res_EFH if madurez`v'_`x'_res_SBIF>0 ///
		& madurez_`x'_res_EFH>0 & madurez`v'_`x'_res_SBIF<. & madurez_`x'_res_EFH<., sig
		putexcel K`s'=("***")
	}


* Tabla 6 y 7 sin outliers

	putexcel B14=("Tabla `aux', sin outliers")
	putexcel B15=("Variable")
	putexcel C15=("Debt Category")
	putexcel D15=("P10")
	putexcel E15=("P25")
	putexcel F15=("P50")
	putexcel G15=("P75")
	putexcel H15=("P90")
	putexcel I15=("Mean")
	putexcel J15=("\rho")

	putexcel B16=("Loans amounts")
	putexcel C16=("Mortgages")
	putexcel C17=("Installment loans")
	putexcel C18=("Credit cards and credit lines")

	putexcel B19=("Debt service") 
	putexcel C19=("Mortgages") 
	putexcel C20=("Installment loans")  

	putexcel B21=("Total maturity") 
	putexcel C21=("Mortgages") 
	putexcel C22=("Installment loans")

	putexcel B23=("Residual maturity") 
	putexcel C23=("Mortgages") 
	putexcel C24=("Installment loans")

	forv k=1/3 {
		
		local x=word("$lista",`k')
		di "`x'"
		
		local p=`k'+15
		
		_pctile error_ratio`v'_`x'  if reporut!=0 & /// 
		ln_`x'_EFH!=. & ln_`x'_SBIF!=. & O_`x'==0  [fw=factor_egm], p(10 25 50 75 90)
		foreach y in D E F G H {
			local z=strpos("DEFGH","`y'")
			putexcel `y'`p'=(100*r(r`z'))
			putexcel `y'`p'=nformat("number_d2")
		}

		sum     error_ratio`v'_`x'  if reporut!=0 & /// 
		ln_`x'_EFH!=. & ln_`x'_SBIF!=. & O_`x'==0  [fw=factor_egm]
			putexcel I`p'=(100*r(mean))
			putexcel I`p'=nformat("number_d2")
		
		corr deuda_m_`x'_EFH deuda_m`v'_`x'_SBIF if deuda_m`v'_`x'_SBIF>0 & /// 
		deuda_m_`x'_EFH>0 & deuda_m`v'_`x'_SBIF<. & /// 
		deuda_m_`x'_EFH<. & O_`x'==0 [fw=factor_egm]
		putexcel J`p'=(100*r(rho))
		
		pwcorr deuda_m_`x'_EFH deuda_m`v'_`x'_SBIF if deuda_m`v'_`x'_SBIF>0 & /// 
		deuda_m_`x'_EFH>0 & deuda_m`v'_`x'_SBIF<. & /// 
		deuda_m_`x'_EFH<. & O_`x'==0, sig
		putexcel K`p'=("***")
	}
	forv k=1/2 {
		
		local x=word("$lista1",`k')
		di "`x'"
		
		local q=`k'+18
		local r=`k'+20
		local s=`k'+22
		
		_pctile error_ratio`v'_cuota_`x'  if reporut!=0 & /// 
		error_ratio`v'_cuota_`x'>-2 & error_ratio`v'_cuota_`x'<2 & O_`x'==0  [fw=factor_egm], p(10 25 50 75 90)
		foreach y in D E F G H {
			local z=strpos("DEFGH","`y'")
			putexcel `y'`q'=(100*r(r`z'))
			putexcel `y'`q'=nformat("number_d2")
		}
		
        sum     error_ratio`v'_cuota_`x'  if reporut!=0 & /// 
		error_ratio`v'_cuota_`x'>-2 & error_ratio`v'_cuota_`x'<2 & O_`x'==0  [fw=factor_egm]
			putexcel I`q'=(100*r(mean))
			putexcel I`q'=nformat("number_d2")
				
		corr cuota`v'_`x'_SBIF cuota_`x'_EFH if cuota`v'_`x'_SBIF>0 & /// 
		cuota_`x'_EFH>0 & cuota`v'_`x'_SBIF<. & cuota_`x'_EFH<. & O_`x'==0 [fw=factor_egm]
		putexcel J`q'=(100*r(rho))
		
		pwcorr cuota`v'_`x'_SBIF cuota_`x'_EFH if cuota`v'_`x'_SBIF>0 & /// 
		cuota_`x'_EFH>0 & cuota`v'_`x'_SBIF<. & cuota_`x'_EFH<. & O_`x'==0, sig
		putexcel K`q'=("***")
		
		_pctile error_ratio`v'_mad_`x'  if reporut!=0 & /// 
		error_ratio`v'_mad_`x'>-2 & error_ratio`v'_mad_`x'<2  & O_`x'==0 [fw=factor_egm], p(10 25 50 75 90)
		foreach y in D E F G H {
			local z=strpos("DEFGH","`y'")
			putexcel `y'`r'=(100*r(r`z'))
			putexcel `y'`r'=nformat("number_d2")
		}
 
        sum     error_ratio`v'_mad_`x'  if reporut!=0 & /// 
		error_ratio`v'_mad_`x'>-2 & error_ratio`v'_mad_`x'<2  & O_`x'==0 [fw=factor_egm]
			putexcel I`r'=(100*r(mean))
			putexcel I`r'=nformat("number_d2")
		
		
		corr madurez`v'_`x'_SBIF madurez_`x'_EFH if madurez`v'_`x'_SBIF>0 & ///
		madurez_`x'_EFH>0 & madurez`v'_`x'_SBIF<. & madurez_`x'_EFH<.  & O_`x'==0 /// 
		[fw=factor_egm]
		putexcel J`r'=(100*r(rho))
		
		pwcorr madurez`v'_`x'_SBIF madurez_`x'_EFH if madurez`v'_`x'_SBIF>0 & ///
		madurez_`x'_EFH>0 & madurez`v'_`x'_SBIF<. & madurez_`x'_EFH<.  & O_`x'==0, sig 
		putexcel K`r'=("***")
		
			_pctile error_ratio`v'_mres_`x'  if reporut!=0 & /// 
		error_ratio`v'_mres_`x'>-2 & error_ratio`v'_mres_`x'<2 & O_`x'==0 [fw=factor_egm], p(10 25 50 75 90)
		foreach y in D E F G H {
			local z=strpos("DEFGH","`y'")
			putexcel `y'`s'=(100*r(r`z'))
			putexcel `y'`s'=nformat("number_d2")
		}

        sum     error_ratio`v'_mres_`x'  if reporut!=0 & /// 
		error_ratio`v'_mres_`x'>-2 & error_ratio`v'_mres_`x'<2 & O_`x'==0 [fw=factor_egm]
			putexcel I`s'=(100*r(mean))
			putexcel I`s'=nformat("number_d2")
		
		corr madurez`v'_`x'_res_SBIF madurez_`x'_res_EFH if madurez`v'_`x'_res_SBIF>0 ///
		& madurez_`x'_res_EFH>0 & madurez`v'_`x'_res_SBIF<. & madurez_`x'_res_EFH<. ///
		& O_`x'==0 [fw=factor_egm]
		putexcel J`s'=(100*r(rho))
		
		pwcorr madurez`v'_`x'_res_SBIF madurez_`x'_res_EFH if madurez`v'_`x'_res_SBIF>0 ///
		& madurez_`x'_res_EFH>0 & madurez`v'_`x'_res_SBIF<. & madurez_`x'_res_EFH<. ///
		& O_`x'==0, sig
		putexcel K`s'=("***")
	}
}



/*

* Se genera base en formato long para traspasar variable de error de reporte redondeado
* y algunas variables adicionales a base de regresiones

* Variables a mantener en la base
keep folio id yearEFH a1_nothighest_income error_ratio0_hipotecario error_ratio0R_hipotecario error_ratio0_prestamo ///
error_ratio0R_prestamo error_ratio0_tarjeta error_ratio0R_tarjeta error_ratio0_linea error_ratio0R_linea ///
O_hipotecario O_prestamo O_tarjeta O_linea reporut ln_*_*EFH ln_*_*SBIF

drop ln_TL_*

order folio yearEFH a1_nothighest_income error_ratio0_* error_ratio0R_* O_* ln_*

reshape long error_ratio0_@ error_ratio0R_@ O_@ ln_@_EFH ln_@_SBIF, i(id) j(tipo) string
egen tipo_deuda=group(tipo), lab

* Etiquetado de variables

rename error_ratio*_ error_ratio*
rename ln__* ln_*
rename O_ outlier
rename error_ratio0 error_ratio02
lab var error_ratio02 "error relativo"
lab var error_ratio0R "error relativo con redondeo"
lab var outlier "indicador de outlier"
lab var ln_EFH "logaritmo monto inicial EFH"
lab var ln_SBIF "logaritmo monto inicial SBIF"


save "$path\dta\informacion_deudas.dta", replace
