version 14.2

clear all
cls
set more off

global path "C:\Users\felma.000\Dropbox\Cruce\Paper descriptivo\Stata"
global pathdat "$path\efh_dta"
global pathtab "$path\tablas"

********************************************************************************
* Cálculo de INR en EFH
********************************************************************************

putexcel set "$pathtab\inr_rates.xlsx", modify

putexcel b2="Variable"
putexcel c2="EFH 2011"
putexcel d2="EFH 2014"
putexcel e2="EFH 2017"

putexcel b3="Morgage - main housing"
putexcel b4="Initial amount"
putexcel b5="Debt burden"
putexcel b6="Consumer debt"
putexcel b7="Initial debt"
putexcel b8="Bank card"
putexcel b9="Bank loans"
putexcel b10="CCAF & cooperatives"
putexcel b11="debt burden"
putexcel b12="Bank card"
putexcel b13="Bank loans"
putexcel b14="CCAF & cooperatives"
putexcel b15="Labor income"
putexcel b16="Financial assets - stock"

*-> EFh 2011

use "$pathdat\EFH_11_allvars.dta"

*  Missing ingreso
g miss_ing=(c27==98 | c27==99) if c27!=.
sum miss_ing
putexcel c15=(`r(mean)'), nformat(percent_d2)
* Missing monto inicial hipotecario
g miss_hip=(e19_t==98 | e19_t==99) if e19_p!=.
sum miss_hip
putexcel c4=(`r(mean)'), nformat(percent_d2)
* Missing carga hipotecaria
g miss_hb=(e27_t==98 | e27_t==99) if e27!=.
sum miss_hb
putexcel c5=(`r(mean)'), nformat(percent_d2)
* Missing deuda consumo

preserve
keep if ord==1
keep folio ord f10*t1* f11*t1* f15*t5* f15*t7* f21*t5* f21*t7*

reshape long f10_t1d f10_t_t1d f11_t1d f15_t5d f15_t_t5d f15_t7d f15_t_t7d ///
f21_t5d f21_t7d, i(folio) j(n_d)

rename *d *

* Montos iniciales
g miss_card=(f10_t_t1==98 | f10_t_t1==99) if f10_t1!=.
g miss_loan=(f15_t_t5==98 | f15_t_t5==99) if f15_t5!=.
g miss_caff=(f15_t_t7==98 | f15_t_t7==99) if f15_t7!=.

tabstat miss_card miss_loan miss_caff, save c(s)
mat a=r(StatTotal)
putexcel c8=matrix(a'), nformat(percent_d2)

* Cargas
g miss_bcard=(f11_t1==98 | f11_t1==99) if f11_t1!=.
g miss_bloan=(f21_t5==98 | f21_t5==99) if f21_t5!=.
g miss_bcaff=(f21_t7==98 | f21_t7==99) if f21_t7!=.

tabstat miss_bcard miss_bloan miss_bcaff, save c(s)
mat a=r(StatTotal)
putexcel c12=matrix(a'), nformat(percent_d2)

restore

* Missing activos financieros
preserve
keep if ord==1
keep folio ord h2_* h1_*

reshape long h1_@ h2_@ h2_@_t, i(folio) j(act)
rename h2_ h2
rename h2__t h2_t

g miss_act=(h2_t==98 | h2_t==99) if h1_==1
sum miss_act
putexcel c16=(`r(mean)'), nformat(percent_d2)

restore

*-> EFH 2014
clear
use "$pathdat\EFH_14_allvars.dta"

* Missing monto inicial hipotecario
g miss_hip=(e19t==98 | e19t==99) if e19_pesos!=.
sum miss_hip
putexcel d4=(`r(mean)'), nformat(percent_d2)

* Missing carga hipotecaria
g miss_bhip=(e35t==98 | e35t==99) if e35!=.
sum miss_bhip
putexcel d5=(`r(mean)'), nformat(percent_d2)

* Missing deuda de consumo
preserve
keep if ord==1
keep folio f7*t1* f9*t1* f15*t5* f15*t6* f24*t5* f24*t6*

reshape long f7_t1d f7t_t1d f9_t1d f9t_t1d f15_t5d f15t_t5d f15_t6d f15t_t6d ///
f24_t5d f24t_t5d f24_t6d f24t_t6d, i(folio) j(n_d)

rename *d *
* Montos iniciales
g miss_card=(f7t_t1==98 | f7t_t1==99) if f7_t1!=.
g miss_loan=(f15t_t5==98 | f15t_t5==99) if f15_t5!=.
g miss_caff=(f15t_t6==98 | f15t_t6==99) if f15_t6!=.

tabstat miss_card miss_loan miss_caff, save c(s)
mat a=r(StatTotal)
putexcel d8=matrix(a'), nformat(percent_d2)

* Carga
g miss_bcard=(f9t_t1==98 | f9t_t1==99) if f9_t1!=.
g miss_bloan=(f24t_t5==98 | f24t_t5==99) if f24_t5!=.
g miss_bcaff=(f24t_t6==98 | f24t_t6==99) if f24_t6!=.

tabstat miss_bcard miss_bloan miss_bcaff, save c(s)
mat a=r(StatTotal)
putexcel d12=matrix(a'), nformat(percent_d2)
restore

* Missing activos financieros
preserve
keep if ord==1
keep folio i2*

reshape long i2_ i2t_ , i(folio) j(act)
rename *_ *

g miss_act=(i2t==98 | i2t==99) if i2!=.
sum miss_act
putexcel d16=(`r(mean)'), nformat(percent_d2)
restore

* Missing ingreso
g miss_ing=(j1t==98 | j1t==99) if j1!=.
sum miss_ing
putexcel d15=(`r(mean)'), nformat(percent_d2)

*-> EFH 2017
clear
use "$pathdat\EFH_17_allvars.dta"

* Missing monto inicial hipotecario
g miss_hip=(e15t==98 | e15t==99) if e15_pesos!=.
sum miss_hip
putexcel e4=(`r(mean)'), nformat(percent_d2)

* Missing carga hipotecaria
g miss_bhip=(e28t==98 | e28t==99) if e28!=.
sum miss_bhip
putexcel e5=(`r(mean)'), nformat(percent_d2)

* Missing deuda de consumo
preserve
keep if ord==1
keep folio f7*t1* f10*t1* f16*t5* f16*t6* f23*t5* f23*t6*

reshape long f7_t1d f7t_t1d f10_t1d f10t_t1d f16_t5d f16t_t5d f16_t6d f16t_t6d ///
f23_t5d f23t_t5d f23_t6d f23t_t6d, i(folio) j(n_d)

rename *d *
* Montos iniciales
g miss_card=(f7t_t1==98 | f7t_t1==99) if f7_t1!=.
g miss_loan=(f16t_t5==98 | f16t_t5==99) if f16_t5!=.
g miss_caff=(f16t_t6==98 | f16t_t6==99) if f16_t6!=.

tabstat miss_card miss_loan miss_caff, save c(s)
mat a=r(StatTotal)
putexcel e8=matrix(a'), nformat(percent_d2)

* Carga
g miss_bcard=(f10t_t1==98 | f10t_t1==99) if f10_t1!=.
g miss_bloan=(f23t_t5==98 | f23t_t5==99) if f23_t5!=.
g miss_bcaff=(f23t_t6==98 | f23t_t6==99) if f23_t6!=.

tabstat miss_bcard miss_bloan miss_bcaff, save c(s)
mat a=r(StatTotal)
putexcel e12=matrix(a'), nformat(percent_d2)
restore

* Missing activos financieros
preserve
keep if ord==1
keep folio i2*

reshape long i2_ i2t_ , i(folio) j(act)
rename *_ *

g miss_act=(i2t==98 | i2t==99) if i2!=.
sum miss_act
putexcel e16=(`r(mean)'), nformat(percent_d2)
restore

* Missing ingreso
g miss_ing=(j1t==98 | j1t==99) if j1!=.
sum miss_ing
putexcel e15=(`r(mean)'), nformat(percent_d2)
