********************************************************
* Rounding variables and INR, EFH 2011
********************************************************

set more off
clear
global path "C:\Users\pedro\Dropbox"
use "$path\Cruce\Paper descriptivo\Stata\efh_dta\EFH_11_allvars.dta", clear
keep if ord==1


*****************
* Re-naming debts
*****************
* Who holds the debt
rename (f3_t4d* f3_t5d* f3_t6d* f3_t7d*) (f3_t5d* f3_t4d* f3_t7d* f3_t6d*)

* Consumer debts: initial amount
rename (f15_t4d* f15_t5d* f15_t6d* f15_t7d*) (f15_t5d* f15_t4d* f15_t7d* f15_t6d*)
rename (f15_t_t4d* f15_t_t5d* f15_t_t6d* f15_t_t7d*) (f15_t_t5d* f15_t_t4d* f15_t_t7d* f15_t_t6d*)
forv i=1/3 {
forv j=1/4 {
capture: recode f10_t`i'd`j' .=0
capture: recode f10_t`i'd`j' 99=. 98=.
capture: gen m_td`i'_`j'=f10_t`i'd`j'
capture: replace m_td`i'_`j'=f10_t_t`i'd`j' if f10_t_t`i'd`j'>0 & f10_t_t`i'd`j'<98

}
}
forv i=4/7 {
forv j=1/3 {
recode f15_t`i'd`j' .=0
recode f15_t`i'd`j' 99=. 98=.
gen     m_td`i'_`j'=f15_t`i'd`j'
replace m_td`i'_`j'=f15_t_t`i'd`j' if f15_t_t`i'd`j'>0 & f15_t_t`i'd`j'<98
}
}
forv j=1/3 {
recode f24_t8d`j' .=0
recode f24_t8d`j' 99=. 98=.
gen m_td8_`j'=f24_t8d`j'
replace m_td8_`j'=f24_t_t8d`j' if f24_t_t8d`j'>0 & f24_t_t8d`j'<98
}

* Consumer debts: Financial burden
rename cf_1_td*              cf_td*_1 
rename cf_2_td*              cf_td*_2 
rename cf_3_td*              cf_td*_3 
rename cf_4_td*              cf_td*_4 
rename (cf_td4_* cf_td5_* cf_td6_* cf_td7_*) (cf_td5_* cf_td4_* cf_td7_* cf_td6_*) 
rename (f21_t4d* f21_t5d* f21_t6d* f21_t7d*) (f21_t5d* f21_t4d* f21_t7d* f21_t6d*)
drop cf_td9 cf_td10 cf_td11 cf_td12 cf_td13

* Mortgage burden 
rename  div_m                div_chvp 
gen div_ccvp=0
gen cf_td9_1= div_chvp
gen cf_td5_4= div_ccvp
* otp
rename (div_m1 div_m2 div_m3) (div_chotp_1 div_chotp_2 div_chotp_3) 
drop  div_m_otp
gen cf_td9_2= div_chotp_1
gen cf_td9_3= div_chotp_2
gen cf_td9_4= div_chotp_3
* cc
forv i=1/3 {
local j=`i'+4
gen div_ccotp_`i'=0 
gen cf_td5_`j'= div_ccotp_`i'
}

* Mortgage initial debt
g e19=e19_p if e14<=3        
replace e19=e19_uf if (e19_p==98 | e19_p==99) & (e19_uf!=98 & e19_uf!=99 & e19_uf!=.) & e14<=3
recode e19 . = 0
replace e19=e19_t if e19_t>0 & e19_t<98
replace e19=. if (e19_p==0 | e19_uf==0) & e14<=3
recode e19 99=. 98=.
gen m_td9_1=e19

* Initial debt CC
g e21=e21_p if e20==1             
replace e21=e21_uf if (e21_p==98 | e21_p==99) & (e21_uf!=8 & e21_uf!=9 & e21_uf!=.) & e20==1
recode e21 . = 0
replace e21=e21_t if e21_t>0 & e21_t<98
replace e21=. if (e21_p==0 | e21_uf==0) & e20==1
recode e21 99=. 98=.
gen m_td5_4=e21

* Initial debt CH otp
forv i=1/3 {
local j=`i'+1
g e48_`i'=e48_h_p_`i' if e47_h_`i'==1
replace e48_`i'=e48_h_uf_`i'   if   (e48_h_p_`i'==98 | e48_h_p_`i'==99) & (e48_h_uf_`i'!=8 & e48_h_uf_`i'!=9 & e48_h_uf_`i'!=.) & e47_h_`i'==1
recode  e48_`i' .=0
replace  e48_`i'=e48_h_t_`i' if e48_h_t_`i'>0 & e48_h_t_`i'<98
replace e48_`i'=. if (e48_h_p_`i'==0 | e48_h_uf_`i'==0) & e47_h_`i'==1
recode e48_`i' 99=. 98=.
gen m_td9_`j'=e48_`i'
}

* Valor inicial CC otp
forv i=1/3 {
local j=`i'+4
g e76_`i'=e48_c_p_`i' if e47_c_`i'==1
replace e76_`i'=e48_c_uf_`i'   if   (e48_c_p_`i'==98 | e48_c_p_`i'==99) & (e48_c_uf_`i'!=8 & e48_c_uf_`i'!=9 & e48_c_uf_`i'!=.) & e47_c_`i'==1
recode  e76_`i' .=0
replace e76_`i'=e48_c_t_`i' if e48_c_t_`i'>0 & e48_c_t_`i'<98
replace e76_`i'=. if (e48_c_p_`i'==0 | e48_c_uf_`i'==0) & e47_c_`i'==1
recode e76_`i' 99=. 98=.
gen m_td5_`j'=e76_`i'
}

de m_td* cf_td*


********************************************
* Member of the household who holds the debt
********************************************
forv k=1/8 {
forv m=1/4 {
capture: rename f3_t`k'd`m' f3_td`k'_`m'
}
}
foreach k in 5 9 {
forv m=1/7 {
capture: gen f3_td`k'_`m'=1
}
}
 
*************************************
* Variables construction for rounding
*************************************
* Consumption amounts
forv m=1(1)4 {
	forv k=1(1)3 {
	capture: gen mo_td`k'_`m'=f10_t`k'd`m' if f10_t`k'd`m'>0                 & f3_td`k'_`m'==1       // original amount
	capture: gen t_mo_td`k'_`m'=(f10_t_t`k'd`m'>0 & f10_t_t`k'd`m'<98        & f3_td`k'_`m'==1) if m_td`k'_`m'!=0     // original amount answer in brackets
	*******
	capture: gen ds_td`k'_`m'=f11_t`k'd`m' if f11_t`k'd`m'>0 & f11_t`k'd`m'!=98 & f11_t`k'd`m'!=99    & f3_td`k'_`m'==1       // debt service
	capture: gen t_ds_td`k'_`m'=0   if  f11_t`k'd`m'!=-100 & cf_td`k'_`m'!=0  // debt service answer in brackets
	}
	forv k=4/7 {
	capture: gen mo_td`k'_`m'=f15_t`k'd`m' if f15_t`k'd`m'>0             & f3_td`k'_`m'==1       // original amount
	capture: gen t_mo_td`k'_`m'=(f15_t_t`k'd`m'>0 & f15_t_t`k'd`m'<98      & f3_td`k'_`m'==1)  if m_td`k'_`m'!=0     // original amount answer in brackets
	*******
	capture: gen ds_td`k'_`m'=f21_t`k'd`m' if f21_t`k'd`m'>0 & f21_t`k'd`m'!=98 & f21_t`k'd`m'!=99     & f3_td`k'_`m'==1       // debt service
	capture: gen t_ds_td`k'_`m'=0  if  f21_t`k'd`m'!=-100  & cf_td`k'_`m'!=0                                                         // debt service answer in brackets
	}
	forv k=8/8 {
	capture: gen mo_td`k'_`m'=f24_t`k'd`m' if f24_t`k'd`m'>0             & f3_td`k'_`m'==1       // original amount
	capture: gen t_mo_td`k'_`m'=(f24_t_t`k'd`m'>0 & f24_t_t`k'd`m'<98      & f3_td`k'_`m'==1)  if m_td`k'_`m'!=0       // original amount answer in brackets
	*******
	capture: gen ds_td`k'_`m'=f21_t`k'd`m' if f21_t`k'd`m'>0             & f3_td`k'_`m'==1       // debt service ************************
	capture: gen t_ds_td`k'_`m'=0  if  f21_t`k'd`m'!=-100 & cf_td`k'_`m'!=0    // debt service answer in brackets
	}
}
de mo_* ds_* t_mo_* t_ds_*
*br f10_t1d1 f10_t_t1d1 mo_td1_1  f11_t1d1 ds_td1_1  f15_t5d1 f15_t_t5d1 mo_td5_1  f21_t5d1 ds_td5_1  f24_t8d1 f24_t_t8d1 mo_td8_1

* Mortgage amounts
* Initial amount CH VP
gen    mo_td9_1  =e19 if (e19_t<1 | e19_t>97)           
gen     t_mo_td9_1=(e19_t>0 & e19_t<98)  if  e14<=1 

* Initial amount CH OTP
forv i=1/3 {
local j=`i'+1
gen     mo_td9_`j'=e48_`i' if (e48_h_t_`i'<1 | e48_h_t_`i'>97)
gen     t_mo_td9_`j'=(e48_h_t_`i'>0 & e48_h_t_`i'<98) if  e47_h_`i'==1
}

* Initial amount CC VP
gen    mo_td5_4=e21 if (e21_t<1 | e21_t>97)   
gen  t_mo_td5_4=(e21_t>0 & e21_t<98) if         e20==1
* Initial amount CC OTP
forv i=1/3 {
local j=`i'+4
gen    mo_td5_`j'=e76_`i' if (e48_c_t_`i'<1 | e48_c_t_`i'>97)
gen   t_mo_td5_`j'=(e48_c_t_`i'>0 & e48_c_t_`i'<98) if  e47_c_`i'==1
}
*********
* Debt service
foreach i in e27 e54_1 e54_2 e54_3 {
replace `i'=. if `i'==98 | `i'==99
}
* CH VP and OTP
gen   ds_td9_1  =e27 if e27>0 &  c_vp==1              
gen   t_ds_td9_1=(e27_t>0 & e27_t<98)     // answer in brackets
replace t_ds_td9_1=0 if c_vp==1
forv i=1/3 {
local j=`i'+1
gen   ds_td9_`j'  =e54_`i' if e54_`i'>0 &  chip_tp`i'==1                     
gen   t_ds_td9_`j'=(e54_t_`i'>0 & e54_t_`i'<98          )     // answer in brackets
replace   t_ds_td9_`j'=0 if chip_tp`i'==1
}
* CC VP and OTP
gen   ds_td5_4  =.
gen   t_ds_td5_4=0             // answer in brackets
forv i=1/3 {
local j=`i'+4
gen   ds_td5_`j'  =.     
gen   t_ds_td5_`j'=.    // answer in brackets
}
de mo_td5* ds_td5* t_mo_td5* t_ds_td5*    mo_td9* ds_td9* t_mo_td9* t_ds_td9*

******************
* Global variables
******************
foreach u in mo_td ds_td t_mo_td t_ds_td m_td cf_td {
global `u'1 "`u'1_1 `u'1_2 `u'1_3"
global `u'2 "`u'2_1 `u'2_2 `u'2_3"
global `u'3 "`u'3_1 `u'3_2 `u'3_3 `u'3_4"
global `u'4 "`u'4_1 `u'4_2 `u'4_3"
global `u'5 "`u'5_1 `u'5_2 `u'5_3 `u'5_4 `u'5_5 `u'5_6 `u'5_7"
global `u'6 "`u'6_1 `u'6_2 `u'6_3"
global `u'7 "`u'7_1 `u'7_2 `u'7_3"
global `u'8 "`u'8_1 `u'8_2 `u'8_3"
global `u'9 "`u'9_1 `u'9_2 `u'9_3 `u'9_4"
****
global `u' "$`u'1 $`u'2 $`u'3 $`u'4 $`u'5 $`u'6 $`u'7 $`u'8 $`u'9"
}


* Assets and incomes variables
* Main oc. income
drop yoprinm
g yoprinm = c27
recode yoprinm .=0
recode yoprinm 98=. 99=. 
replace yoprinm=. if c27==0  
* Secodary oc. income
drop yosec
gen yosec = c32     
recode yosec .=0      
recode yosec 98=. 99=. 
* rename
drop e8
rename vp e8
*************************
global yoprinmh          "yoprinm"  
global yoprinh           "c29_1 c29_2 c29_3 c29_5"  
global yosech            "yosec"  
global ypenh             "d1m_1_ d1m_2_ d1m_3_ d3m_1_ d3m_2_ d3m_3_ d3m_4_ d3m_5_"  
global ysubh             "d2m_1_ d2m_2_ d2m_3_ d2m_4_ d2m_5_ d2m_6_ d2m_7_"
global yotroh            "d5m_1_ d5m_2_ d5m_3_ d5m_4_ d5m_5_ d5m_6_ d5m_7_ d5m_8_ d6m_1_ d6m_2_ d6m_3_ d6m_4_ d6m_6_ d6m_5_ d6m_7_"
*---
global act_vp            "e8"
global act_otp           "OTP_1 OTP_2 OTP_3"
global act_vehicyotros   "e65_1 e65_2 e65_3 e65_4 e65_5 e65_6"
global act_var           "h2_1 h2_2 h2_6 h2_7"
global act_fijo          "h2_3 h2_4 h2_5"

* Edición a variables de tramos
rename e36* OTP*
rename (OTP_t_1 OTP_t_2 OTP_t_3) (OTP_1_t OTP_2_t OTP_3_t)


******************************************
* Rounding (Gideon, Hsu and McFall (2015))
******************************************
foreach u in $mo_td $ds_td        $yoprinmh $yoprinh $yosech $ypenh $ysubh $yotroh  $act_vp $act_otp $act_vehicyotros $act_var $act_fijo  {
replace `u'=int(`u')
*replace `u'=int(`u'/1000)
tostring `u' ,replace force
gen large=length(`u')
gen trailing=large-length(reverse(substr(reverse(`u'), indexnot(reverse(`u'), "0"),.)))
destring `u' ,replace
gen ro_`u'=(trailing)/(large-1)       // rounding meassure
drop large trailing
}
foreach u in  $yoprinmh $yoprinh $yosech $ypenh $ysubh $yotroh  $act_vp $act_otp $act_vehicyotros $act_var $act_fijo {
capture: replace ro_`u'=. if `u'_t<98 
}
rename (ro_mo_td* ro_ds_td* t_mo_td* t_ds_td*) (ro_m_td* ro_cf_td* t_m_td* t_cf_td*) // convenient renaming

* Agregating rounding variables
foreach h in yoprinmh yoprinh yosech ypenh ysubh yotroh  act_vp act_otp act_vehicyotros act_var act_fijo {
global ro_`h' ""
foreach e in $`h' {
global ro_`h' ${ro_`h'} ro_`e'
}
egen ro_`h'  =rmean(${ro_`h'})
}
forv i=1/9 {
egen ro_m_td`i'  =rmax(ro_m_td`i'_*)
egen ro_cf_td`i'=rmax(ro_cf_td`i'_*)
egen t_cf_td`i'=rmax(t_cf_td`i'_*)
egen t_m_td`i'=rmax(t_m_td`i'_*)
} 
egen ro_cf_td_no5_9 =rmean(ro_cf_td1_* ro_cf_td2_* ro_cf_td3_* ro_cf_td4_* ro_cf_td6_* ro_cf_td7_* ro_cf_td8_*)
egen ro_m_td_no5_9  =rmean(ro_m_td1_* ro_m_td2_* ro_m_td3_* ro_m_td4_* ro_m_td6_* ro_m_td7_* ro_m_td8_*)

* 	Stats
tabstat ro_m_td* ro_cf_td* ro_yoprinmh ro_yoprinh ro_yosech ro_ypenh ro_ysubh ro_yotroh ro_act_vp ro_act_otp ro_act_vehicyotros ro_act_var ro_act_fijo  ,s(p10 p50 mean n)  columns(statistics)


/*
* Rounding in agregate variables
foreach y in ro {
egen `y'_ing   =rmean(`y'_yoprinmh `y'_yoprinh `y'_yosech `y'_ypenh `y'_ysubh `y'_yotroh)
}
*/

********
* INR
********
* INR dummies
forv i=1/9 {
	forv j=1/7 {
	capture: gen inr_m_td`i'_`j'=(m_td`i'_`j'==.)   if m_td`i'_`j'!=0  & f3_td`i'_`j'==1 
	capture: gen inr_cf_td`i'_`j'=(cf_td`i'_`j'==.) if cf_td`i'_`j'!=0 & f3_td`i'_`j'==1 
	}
}

* Stats
tabstat inr_m_td* ,s(mean n)  columns(statistics)
tabstat inr_cf_td* ,s(mean n)  columns(statistics)
forv i=1/9 {
	forv j=1/3 {
	tab ro_m_td`i'_`j' t_m_td`i'_`j' 
	}
}
tab ro_m_td5_4 t_m_td5_4
tab ro_m_td5_5 t_m_td5_5
tab ro_m_td5_6 t_m_td5_6
tab ro_m_td5_7 t_m_td5_7

********
* Saving
********
gen yearEFH=2011
order folio yearEFH
keep folio yearEFH cf_td9* cf_td5* m_td5* m_td9* ro_m_td* ro_cf_td* t_m_td* t_cf_td* ro_yoprinmh ro_yoprinh ro_yosech ro_ypenh ro_ysubh ro_yotroh ro_act_vp ro_act_otp ro_act_vehicyotros ro_act_var ro_act_fijo
save "$path\Cruce\Paper descriptivo\Stata\dta\Rouding_INR\ro_2011.dta" ,replace
