********************************************************
* Rounding 
********************************************************

set more off
clear
global path "C:\Users\pedro\Dropbox"
use  "$path\Cruce\Paper descriptivo\Stata\dta\Rouding_INR\ro_2011.dta"  , clear
append using "$path\Cruce\Paper descriptivo\Stata\dta\Rouding_INR\ro_2014.dta"
append using "$path\Cruce\Paper descriptivo\Stata\dta\Rouding_INR\ro_2017.dta"
rename yearEFH year_efh

* Merging with individuals who declare ID
merge 1:1 folio year_efh using "$path\Cruce\Paper descriptivo\Stata\dta\reporta_ruts_2011_2014_2017.dta"
tab _merge

* Globals
global m_td     "m_td1 m_td2 m_td3 m_td4 m_td5 m_td6 m_td7 m_td8 m_td9"
global cf_td    "cf_td1 cf_td2 cf_td3 cf_td4 cf_td5 cf_td6 cf_td7 cf_td8 cf_td9"
global incomes  "yoprinmh yoprinh yosech ypenh ysubh yotroh"
global assets  "act_vp act_otp act_vehicyotros act_var act_fijo"

* Number of credits per type (only credits with rounding meassure
forv i=1/9 {
foreach u in m_td cf_td {
egen count_`u'`i'  =rownonmiss(ro_`u'`i'_*)
} 
}
foreach u in $incomes $assets {
gen count_`u' =1
}

* Stats
forv i=1/9 {
drop ro_m_td`i'_* ro_cf_td`i'_*
}
tabstat ro_m_td* ro_cf_td* ro_yoprinmh ro_yoprinh ro_yosech ro_ypenh ro_ysubh ro_yotroh ro_act_vp ro_act_otp ro_act_vehicyotros ro_act_var ro_act_fijo if _merge==3  ,s(p1 p10 p50 mean n)  columns(statistics)
tabstat ro_m_td* ro_cf_td* ro_yoprinmh ro_yoprinh ro_yosech ro_ypenh ro_ysubh ro_yotroh ro_act_vp ro_act_otp ro_act_vehicyotros ro_act_var ro_act_fijo  ,s(p1 p10 p50 mean n)  columns(statistics)

* Ponderated matrix
matrix M=J(29,5,0)
local h=1
foreach i in $m_td $cf_td $incomes $assets {
tabstat ro_`i' [fw=count_`i'] if _merge==3 ,s(p1 p10 p50 mean n)  columns(statistics) save
matrix M[`h',1]==r(StatTotal)' 
local h=`h'+1
}
mat rownames M = $m_td $cf_td $incomes $assets 
mat colnames M = p1 p10 p50 mean n 	 
matrix list M


* T-test cf vs m
matrix A=J(9,4,0)
local h=1
forv i=1/9 {
ttest ro_m_td`i'=ro_cf_td`i' if _merge==3 ,unpaired  unequal
matrix A[`h',1]==r(mu_1)
matrix A[`h',2]==r(mu_2)
matrix A[`h',3]==r(t)
matrix A[`h',4]==r(p)
local h=`h'+1
}
mat rownames A = td1 td2 td3 td4 td5 td6 td7 td8 td9
mat colnames A = mean_m mean_cf t_value p_value
matrix list A



