**********************************************************************************
* CREACION BASE LONG
* Autor: PR 
**********************************************************************************

* Pasos iniciales
clear all
set more off
global path "C:\Users\pedro\Dropbox\Cruce\Paper descriptivo\Stata\dta"

* Abrimos la base de madeira (con folios originales efh)
use "$path\analysis11_14_17_vfix.dta", clear

* Dejamos variables relevantes de la base madeira
keep folio yearEFH reporut_2017 /*
*/ error_ratio0_hipotecario error_ratio0_prestamo error_ratio0_tarjeta error_ratio0_linea /*
*/ a1_nothighest_income nr_y_max a1_nothighest_age   /*
*/ deuda_hipotecario_EFH deuda_prestamo_EFH deuda_tarjeta_EFH deuda_linea_EFH /*   
*/ deuda_hipotecario_SBIF deuda_prestamo_SBIF deuda_tarjeta_SBIF deuda_linea_SBIF /*
*/ error_mortgageEFH_notSBIF error_prestamoEFH_notSBIF

*Rename conveniente
rename (error_mortgageEFH_notSBIF error_prestamoEFH_notSBIF) (error_EFH_notSBIF_hipotecario error_EFH_notSBIF_prestamo)

* Hacemos reshape
reshape long error_ratio0_ error_EFH_notSBIF_, i( folio yearEFH ) j(tipo_deud) s
rename error_ratio0_ error_ratio0
rename error_EFH_notSBIF_ error_EFH_notSBIF
encode tipo_deud ,gen(tipo_deuda)

* Pegamos base con variables demográficas EFH 
merge m:1 folio yearEFH using "$path\variables_EFH_2011_2014_2017.dta" ,replace update
drop if _merge==2 

* Edición final y guardamos
drop _merge tipo_deud
order folio yearEFH tipo_deuda error_ratio
save "$path\analysis11_14_17_vfix_long.dta", replace 

*----------------------------------------------------------------------------------------------------- 
* Ejemplo de regresión
g E_error_ratio0 = 100*abs(error_ratio0) if error_ratio0>-2 & error_ratio0<2  //make them in %
reg E_error_ratio0   d_nomax_ing d_nomax_edad i.tipo_deuda [pw=factor_egm]
*----
*----
logit error_EFH_notSBIF d_nomax_ing d_nomax_edad i.tipo_deuda [pw=factor_egm]
*-----------------------------------------------------------------------------------------------------

* Variables CM vs PR
tab a1_nothighest_income d_nomax_ing
tab a1_nothighest_age d_nomax_edad
