version 14.2
clear
drop _all
cls

global path "C:\Users\felma.000\Dropbox\Cruce"
global pathdat "$path\Paper descriptivo\Stata\dta"
global dat "$path\Paper_use_docs\2019\Stata\dta"

* Se abre base de cruce EFH-SBIF a nivel de deuda. Base construída para paper de
* uso de documentos.

use "$dat\base_rut_efh_sbif_11_14_17.dta"

* Se analiza redondep para mon_d_x_i y stock_d_x_i con x=efh,sbif; i=1,2,5,9

* Se ajusta nombre de variables efh
foreach k in 1 2 5 9 {
	rename mon_d_`k' mon_d_efh_`k'
	rename stock_d_`k' stock_d_efh_`k'
	g dif_mon_`k'=mon_d_sbif_`k'-mon_d_efh_`k'
}


*-> Indicadores de redondeo basados en desviación porcentual de dato SBIF

forv k=5(5)20 {
	local p=`k'/100
	foreach m in 1 2 5 9 {
	g u_`k'_`m'=(1+`p')*mon_d_sbif_`m' if mon_d_sbif_`m'>0
	g l_`k'_`m'=(1-`p')*mon_d_sbif_`m' if mon_d_sbif_`m'>0
	g ind_`k'_`m'=(mon_d_efh_`m'>=l_`k'_`m' & mon_d_efh_`m'<=u_`k'_`m') if mon_d_efh_`m'>0 & mon_d_sbif_`m'>0
	
	lab var ind_`k'_`m' "indicador de redondeo para un desvío de `k'% en deuda `m'"
	lab def ind_`k'_`m' 0 "fuera del `k'%" 1 "dentro del `k'%"
	lab val ind_`k'_`m' ind_`k'_`m'
	}
}

*-> Algunos análisis preliminares

tabstat mon_d_*_5 dif_mon_5 if year_efh==2017 & mon_d_efh_5>0 & mon_d_sbif_5>0, by(ind_20_5) f(%12.0g) stat(mean n)
tabstat mon_d_*_9 dif_mon_9 if year_efh==2017 & mon_d_efh_9>0 & mon_d_sbif_9>0, by(ind_20_9) f(%12.0g) stat(mean n)


preserve
	keep folio year_efh ind* n_deudas_efh_*
	save "$pathdat\indicadores_redondeo.dta", replace
restore
